<?php
/**
The MIT License

Copyright © 2021-2022 Martin Härtlein

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
**/
ob_start();
if(!isset($_SESSION['API_TOKENS'])){
	echo 'NO API TOKENS SET YET!';
	exit();
}
if(!(isset($_SESSION['SECRET_KEY']) && $_SESSION['SECRET_KEY']===SECRET_KEY)){
	echo 'Tell me your secret!';
	exit();
}
// POST API ///////////////////////////////////////////////////////////////////////////
$postjson=file_get_contents('php://input'); 
$postobj=json2obj($postjson);
if($postobj!==NULL){
	//  api token checks
	if(!isset($postobj['apitoken'])){
		echo 'need apitoken in postobj';
		exit();
	}
	if(!isset($_SESSION['API_TOKENS'][$postobj['apitoken']])){
		echo 'incorrect apitoken!';
		exit();
	}
    // callid and cmdobj
    if(isset($postobj['callid']) && isset($postobj['cmdobjarr'])){
        $mainechobj=json2obj(obj2json($postobj)); // make copy
        $cmdobjarr=$postobj['cmdobjarr'];
        $echobjarr=[];
        // loop cmdobjarr
        foreach($cmdobjarr as $cmdobj){
            $echobj=[];
            $echobj['cmdobj']=json2obj(obj2json($cmdobj));
            // get component dom by modulname and function name
            if(isset($cmdobj['api-func-component']) && isset($cmdobj['api-func-name']) && isset($cmdobj['api-target-id'])){
                // default insert cmd
                if(!isset($cmdobj['api-insert-cmd'])){
                    $echobj['cmdobj']['api-insert-cmd']='replaceinner';
                }
                // insert domstr
                if(isset($cmdobj['api-func-parobj'])){
                    $echobj['cmdobj']['api-insert-domstr']=$COMPONENTS[$cmdobj['api-func-component']][$cmdobj['api-func-name']]($cmdobj['api-func-parobj']);
                }else{
                    $echobj['cmdobj']['api-insert-domstr']=$COMPONENTS[$cmdobj['api-func-component']][$cmdobj['api-func-name']]();
                }
                $echobj['cmdobj']['api-insert-domstr']='<div>'.$echobj['cmdobj']['api-insert-domstr'].'</div>';

            }
            // catch error
            $echobj['systemerror']=ob_get_clean();
            ob_start();
            // add echobj
            $echobjarr[]=$echobj;
        }
        // echo all
        $mainechobj['cmdobjarr']=$echobjarr;
        echo obj2json($mainechobj);
        exit();

    }
}





?>

?