// JavaScript Document
let BLUEPRINTS=[];
window.BLUEPRINTS=BLUEPRINTS;
(function(){
	document.addEventListener("DOMContentLoaded", INIT);
	window.addEventListener("resize", RESIZE);
	function INIT(){
		// resize
		RESIZE();
	}

	// RESIZE
	function RESIZE(){
		console.log('RESIZE');
		// areas
		const bcw=document.documentElement.clientWidth;
		//const bch=Math.max(window.innerHeight, document.documentElement.clientHeight)-64;
		const bch=window.ff_helper_vh_vw.clientHeight-72;
		const ratio=bcw/bch;
		let toparea_position='';
		let landscape=0;
		let toparea_w=0;
		let toparea_h=0;
		let bottomarea_w=0;
		if(bcw<640 || ratio<1){
			area_mode='portrait';
			toparea_w=bcw;
			toparea_h=bcw;
			bottomarea_w=bcw;
		}else{
			area_mode='landscape';
			toparea_w=bcw*0.54;
			toparea_h=bch;
			bottomarea_w=bcw*0.46;
		}
		// max bottom width
		let maxbottomareaw=768;
		if(area_mode==="landscape" && bcw>maxbottomareaw*2){
			bottomarea_w=maxbottomareaw;
			toparea_w=bcw-bottomarea_w;
		}
		// set properties and attributes
       	document.body.setAttribute('area-mode', area_mode);
		cssroot.style.setProperty('--toparea-w', toparea_w+'px');
		cssroot.style.setProperty('--toparea-h', toparea_h+'px');
		cssroot.style.setProperty('--bottomarea-w', bottomarea_w+'px');
		// menu
		const menu=document.getElementsByClassName('menu')[0];
		if(menu!=null){
			cssroot.style.setProperty('--menu-client-width', menu.clientWidth+'px');
		}
	}
	
	// MEDIA GALLERY
	BLUEPRINTS['mediagallery_next']=function(event){
		const mediagallery=event.currentTarget.closest('.mediagallery');
		let mediaindex=parseInt(mediagallery.style.getPropertyValue('--media-index'));
		mediaindex++;
		BLUEPRINTS['mediagallery_update'](mediagallery, mediaindex);
	}
	BLUEPRINTS['mediagallery_prev']=function(event){
		const mediagallery=event.currentTarget.closest('.mediagallery');
		let mediaindex=parseInt(mediagallery.style.getPropertyValue('--media-index'));
		mediaindex--;
		BLUEPRINTS['mediagallery_update'](mediagallery, mediaindex);
	}
	BLUEPRINTS['mediagallery_update']=function(mediagallery, mediaindex){
		const mediacount=mediagallery.style.getPropertyValue('--media-count');
		if(mediaindex>=mediacount){
			mediaindex=mediacount-1;
		}
		if(mediaindex<0){
			mediaindex=0;
		}
		if(mediaindex===mediacount-1){
			mediagallery.setAttribute('show-nextbt', 'false');
		}else{
			mediagallery.setAttribute('show-nextbt', 'true');
		}
		if(mediaindex===0){
			mediagallery.setAttribute('show-prevbt', 'false');
		}else{
			mediagallery.setAttribute('show-prevbt', 'true');
		}
		mediagallery.style.setProperty('--media-index', mediaindex);
	}
	// CREATIVE TOOL CLOSE BUTTON ON CLICK
	BLUEPRINTS['creativtoolclosebt_onclick']=function(event){
		window.history.back();
	}
	// SHARE MENU
	document.addEventListener('DOMContentLoaded', sharebutton_INIT);
	function sharebutton_INIT(){
		if(!navigator.share){
			const sharebts=document.getElementsByClassName('sharebt');
			for(let sharebt of sharebts){
				REMOVE(sharebt);
			}
		}
	}
	BLUEPRINTS['sharebutton_triggersharemenu']=function(url='', title='', text=''){
		if(navigator.share) {
			const shareobj={};
			if(title===''){
				shareobj.title=document.title;
			}
			if(text!==''){
				shareobj.text=text;
			}
			if(url===''){
				shareobj.url=window.location.href;
			}else{
				shareobj.url=url;
			}
			navigator.share(shareobj)
			.then(()=>console.log('sharebutton_triggersharemenu: Successfully shared'))
			.catch(error=>console.log('sharebutton_triggersharemenu: Error:', error));
		}
	}
	// MENU
	BLUEPRINTS['menu_toggle']=function(event){
		if(document.body.hasAttribute('menu-is-opened')){
			document.body.removeAttribute('menu-is-opened');
		}else{
			document.body.setAttribute('menu-is-opened', 'true');
		}
	}
	// ADDITIONAL CONTENT BUTTON
	BLUEPRINTS['button_showadditionalcontent']=function(event){
		const introbox=event.currentTarget.closest('.introbox');
		if(introbox!=null){
			REMOVE(introbox);
		}
		REMOVE(event.currentTarget);
		const contents=document.getElementsByClassName('additionalcontent');
		for(let content of contents){
			content.setAttribute('is-visible','');
		}
							
	}
	// LINK POPUP BOX
	BLUEPRINTS['linkpopupstr_showPopUp']=function(event){
		const href=event.currentTarget.getAttribute('linkpopup-href');
		const buttontext=event.currentTarget.getAttribute('linkpopup-buttontext');
		const mediaid=event.currentTarget.getAttribute('linkpopup-mediaid');
		const text='<p>'+event.currentTarget.getAttribute('linkpopup-text')+'</p><a class="button2" href="'+href+'" target="_blank"><span>'+buttontext+'</span></a>';
		const media=rMedia(mediaid);
		const popup=asEl('<div class="overlay" onclick="REMOVE(this.closest(\'.overlay\'));"><div class="overlaybox overlaybubblebox linkpopupbox"><div class="content"><div class="bubble"><div class="thumb">'+media+'</div><div class="text">'+text+'</div></div><div class="whale"><div class="svgicon" style="--svgicon-url:var(--icon-whale); --svgicon-color:#000000"></div></div></div></div></div>');	
		document.body.appendChild(popup);
	}
	// MEDIA LOADED
	BLUEPRINTS['media_isloaded']=function(event){
		const media=event.currentTarget.closest('.media');
		media.setAttribute('is-loaded', '');
		const mediagallery=event.currentTarget.closest('.mediagallery');
		console.log('media_isloaded', mediagallery);
		if(mediagallery!=null){
			if(media.parentElement.firstElementChild===media){
				mediagallery.setAttribute('loaded-firstimage', '');
			}
			
		}
	}
	// WAS IN VIEWPORT
	let WASINVIEWPORT_ELEMENTS;
	let WASINVIEWPORT_EL;
	document.addEventListener("DOMContentLoaded", intitWasInViewport);
	function intitWasInViewport(){
		WASINVIEWPORT_ELEMENTS=document.querySelectorAll('.whitebox');
		wasinviewport_Tick();
	}
	function wasinviewport_Tick(){
		for(WASINVIEWPORT_EL of WASINVIEWPORT_ELEMENTS){
			if(!WASINVIEWPORT_EL.hasOwnProperty('ff_wasinviewport') && isInViewport(WASINVIEWPORT_EL)){
				WASINVIEWPORT_EL.ff_wasinviewport=true;
				WASINVIEWPORT_EL.setAttribute('was-inviewport', 'true');
			}
		}
		setTimeout(wasinviewport_Tick, 1000/30);
	}
	// FULL  WIDTH IMAGE
	BLUEPRINTS['fullwidthimg_show']=function(event){
		const fullwidthimg=event.currentTarget.closest('.fullwidthimg');
		fullwidthimg.setAttribute('show-fullheight', '');
	};
	// COPYRIGHT INFO BUTTON
	document.addEventListener('mousedown', copyrightbutton_hideAll)
	function copyrightbutton_hideAll(){
		const copyrightbuttons=document.getElementsByClassName('copyrightbutton');
		for(const copyrightbutton of copyrightbuttons){
			copyrightbutton.removeAttribute('show-info');
		}
	}
	BLUEPRINTS['copyrightbutton_onclick']=function(e){
		const copyrightbutton=e.currentTarget.closest('.copyrightbutton');
		copyrightbutton_hideAll();
		copyrightbutton.setAttribute('show-info', '');
	}
	// HALL OF FAME FORM
	BLUEPRINTS['clearHalloffameFormResponsebox']=function(_innerhtml){
		document.getElementById("halloffameformresponsebox").innerHTML='';
	}
	
})();