<?php
$COMPONENTS['INPUTS']=[];
// TEXTINPUT
$BLUEPRINTS['rInputGroup']=function($obj){
	$name=rObjValue($obj, 'name');
	$type=rObjValue($obj, 'type');
	$id=rObjValue($obj, 'id');
	$innerdom=rObjValue($obj, 'innerdom');
	return '<div inputgroup-name="'.$name.'" inputgroup-type="'.$type.'" inputgroup-id="'.$id.'">
				'.$innerdom.'
			</div>';
};
// DROPDOWN
$BLUEPRINTS['rDropDown']=function($obj){
	$targetid=rTmpID('dropdown');
	$name=rObjValue($obj, 'name');
	$value=rObjValue($obj, 'value');
	$defaulttext=rObjValue($obj, 'defaulttext');
	$valuetext='';
	$label=rObjValue($obj, 'label');
	$options=rObjValue($obj, 'options', []);
	$class=rObjValue($obj, 'class');
	$atts=rObjValue($obj, 'atts');
	$id=rObjValue($obj, 'id');
	$onvaluechange_callback=rObjValue($obj, 'onvaluechange_callback');
	$resetbt_dom='<div class="resetbutton"></div>';
	// add default value
	if($defaulttext===''){
		$defaulttext='Keine Auswahl';
	}
	if($defaulttext==='none'){
		$defaulttext='';
		$resetbt_dom='';
	}
	if($defaulttext!==''){
		array_unshift($options, ['value'=>'','text'=>$defaulttext]);
	}
	// items
	$items_dom='';
	foreach($options as $option){
		$category=rObjValue($option, 'category');
		if($category!==''){
			$items_dom.='<div class="dropdowncategory">'.$category.'</div>';
		}else{
			$ovalue=rObjValue($option, 'value');
			$otext=rObjValue($option, 'text');
			$groupid=rObjValue($option, 'groupid');
			$groupidatt='';
			if($groupid!==''){
				$groupidatt='group-id="'.$groupid.'"';
			}
			$iscurrentatt='';
			if($value===$ovalue){
				$iscurrentatt='is-current';
				$valuetext=$otext;
			}
			$items_dom.='<div class="dropdownitem" set-value="'.$ovalue.'" '.$iscurrentatt.' '.$groupidatt.'>'.$otext.'</div>';
		}
	}
	// labeldom and att
	$label_dom='';
	$haslabel_att='';
	if($label!==''){
		$label_dom='<div class="inputlabel">'.$label.'</div>';
		$haslabel_att='has-label';
	}
	// classes
	$classes='dropdown_'.$name;
	if($class!==''){
		$classes.=' '.$class;
	}
	// id att
	$idatt='';
	if($id!==''){
		$idatt='id="'.$id.'"';
	}
	// onvaluechange_callback
	$onvaluechange_callback_att='';
	if($onvaluechange_callback!==''){
		$onvaluechange_callback_att='onvaluechange-callback="'.$onvaluechange_callback.'"';
	}
	return '<div '.$idatt.' class="'.$classes.'" target-id="'.$targetid.'" input-name="'.$name.'" input-value="'.$value.'" input-initial-value="'.$value.'" input-type="dropdown" input-label="'.rAttStr($label).'" '.$haslabel_att.' '.$atts.' onclick="BLUEPRINTS.dropdown_click(event);" '.$onvaluechange_callback_att.'>
				'.$label_dom.'
				<div class="currentvalue">'.$valuetext.'</div>
                <div class="dropdownitems">
					<div class="dropdownscrollcont">
                        '.$items_dom.'
					</div>
                </div>
				'.$resetbt_dom.'
				<div class="dropdownarrow"></div>
			</div>';
	 
};
// TEXT INPUT
$BLUEPRINTS['rTextInput']=function($obj){
	$targetid=rTmpID('textinput');
	$name=rObjValue($obj, 'name');
	$value=rObjValue($obj, 'value');
	$label=rObjValue($obj, 'label');
	$placeholder=rObjValue($obj, 'placeholder');
	$class=rObjValue($obj, 'class');
	$atts=rObjValue($obj, 'atts');
	$inputid=rObjValue($obj, 'inputid');
	$inputatts=rObjValue($obj, 'inputatts');
	$onvaluechange_callback=rObjValue($obj, 'onvaluechange_callback');
	// playholder_att
	$placeholder_att='';
	if($placeholder!==''){
		$placeholder_att=' placeholder="'.$placeholder.'"';
	}
	// labeldom
	$label_dom='';
	if($label!==''){
		$label_dom='<div class="inputlabel">'.$label.'</div>';
	}
	// classes
	$classes='textinput_'.$name;
	if($class!==''){
		$classes.=' '.$class;
	}
	// inputid att
	if($inputid===''){
		$inputid=$targetid.'_inputel';
	}else{
		$inputid=rAttStr($inputid);
	}
	// onvaluechange_callback
	$onvaluechange_callback_att='';
	if($onvaluechange_callback!==''){
		$onvaluechange_callback_att='onvaluechange-callback="'.$onvaluechange_callback.'"';
	}
	// rerturn
	return '<div class="'.$classes.'" target-id="'.$targetid.'"  input-name="'.$name.'" input-value="'.$value.'" input-initial-value="'.$value.'" input-type="textinput" '.$atts.' input-label="'.rAttStr($label).'"  '.$onvaluechange_callback_att.'>
				'.$label_dom.'
				<input type="text" name="input'.$name.'" '.$placeholder_att.' id="'.$inputid.'" value="'.$value.'" oninput="BLUEPRINTS.textinput_oninput(event);" '.$inputatts.'>			
			</div>';
	 
};
// RICH TEXT INPUT
$BLUEPRINTS['rRichTextInput']=function($obj){
	$targetid=rTmpID('textinput');
	$texteditor_toolbar_id=rTmpID('tetoolbar');
	$name=rObjValue($obj, 'name');
	$value=rObjValue($obj, 'value');
	$label=rObjValue($obj, 'label');
	$placeholder=rObjValue($obj, 'placeholder');
	$editortags=rObjValue($obj, 'editortags');
	$toolbarmode=rObjValue($obj, 'toolbarmode');
	$class=rObjValue($obj, 'class');
	$atts=rObjValue($obj, 'atts');
	$inputid=rObjValue($obj, 'inputid');
	$onvaluechange_callback=rObjValue($obj, 'onvaluechange_callback');
	// playholder_att
	$placeholder_att='';
	if($placeholder!==''){
		$placeholder_att=' placeholder="'.$placeholder.'"';
	}
	// editortags_att
	$editortags_att='a,b,h1,h2';
	if($editortags!==''){
		$editortags_att=' editor-tags="'.$editortags.'"';
	}
	// labeldom
	$label_dom='';
	if($label!==''){
		$label_dom='<div class="inputlabel">'.$label.'</div>';
	}
	// classes
	$classes='textinput_'.$name;
	if($class!==''){
		$classes.=' '.$class;
	}

	// toolbarmode
	$inserttoolbarscript='';
	if($toolbarmode==='classic'){
		$scripttargetid=rTmpID();
		$inserttoolbarscript='<div target-id="'.$scripttargetid.'"></div><script>BLUEPRINTS.richtextinput_insertToolbar("'.$scripttargetid.'", "'.$editortags.'", "'.$texteditor_toolbar_id.'");</script>';
	}
	
	// onvaluechange_callback
	$onvaluechange_callback_att='';
	if($onvaluechange_callback!==''){
		$onvaluechange_callback_att='onvaluechange-callback="'.$onvaluechange_callback.'"';
	}
	// rerturn
	return '<div class="'.$classes.'" target-id="'.$targetid.'"  input-name="'.$name.'" input-type="richtextinput" '.$atts.' input-label="'.rAttStr($label).'"  '.$onvaluechange_callback_att.'>
				'.$label_dom.'
				'.$inserttoolbarscript.'
				<div contenteditable="true" '.$placeholder_att.' id="'.$inputid.'" '.$editortags_att.' oninput="BLUEPRINTS.richtextinput_oninput(event);" ref-texteditor-toolbar-id="'.$texteditor_toolbar_id.'">
				'.$value.'
				</div>
			</div>';
	 
};
// TEXT AREA
$BLUEPRINTS['rTextArea']=function($obj){
	$targetid=rTmpID('textarea');
	$name=rObjValue($obj, 'name');
	$value=rObjValue($obj, 'value');
	$label=rObjValue($obj, 'label');
	$placeholder=rObjValue($obj, 'placeholder');
	$class=rObjValue($obj, 'class');
	$atts=rObjValue($obj, 'atts');
	$inputid=rObjValue($obj, 'inputid');
	$onvaluechange_callback=rObjValue($obj, 'onvaluechange_callback');
	// playholder_att
	$placeholder_att='';
	if($placeholder!==''){
		$placeholder_att=' placeholder="'.$placeholder.'"';
	}
	// labeldom
	$label_dom='';
	if($label!==''){
		$label_dom='<div class="inputlabel">'.$label.'</div>';
	}
	// classes
	$classes='textarea_'.$name;
	if($class!==''){
		$classes.=' '.$class;
	}
	// inputid att
	if($inputid===''){
		$inputid=$targetid.'_inputel';
	}else{
		$inputid=rAttStr($inputid);
	}
	// onvaluechange_callback
	$onvaluechange_callback_att='';
	if($onvaluechange_callback!==''){
		$onvaluechange_callback_att='onvaluechange-callback="'.$onvaluechange_callback.'"';
	}
	// return
	return '<div class="'.$classes.'" target-id="'.$targetid.'"  input-name="'.$name.'" input-value="'.$value.'" input-initial-value="'.$value.'" input-type="textarea" '.$atts.' input-label="'.rAttStr($label).'"  '.$onvaluechange_callback_att.'>
				'.$label_dom.'
				<textarea type="text" name="input'.$name.'" '.$placeholder_att.' id="'.$inputid.'" oninput="BLUEPRINTS.textarea_oninput(event);">'.$value.'</textarea>		
			</div>';
	 
};
// CHECKBOX 
$BLUEPRINTS['rCheckBox']=function($obj){
	$targetid=rTmpID('checkbox');
	$name=rObjValue($obj, 'name');
	$value=rObjValue($obj, 'value')?'true':'false';
	$label=rObjValue($obj, 'label');
	$class=rObjValue($obj, 'class');
	$atts=rObjValue($obj, 'atts');
	$inputid=rObjValue($obj, 'inputid');
	$onvaluechange_callback=rObjValue($obj, 'onvaluechange_callback');
	
	// labeldom
	$label_dom='';
	if($label!==''){
		$label_dom='<div class="inputlabel">'.$label.'</div>';
	}
	// classes
	$classes='checkbox_'.$name;
	if($class!==''){
		$classes.=' '.$class;
	}
	// onvaluechange_callback
	$onvaluechange_callback_att='';
	if($onvaluechange_callback!==''){
		$onvaluechange_callback_att='onvaluechange-callback="'.$onvaluechange_callback.'"';
	}
	// return
	return '<div class="'.$classes.'" target-id="'.$targetid.'"  input-name="'.$name.'" input-value="'.$value.'" input-initial-value="'.$value.'" input-type="checkbox" '.$atts.' input-label="'.rAttStr($label).'"  '.$onvaluechange_callback_att.' onclick="BLUEPRINTS.checkbox_oninput(event);">
				<div class="checkboxbox"></div>
				'.$label_dom.'
			</div>';
	 
};
// DATE INPUT
$BLUEPRINTS['rDateInput']=function($obj){
	$targetid=rTmpID('dateinput');
	$name=rObjValue($obj, 'name');
	$value=rObjValue($obj, 'value');
	$label=rObjValue($obj, 'label');
	$placeholder=rObjValue($obj, 'placeholder');
	$class=rObjValue($obj, 'class');
	$atts=rObjValue($obj, 'atts');
	$inputid=rObjValue($obj, 'inputid');
	$onvaluechange_callback=rObjValue($obj, 'onvaluechange_callback');
	// playholder_att
	$placeholder_att='';
	if($placeholder!==''){
		$placeholder_att=' placeholder="'.$placeholder.'"';
	}
	// labeldom
	$label_dom='';
	if($label!==''){
		$label_dom='<div class="inputlabel">'.$label.'</div>';
	}
	// classes
	$classes='dateinput_'.$name;
	if($class!==''){
		$classes.=' '.$class;
	}
	// inputid att
	if($inputid===''){
		$inputid=$targetid.'_inputel';
	}else{
		$inputid=rAttStr($inputid);
	}
	// onvaluechange_callback
	$onvaluechange_callback_att='';
	if($onvaluechange_callback!==''){
		$onvaluechange_callback_att='onvaluechange-callback="'.$onvaluechange_callback.'"';
	}
	// return
	return '<div class="'.$classes.'" target-id="'.$targetid.'"  input-name="'.$name.'" input-value="'.$value.'" input-initial-value="'.$value.'" input-type="dateinput" '.$atts.' input-label="'.rAttStr($label).'"  '.$onvaluechange_callback_att.'>
				'.$label_dom.'
				<input type="date" name="input'.$name.'" '.$placeholder_att.' id="'.$inputid.'" value="'.$value.'" oninput="BLUEPRINTS.dateinput_oninput(event);">			
			</div>';
	 
};

// MEDIA INPUT
$BLUEPRINTS['mediainput_rContentByValue']=function($mediaidarr){
	global $BLUEPRINTS;
	$content='';
	foreach($mediaidarr as $mediaid){
		$content.=$BLUEPRINTS['mediainput_rMediael']($mediaid);
	}
	return $content;
};
$BLUEPRINTS['mediainput_rMediael']=function($mediaid){
	return '<div class="mediael" media-id="'.$mediaid.'" target-id="'.rTmpID('mediael').'">
				'.rMediaDomByMediaId($mediaid).'
				<div class="deletebt">
					<div class="deleteicon scopeicon"></div>
				</div>
			</div>';
};
$BLUEPRINTS['rMediaInput']=function($obj){
	global $BLUEPRINTS;
	$targetid=rTmpID('upload');
	$inputid=rTmpID('fileinput');
	$uploadcontainertargetid=rTmpID('uploadcontainer');
	$name=rObjValue($obj, 'name');
	$value=rObjValue($obj, 'value', []);
	$mimetypes=rObjValue($obj, 'mimetypes', '*/*');
	$multiple=rObjValue($obj, 'multiple');
	$label=rObjValue($obj, 'label');
	$class=rObjValue($obj, 'class');
	$atts=rObjValue($obj, 'atts');
	
	$onvaluechange_callback=rObjValue($obj, 'onvaluechange_callback');
	// labeldom
	$label_dom='';
	if($label!==''){
		$label_dom='<div class="inputlabel">'.$label.'</div>';
	}
	// classes
	$classes='mediainput_'.$name;
	if($class!==''){
		$classes.=' '.$class;
	}
	// multiple
	$multipleatt='';
	if($multiple==='true' || $multiple===true){
		$multipleatt='multiple';
	}
	// onvaluechange_callback
	$onvaluechange_callback_att='';
	if($onvaluechange_callback!==''){
		$onvaluechange_callback_att='onvaluechange-callback="'.$onvaluechange_callback.'"';
	}
	// load content
	$content=$BLUEPRINTS['mediainput_rContentByValue']($value);
	// return
	return '<div class="'.$classes.'" target-id="'.$targetid.'"  input-name="'.$name.'"  input-type="mediainput" '.$atts.' input-label="'.rAttStr($label).'"  '.$onvaluechange_callback_att.' onclick="BLUEPRINTS.mediainput_onclick(event);">
				'.$label_dom.'
				<div class="circlebtbg uploadbt">
					<label for="'.$inputid.'" class="uploadbtlabel scopeicon">
						<input type="file" '.$multipleatt.' name="files[]" accept="'.$mimetypes.'" onchange="BLUEPRINTS.mediainput_oninput(event);" ref-target-id="'.$uploadcontainertargetid.'" id="'.$inputid.'" onclick="this.value=null;">
					</label>
				</div>
				<div class="uploadcontainer" '.$multipleatt.' target-id="'.$uploadcontainertargetid.'" accepted-mimetypes="'.$mimetypes.'">
					'.$content.'
				</div>
			</div>';
};
$COMPONENTS['INPUTS']['mediainput_deleteMedia']=function($mediaid){
	deleteMedia($mediaid);
	return '';
}
	
?>