// JavaScript Document
let MEDIASLIDER={};
(function(){
	window.addEventListener('DOMContentLoaded', INIT);
	let smoothscroll=false;
	let smoothscroll_timer=0;
	function INIT(){
		const mediasliders=document.getElementsByClassName('mediasliderbox');
		for(const mediaslider of mediasliders){
			const mediaelswrapper=mediaslider.getElementsByClassName('mediaelswrapper')[0];
			mediaslider.ff_pauseonscroll=false;
			mediaslider.ff_deactivateinfinitescrolljumponscroll=false;
			mediaslider.ff_autoscrolling=true;
			mediaslider.ff_pauseonscrolltimer=0;
			
			MEDIASLIDER.setCurrent(mediaslider, 0, 'instantscroll');
			mediaelswrapper.ff_scrollLeft_target=mediaelswrapper.scrollLeft;
			
			mediaslider.ff_autoScroll=function(){
				if(mediaslider.ff_autoscrolling){
					MEDIASLIDER.next(mediaslider);
				}
				setTimeout(mediaslider.ff_autoScroll, 6000);
			}
			setTimeout(mediaslider.ff_autoScroll, 6000);
			
			// smotthscroll ticker
			mediaslider.ff_scmoothscrolltick=function(){
				if(smoothscroll){
					const mediaelswrapper=mediaslider.getElementsByClassName('mediaelswrapper')[0];
					const delta=mediaelswrapper.ff_scrollLeft_target-mediaelswrapper.scrollLeft;
					console.log('delta', delta);
					if(parseInt(Math.abs(delta))>8){
						mediaelswrapper.style.setProperty('scroll-snap-type', 'none');
						mediaelswrapper.scrollLeft+=delta/8;
						console.log('smoothscroll');
					}else{
						mediaelswrapper.style.removeProperty('scroll-snap-type');
						smoothscroll=false;
						mediaelswrapper.scrollLeft=mediaelswrapper.ff_scrollLeft_target;
						mediaelswrapper.ff_scrollLeft_target=mediaelswrapper.scrollLeft;
						
					}	
				}
					
				setTimeout(mediaslider.ff_scmoothscrolltick, 1000/60);
			}
			mediaslider.ff_scmoothscrolltick();
		}
	}
	
	// inline handler
	MEDIASLIDER.mediaslider_onmousetouchdown=function(e){
		const mediaslider=e.currentTarget.closest('.mediasliderbox');
		mediaslider.ff_autoscrolling=false;
	}
	MEDIASLIDER.dot_onclick=function(e, n){
		const mediaslider=e.currentTarget.closest('.mediasliderbox');
		MEDIASLIDER.setCurrent(mediaslider, n);
	}
	MEDIASLIDER.mediabox_onmousedown=function(e){
		const mediabox=e.currentTarget;
		const mediaslider=mediabox.closest('.mediasliderbox');
		if(mediabox.hasAttribute('is-current-viewed-next')){
			MEDIASLIDER.next(mediaslider);
		}else if(mediabox.hasAttribute('is-current-viewed-prev')){
			MEDIASLIDER.prev(mediaslider);
		}
	}
	MEDIASLIDER.mediaelswrapper_onscroll=function(e){
		console.log('onscroll');
		const mediaslider=e.currentTarget.closest('.mediasliderbox');
		if(mediaslider.ff_pauseonscroll===false){
			const mediaelswrapper=mediaslider.getElementsByClassName('mediaelswrapper')[0];
			const mediaboxes=mediaslider.getElementsByClassName('slidermediabox');
			const count=mediaboxes.length-4;
			const firstbox_rect=mediaboxes[1].getBoundingClientRect();
			const secondbox_rect=mediaboxes[2].getBoundingClientRect();
			const secondlastbox_rect=mediaboxes[mediaboxes.length-2].getBoundingClientRect();
			const mediaelswrapper_rect=mediaelswrapper.getBoundingClientRect();
			const padw=(mediaelswrapper_rect.width-firstbox_rect.width)/2;
			const boxdist=secondbox_rect.left-firstbox_rect.left;
			// infinite scroll
            if(secondbox_rect.right>mediaelswrapper_rect.right-padw){
                MEDIASLIDER.scrollJumpLeft(mediaslider, count*boxdist, true);
                mediaelswrapper.ff_scrollLeft_target+=count*boxdist;
				console.log('SCROLLJUMP FROM JUMP FROM START TO END');
            }else if(secondlastbox_rect.left<mediaelswrapper_rect.left+padw){
                MEDIASLIDER.scrollJumpLeft(mediaslider, -count*boxdist, true);
				console.log('SCROLLJUMP FROM JUMP FROM END  TO START');
                mediaelswrapper.ff_scrollLeft_target-=count*boxdist;
            }
			
			// is-in-view
			const viewindex=parseInt((mediaelswrapper.scrollLeft+padw+mediaelswrapper_rect.width/2)/boxdist);
			let mediabox;
			for(let n=0; n<mediaboxes.length; n++){
				mediabox=mediaboxes[n];
				mediabox.removeAttribute('is-current-viewed');
				mediabox.removeAttribute('is-current-viewed-prev');
				mediabox.removeAttribute('is-current-viewed-next');
				if(n===viewindex-1){
					mediabox.setAttribute('is-current-viewed-prev', '');
				}else if(n===viewindex){
					mediabox.setAttribute('is-current-viewed', '');
					mediaslider.setAttribute('current-viewed-n', n);
				}else if(n===viewindex+1){
					mediabox.setAttribute('is-current-viewed-next', '');
				}
			}
			let currentn=viewindex-2;
			MEDIASLIDER.setCurrentN(mediaslider, currentn);
		}
	}
	// functions
	MEDIASLIDER.scrollJumpLeft=function(mediaslider, value, by=false){
		const mediaelswrapper=mediaslider.getElementsByClassName('mediaelswrapper')[0];
		mediaslider.ff_pauseonscroll=true;
		if(by){
			mediaelswrapper.scrollLeft+=value;
		}else{
			mediaelswrapper.scrollLeft=value;
		}			
		mediaslider.ff_pauseonscroll=false;
	}
	MEDIASLIDER.setCurrentN=function(mediaslider, currentn){
		const dots=mediaslider.getElementsByClassName('dot');
		// set current
		if(currentn<0){
			currentn=dots.length-2;
		}
		if(currentn>=dots.length){
			currentn=0;
		}
		mediaslider.setAttribute('current-n', currentn);
		// update dots
		for(let dot of dots){
			dot.removeAttribute('is-current');
		}
		dots[currentn].setAttribute('is-current', '');
		return currentn;
	}
	MEDIASLIDER.setCurrent=function(mediaslider, currentn, option=''){
		smoothscroll=true;
		const currentcurrentn=parseInt(mediaslider.getAttribute('current-n'));
		const mediaboxes=mediaslider.getElementsByClassName('slidermediabox');
		const mediaelswrapper=mediaslider.getElementsByClassName('mediaelswrapper')[0];
		const dots=mediaslider.getElementsByClassName('dot');
		const count=mediaboxes.length-4;
		currentn=MEDIASLIDER.setCurrentN(mediaslider, currentn);
		const currentbox=mediaboxes[currentn+2];
		const rect=mediaboxes[0].getBoundingClientRect();
		const rect1=mediaboxes[1].getBoundingClientRect();
		const boxdist=rect1.left-rect.left;
		const padw=(mediaelswrapper.getBoundingClientRect().width-rect.width)/2;
		// scroll to current
		 if(option==='instantscroll'){
			 smoothscroll=false;
			MEDIASLIDER.scrollJumpLeft(mediaslider, currentbox.offsetLeft-padw);
		 }else{
			if(currentcurrentn===0){
				MEDIASLIDER.scrollJumpLeft(mediaslider, -count*boxdist, true);
				mediaslider.ff_pauseonscroll=true;
				mediaelswrapper.ff_scrollLeft_target=currentbox.offsetLeft-padw;
				clearTimeout(mediaslider.ff_pauseonscrolltimer);
				mediaslider.ff_pauseonscrolltimer=setTimeout(function(){
					mediaslider.ff_pauseonscroll=false;
					MEDIASLIDER.mediaelswrapper_onscroll({currentTarget:mediaslider});
				}, 1000/4);
			}else{
				mediaelswrapper.ff_scrollLeft_target=currentbox.offsetLeft-padw;
			}
		 }
	}
	MEDIASLIDER.next=function(mediaslider){
		smoothscroll=true;
		const currentn=parseInt(mediaslider.getAttribute('current-n'));
		if(currentn===0){
			MEDIASLIDER.setCurrent(mediaslider, currentn+1);
		}else{
			const mediaelswrapper=mediaslider.getElementsByClassName('mediaelswrapper')[0];
			const nextel=mediaslider.querySelectorAll('.slidermediabox[is-current-viewed-next]')[0];
			const padw=(mediaelswrapper.getBoundingClientRect().width-nextel.getBoundingClientRect().width)/2;
			mediaelswrapper.ff_scrollLeft_target=nextel.offsetLeft-padw;
		}
		
	}
	MEDIASLIDER.prev=function(mediaslider){
		smoothscroll=true;
		const prevel=mediaslider.querySelectorAll('.slidermediabox[is-current-viewed-prev]')[0];
		const mediaelswrapper=mediaslider.getElementsByClassName('mediaelswrapper')[0];
		const padw=(mediaelswrapper.getBoundingClientRect().width-prevel.getBoundingClientRect().width)/2;
		mediaelswrapper.ff_scrollLeft_target=prevel.offsetLeft-padw;
		console.log('MEDIASLIDER.prev', 'mediaelswrapper.scrollLeft', mediaelswrapper.scrollLeft, 'prevel.offsetLeft', prevel.offsetLeft)
	}
})();
