/////// TEXTEDITOR //////////////////////////////////////////
let TEXTEDITOR={};
(function(){
// config
const TEXTFORMATS=['a', 'br', 'b', 'i', 'strong', 'em', 'u', 'sup', 'fill-word', 'button-1', 'color-1', 'color-2', 'color-3', 'color-4', 'color-5'];
const PARAGRAPHFORMATS=['p', 'h1', 'h2', 'h3', 'bullet-point'];
const TEXTATTS=['href'];
let SEL_TEXTBOX_INFOS;
let delayedformatrange_timer=0;
TEXTEDITOR.rootel=null;
TEXTEDITOR.history_timer=0;
TEXTEDITOR.history_max=23;
TEXTEDITOR.modulrange=null;	
TEXTEDITOR.SELECTION_CHANGE_ON=true;
TEXTEDITOR.selectionchange_timer=0;
	
	/*c
window.customElements.define("fill-word", class extends HTMLElement {});
window.customElements.define("button-1", class extends HTMLElement {});
window.customElements.define("color-1", class extends HTMLElement {});
window.customElements.define("color-2", class extends HTMLElement {});
window.customElements.define("color-3", class extends HTMLElement {});
window.customElements.define("color-4", class extends HTMLElement {});
window.customElements.define("color-5", class extends HTMLElement {});
window.customElements.define("bullet-point", class extends HTMLElement {});
	*/
function getAllTextNodes(el){
	let node;
	const arr=[];
	const walker=document.createTreeWalker(el, NodeFilter.SHOW_TEXT, null, false);
	while(node=walker.nextNode()){
		arr.push(node);
	}
	return arr;
}

// init  

document.addEventListener('DOMContentLoaded', INIT);	
function INIT(){
    console.log("texteditor_INIT");
	TEXTEDITOR.urltfbox=asEl('<div class="urltfbox" aria-hidden="true"><input type="text" placeholder="URL eingeben" class="urltf" title="URL" /><div class="urltfconfirm">Verlinken</div></div>');
	TEXTEDITOR.urltf=TEXTEDITOR.urltfbox.getElementsByClassName('urltf')[0];
	TEXTEDITOR.toolbar=TEXTEDITOR.rToolbar();
	TEXTEDITOR.toolbar.classList.add('toolbar_texteditor_global');
	// TEXTEDITOR.globaltoolbar=TEXTEDITOR.toolbar;
	document.body.appendChild(TEXTEDITOR.toolbar);
	document.body.appendChild(TEXTEDITOR.urltfbox);
	TEXTEDITOR.reINIT();
}
TEXTEDITOR.reINIT=function(){
	const initels=document.querySelectorAll('*[contenteditable][editor-tags]');
	for(el of initels){
		if(el.hasOwnProperty('ff_has_been_inited')===false){
			el.ff_has_been_inited=true;
			TEXTEDITOR.history_addTo(el, el.innerHTML);
			TEXTEDITOR.checkEmptyness(el);
		}
	}
}
TEXTEDITOR.addGlobalToolBarElement=function(el, insertcmd='beforeend'){
	TEXTEDITOR.toolbar.insertAdjacentElement(insertcmd, el);
}
TEXTEDITOR.rToolbar=function(editortags='all'){
	let tagsarr=[];
	if(editortags==='all'){
		for(let str of TEXTFORMATS){
			tagsarr.push(str);
		}
		for(let str of PARAGRAPHFORMATS){
			tagsarr.push(str);
		}
	}else{
		tagsarr=editortags.split(',');
	}
	let bts='';
	let colorbts='';
	console.log('rToolbar', 'tagsarr', tagsarr);
	// always present
	bts+='<div class="iconbt_erase" format-tag="erase" title="Formatierung löschen"></div>';
	for(let tag of tagsarr){
		tag=tag.trim();
		// optional
		if(tag==='strong'){
			bts+='<div class="iconbt_strong" format-tag="strong" title="Fett"></div>';
		}else if(tag==='em'){
			bts+='<div class="iconbt_em" format-tag="em" title="Kursiv"></div>';
		}else if(tag==='b'){
			bts+='<div class="iconbt_b" format-tag="b" title="Großbuchstaben"></div>';
		}else if(tag==='sup'){
			bts+='<div class="iconbt_sup" format-tag="sup" title="Hochgestellt"></div>';
		}else if(tag==='p'){
			bts+='<div class="iconbt_p" format-tag="p" title="Absatz"></div>';
		}else if(tag==='bullet-point'){
			bts+='<div class="iconbt_bullet-point" format-tag="bullet-point" title="Listenpunkt"></div>';
		}else if(tag==='h1'){
			bts+='<div class="iconbt_h1" format-tag="h1" title="Überschrift 1"></div>';
		}else if(tag==='h2'){
			bts+='<div class="iconbt_h2" format-tag="h2" title="Überschrift 2"></div>';
		}else if(tag==='h3'){
			bts+='<div class="iconbt_h3" format-tag="h3" title="Überschrift 3"></div>';
		}else if(tag==='a'){
			bts+='<div class="iconbt_a" format-tag="a" format-attr="href" title="Verlinken"></div>';
		}else if(tag==='u'){
			bts+='<div class="iconbt_u" format-tag="u" title="Unterstreichen"></div>';
		}else if(tag==='erasea'){
			bts+='<div class="iconbt_erasea" format-tag="erasea" title="Verlinkung entfernen"></div>';
		// custom tags
		}else if(tag==='button-1'){
			bts+='<div class="iconbt_button-1" format-tag="button-1" title="button"></div>';
		}else if(tag==='fill-word'){
			bts+='<div class="iconbt_fill-word" format-tag="fill-word" title="Füllwortlücke"></div>';
		// colors
		}else if(tag==='color-1'){
			colorbts+='<div class="iconbt_color-1" format-tag="color-1" title="Farbe 1"></div>';
		}else if(tag==='color-2'){
			colorbts+='<div class="iconbt_color-2" format-tag="color-2" title="Farbe 2"></div>';
		}else if(tag==='color-3'){
			colorbts+='<div class="iconbt_color-3" format-tag="color-3" title="Farbe 3"></div>';
		}else if(tag==='color-4'){
			colorbts+='<div class="iconbt_color-4" format-tag="color-4" title="Farbe 4"></div>';
		}else if(tag==='color-5'){
			colorbts+='<div class="iconbt_color-5" format-tag="color-5" title="Farbe 5"></div>';
		}
	}
	if(colorbts!==''){
		colorbts='<div class="colorbts">'+colorbts+'</div>';
	}
	return asEl('<div class="toolbar_texteditor" aria-hidden="true">'+bts+colorbts+'</div>');
} 

// inline function
TEXTEDITOR.richtextinput_oninput=function(e){
	formatRange(getRange(), '');
	/*
	clearTimeout(delayedformatrange_timer);
    delayedformatrange_timer=setTimeout(function(){formatRange(getRange(), '');},1);
	*/
}

// API
TEXTEDITOR.checkEmptyness=function(el){
	if(el.textContent===''){
		el.setAttribute('is-empty', '');
	}else{
		el.removeAttribute('is-empty');
	}
}
TEXTEDITOR.urltfbox_confirm=function(){
	//console.log('urltfbox_confirm');
	if(TEXTEDITOR.modulrange!=null){
		console.log('TEXTEDITOR.urltfbox_confirm', TEXTEDITOR.modulrange);
		formatRange(TEXTEDITOR.modulrange, 'a');
		TEXTEDITOR.urltf.value='';
		TEXTEDITOR.urltfbox.removeAttribute('is-active');
	}
}
TEXTEDITOR.urltfbox_hide=function(){
	//console.log('urltfbox_hide');
	if(TEXTEDITOR.urltfbox.hasAttribute('is-active')){
        formatRange(TEXTEDITOR.modulrange, ''); 
        TEXTEDITOR.urltf.value='';
        TEXTEDITOR.urltfbox.removeAttribute('is-active');
	}
}
TEXTEDITOR.urltfbox_show=function(){
	//console.log('urltfbox_show');
	TEXTEDITOR.urltf.value='';
	TEXTEDITOR.toolbar.style.opacity=1;
    TEXTEDITOR.toolbar.style.pointerEvents='all';
	TEXTEDITOR.urltfbox.setAttribute('is-active', 'true');
	setTimeout(function(){TEXTEDITOR.urltf.focus()},30);
}
TEXTEDITOR.toolbar_hide=function(){
	//console.log('toolbar_hide');
	TEXTEDITOR.toolbar.style.opacity=0;
    TEXTEDITOR.toolbar.style.pointerEvents='none';
}
TEXTEDITOR.toolbar_show=function(){
	//console.log('toolbar_show');
	if(TEXTEDITOR.rootel!==null){
		if(!TEXTEDITOR.rootel.hasAttribute('ref-texteditor-toolbar-id')){
			// hide all buttons
			const formatels=TEXTEDITOR.toolbar.querySelectorAll('*[format-tag]');
			for(const el of formatels){
				el.style.display='none';
			}
			// show by editor-tags attribute
			TEXTEDITOR.toolbar.querySelectorAll('*[format-tag="erase"]')[0].style.display='flex';
			const editortags=TEXTEDITOR.rootel.getAttribute('editor-tags');
			if(editortags!=='none'){
				const showtags=editortags.split(',');
				let hascolor=false;
				let n=showtags.length;
				while(n--){
					const showtag=showtags[n].trim();
					TEXTEDITOR.toolbar.querySelectorAll('*[format-tag="'+showtag+'"]')[0].style.display='flex';
					if(showtag.substr(0,5)==='color'){
						hascolor=true;
					}
				}
				if(hascolor===false){
					TEXTEDITOR.toolbar.getElementsByClassName('colorbts')[0].style.display='none';
				}
			}
			TEXTEDITOR.toolbar.style.opacity=1;
			TEXTEDITOR.toolbar.style.pointerEvents='all';
		}
		// CALLBACK
		if(TEXTEDITOR.rootel.hasAttribute('ontoolbarshow-callback')){
			callWindowCallback(TEXTEDITOR.rootel.getAttribute('ontoolbarshow-callback'), TEXTEDITOR.toolbar);
		}
	}
	
}
TEXTEDITOR.temporarilyDeactivateSelectionChangeHandler=function(){
	TEXTEDITOR.SELECTION_CHANGE_ON=false;
	clearTimeout(TEXTEDITOR.selectionchange_timer);
	TEXTEDITOR.selectionchange_timer=setTimeout(function(){TEXTEDITOR.SELECTION_CHANGE_ON=true;},1);
}
// FORMAT RANGE
function formatRange(range, tag, _historymode='delayed'){
    // console.log('formatRange', 'format-tag: '+tag);
	TEXTEDITOR.temporarilyDeactivateSelectionChangeHandler();
    if(range!=null && tag!=null){ 
        const iscollapsed=range.collapsed;
		let tagtype='';
		if(TEXTFORMATS.indexOf(tag)!==-1){
			tagtype='tag';
		}
		if(PARAGRAPHFORMATS.indexOf(tag)!==-1){
			tagtype='paragraph';
		}
        const rootel=TEXTEDITOR.rootel;
		let frag=document.createDocumentFragment(); 
		let startel=asEl('<selstart></selstart>');
        let endel=asEl('<selend></selend>');
        let pnode=null, prevnode=null, nextnode=null; 
		let n=0, m=0, i=0;
		// add selstart and selend to range
		frag.appendChild(startel);
		frag.appendChild(range.cloneContents());
		frag.appendChild(endel);
		range.deleteContents();
		range.insertNode(frag);
        
		
        // remove forced paragraph caused by insertNode Method
		
		if(tagtype==='tag'){
			pnode=startel.parentElement;
			prevnode=startel.previousSibling;
			nextnode=startel.nextSibling;
			if(pnode===rootel && prevnode!=null && nextnode!=null && PARAGRAPHFORMATS.indexOf(nodeName(prevnode))!==-1 && PARAGRAPHFORMATS.indexOf(nodeName(nextnode))!==-1){
				prevnode.appendChild(startel);
				prevnode.appendChild(nextnode);
				unWrap(nextnode);
			}
			pnode=endel.parentElement;
			prevnode=endel.previousSibling;
			nextnode=endel.nextSibling;
			if(pnode===rootel && prevnode!=null && nextnode!=null && PARAGRAPHFORMATS.indexOf(nodeName(prevnode))!==-1 && PARAGRAPHFORMATS.indexOf(nodeName(nextnode))!==-1){
				prevnode.appendChild(endel);
				prevnode.appendChild(nextnode);
				unWrap(nextnode);
			}  
		}
		
       // get node infos
		updateSelTextBoxInfos();
		let parr=SEL_TEXTBOX_INFOS.parr, obj=null, dom='', hasparagraphtags, firstnode, pdom, openedpartag, par, useptag, node, firstinnode, lastinnode, name, addtag;
		let userptagopened=false, lastnode, open_textnode, ftag, attsstr, atts, att, k, url, formatattstrarr, deletei, hashref, setnewa;
		
		// has textnodes
       	let hastextnodes=false;
        for(m=0; m<parr.length; m++){
            for(n=0; n<parr[m].length; n++){ 
                if(parr[m][n].name==='#text'){
                    hastextnodes=true;
                    break;
                }     
            }
        }
        // no textnodes
        if(hastextnodes===false){
			dom='<selstart></selstart><selend></selend>';
        // loop paragraphs
        }else{
			for(m=0; m<parr.length; m++){
				par=parr[m];
				firstnode=par[0];
				// preloop nodes 
				firstinnode=null;
				lastinnode=null;
				for(n=0; n<par.length; n++){
					node=par[n];
					if(node.selinfofirstin){
						firstinnode=node;
						userptagopened=true;
					}
					if(node.selinfolastin){
						lastinnode=node;
						userptagopened=false;
					}
				}
				pdom='';
				// open add paragraph tag
				if((tagtype=='paragraph' || tag==='erase') && (userptagopened || lastinnode!=null)){
					if(tag==='erase'){
						pdom+='<p>';
					}else{
						pdom+='<'+tag+'>';
					}
				// open paragraph
				}else if(firstnode.pformats.length>0){
					pdom+='<'+firstnode.pformats[0]+'>';
				}
				// loop text nodes 
				for(n=0; n<par.length; n++){
					node=par[n];
					name=node.name;
					// break
					if(name==='br'){
						if(node.pformats.length>0){
							pdom+='<br>';
						}else{
							pdom+='<p>';
							pdom+='&#8203;';
							pdom+='</p>';
						}
					}
					// selection marker
					if(name==='selstart'){
						pdom+='<selstart></selstart>';
					}
					if(name==='selend'){
						pdom+='<selend></selend>';
					}
					// text
					if(name==='#text'){
						// set new a
						setnewa=node.selinfo==='in' && tag==='a';
						
						// preloop formats collect allowed atts and hrefs in formatattstrarr
                        formatattstrarr=[];
						i=node.formats.length;
                        while(i--){
                            atts=node.atts[i];
							attsstr='';
							deletei=false;
							hashref=false;
							// collect and/or remove
                            for(k=0; k<atts.length; k++){
                                att=atts[k];
								// has href
								if(hashref===false){
									hashref=att.name==='href';
								}
								// is valid att name (todo: for tag name)
                                if(TEXTATTS.indexOf(att.name)!==-1){
                                    // remove a tag if href is empty or isnew a
                                    if(node.formats[i]==='a' && (setnewa || (att.name==='href' && att.value===''))){
                                        deletei=true;
									// just collect
                                    }else{
                                        attsstr+=' '+att.name+'="'+att.value+'"';
                                    }
                                }
                            }
							// remove a tag without attributes or more than 1 or no href
							if(!deletei && node.formats[i]==='a' && (atts.length===0 || atts.length>1 || hashref===false)){
								deletei=true;
							}
							
							// add to formatattstrarr or remove formattag
							if(deletei===true){
							    node.formats.splice(i, 1);
                                node.atts.splice(i, 1);
							}else{
								formatattstrarr.unshift(attsstr);
							}
							
							
                        }
						
						// add new text tag
						if(node.selinfo==='in' && tagtype==='tag' && node.formats.indexOf(tag)===-1){
							node.formats.push(tag);
							// set new href
							if(setnewa){
								url=TEXTEDITOR.urltf.value;
								formatattstrarr.push(' href="'+url+'"');
							}else{
								formatattstrarr.push('');
							}
						}
						
						// open tags if not: textnode is empty, has fillword & should be erased
						open_textnode=!(node.formats.indexOf('fillword')!==-1 && node.text.trim()==='') && !(node.selinfo==='in' && tag==='erase');
						if(open_textnode){  
							for(i=0; i<node.formats.length; i++){
								pdom+='<'+node.formats[i]+formatattstrarr[i]+'>';
							}
						}

						// fillword trim
						if(node.formats.indexOf('fillword')!==-1 && node.text.trim()!==''){
							node.text=node.text.trim();
						}

						// inner
						pdom+=node.text.replace('\r\n', '<br>');

						// close tags
						if(open_textnode){
							i=node.formats.length;
                            while(i--){
                                pdom+='</'+node.formats[i]+'>';
                            }
						}

						// fillword add space after
						if(!iscollapsed && node.formats.indexOf('fillword')!==-1){
							pdom+=' ';
						}

					}
				}
				// close paragraph tag
				if((tagtype=='paragraph' || tag==='erase') && (userptagopened || lastinnode!=null)){
					if(tag==='erase'){
						pdom+='</p>';
					}else{
						pdom+='</'+tag+'>';
					}
				// close paragraph
				}else if(firstnode.pformats.length>0){
					pdom+='</'+firstnode.pformats[0]+'>';
				}
				//
				dom+=pdom;
			}
		}
		
		// merge same tags loop
		for(n=0; n<TEXTFORMATS.length; n++){
			ftag=TEXTFORMATS[n];
			if(ftag!=='br' && ftag!='a'){
				dom=dom.split('</'+ftag+'><selstart></selstart><selend></selend><'+ftag+'>').join('<selstart></selstart><selend></selend>');
				dom=dom.split('</'+ftag+'><'+ftag+'>').join('');
			}
		}
		// delete empty tags loop
		for(n=0; n<TEXTFORMATS.length; n++){
			ftag=TEXTFORMATS[n];
			if(ftag!=='br' && ftag!='a'){
				dom=dom.split('<'+ftag+'><selstart></selstart><selend></selend></'+ftag+'>').join('<selstart></selstart><selend></selend>');
				dom=dom.split('<'+ftag+'></'+ftag+'>').join('');
			}
		}
		
		for(n=0; n<PARAGRAPHFORMATS.length; n++){
			ftag=PARAGRAPHFORMATS[n];
			dom=dom.split('<'+ftag+'><selstart></selstart></'+ftag+'>').join('<selstart></selstart>');
			dom=dom.split('<'+ftag+'><selend></selend></'+ftag+'>').join('<selend></selend>');
			dom=dom.split('<'+ftag+'><selstart></selstart><selend></selend></'+ftag+'>').join('<selstart></selstart><selend></selend>');
			dom=dom.split('<'+ftag+'></'+ftag+'>').join('');
		}
		
		// apply dom string
		rootel.innerHTML=dom;
		// replace arr
		if(rootel.hasAttribute('replace-arr')){
			const replacearr=rootel.getAttribute('replace-arr').split('¡');
			function replaceChars(_node){
				if(nodeName(_node)==="#text"){
					for(let n=0; n<replacearr.length; n+=2){
						_node.data=_node.data.split(replacearr[n]).join(replacearr[n+1]);
					}
				}
			}
			if(replacearr.length%2===0){
				loopChildNodes(rootel, replaceChars);
			}
		}
		// remove empty atags
		const emptyas=rootel.querySelectorAll('a:empty');
		n=emptyas.length;
		while(n--){
			REMOVE(emptyas[n]);
		}
		// remove all style attributes atags
		const styleels=rootel.querySelectorAll('*[style]');
		for(const stylel of styleels){
			styleel.removeAttribute('style');
		}
		// merge same a tags
		const atags=rootel.querySelectorAll('a');
		let a, prevtagname, inbetweenarr;
		n=atags.length;
		while(n--){
			a=atags[n];
			prevnode=a.previousSibling;
			if(prevnode!=null){
				prevtagname=(prevnode instanceof Element) ? prevnode.tagName.toLowerCase() : 'none';
				inbetweenarr=[];
				while(prevtagname==='selstart' || prevtagname==='selend'){
					if(prevtagname==='selstart'){
						inbetweenarr.push(prevnode);
					}
					if(prevtagname==='selend'){
						inbetweenarr.push(prevnode);
					}
					prevnode=prevnode.previousSibling;
					if(prevnode!=null){
						prevtagname=(prevnode instanceof Element) ? prevnode.tagName.toLowerCase() : 'none';
					}else{
						break;
					}
				}
				if(prevnode!=null && prevtagname==='a' && gA(prevnode, 'href')===gA(a, 'href')){
					for(i=0; i<inbetweenarr.length; i++){
						prevnode.insertAdjacentElement('beforeend', inbetweenarr[i]);
					}
					prevnode.innerHTML=prevnode.innerHTML+a.innerHTML;
					REMOVE(a);
				}
			}
		}
		// reset range
		startel=rootel.getElementsByTagName('selstart')[0];
        endel=rootel.getElementsByTagName('selend')[0];
		range.setStartAfter(startel);
       	range.setEndBefore(endel);
		// bugfix firefox
		if(range.collapsed && endel===rootel.lastElementChild){
			const parels=rootel.querySelectorAll('*:not(selstart):not(selend)');
			if(parels.length>0){
				const lastparel=parels[parels.length-1];
				lastparel.appendChild(startel);
				lastparel.appendChild(endel);
			}
		}
		//
        range.setStartAfter(startel);
       	range.setEndBefore(endel);
        REMOVE(startel);
        REMOVE(endel);
        document.getSelection().removeAllRanges();
        document.getSelection().addRange(range); 
		document.getSelection().removeAllRanges();
        document.getSelection().addRange(range); 
		TEXTEDITOR.modulrange=getRange();
		
		// check Emptyness
		TEXTEDITOR.checkEmptyness(rootel);
		// save to history
		if(_historymode==='delayed'){
			clearTimeout(TEXTEDITOR.history_timer);
			TEXTEDITOR.history_timer=setTimeout(TEXTEDITOR.history_addTo, 1500, TEXTEDITOR.rootel, TEXTEDITOR.rootel.innerHTML);
		}else if(_historymode!=='prevent'){
			TEXTEDITOR.history_addTo(TEXTEDITOR.rootel, TEXTEDITOR.rootel.innerHTML);
		}
		// CALLBACK
		if(rootel.hasAttribute('onformatrange-callback')){
			callWindowCallback(rootel.getAttribute('onformatrange-callback'), rootel);
		}
		
    }
}
// HISTORY
TEXTEDITOR.history_goBack=function(_rootel){
	//console.log('TEXTEDITOR.history_goBack');
	if(_rootel!=null && _rootel.hasOwnProperty('ff_history') && _rootel.ff_history.length>1){
		TEXTEDITOR.temporarilyDeactivateSelectionChangeHandler();
		_rootel.ff_history_index=_rootel.ff_history_index===0 ? 0 : _rootel.ff_history_index-1;
		_rootel.innerHTML=_rootel.ff_history[_rootel.ff_history_index];
	}
}
TEXTEDITOR.history_goForward=function(_rootel){
	//console.log('TEXTEDITOR.history_goForward');
	if(_rootel!=null && _rootel.hasOwnProperty('ff_history') && _rootel.ff_history.length>1){
		TEXTEDITOR.temporarilyDeactivateSelectionChangeHandler();
		_rootel.ff_history_index=_rootel.ff_history_index>=_rootel.ff_history.length-1 ? _rootel.ff_history.length-1 : _rootel.ff_history_index+1;
		_rootel.innerHTML=_rootel.ff_history[_rootel.ff_history_index];
	}
}
TEXTEDITOR.history_addTo=function(_rootel, _html){
	//console.log('TEXTEDITOR.history_addTo');
	// init
	if(!_rootel.hasOwnProperty('ff_history')){
		_rootel.ff_history=[];
		_rootel.ff_history_index=0;
	}
	// check if has changed
	if(_rootel.ff_history[_rootel.ff_history_index]!==_html){
		// delete "future"
		const futurecount=_rootel.ff_history.length-1-_rootel.ff_history_index;
		if(futurecount>0){
			_rootel.ff_history.splice(_rootel.ff_history_index+1, futurecount);
		}
		// add
		_rootel.ff_history.push(_html);
		// limit
		if(_rootel.ff_history.length>TEXTEDITOR.history_max){
			_rootel.ff_history.splice(0, 1);
		}
		// update current index
		_rootel.ff_history_index=_rootel.ff_history.length-1;
	}
}
// HANDLER ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  MOUSE DOWN HAND
window.addEventListener('mousedown', mDown_hand);
window.addEventListener('touchstart', mDown_hand);
function mDown_hand(e){
	const t=e.target;
	const toolbar=t.closest('.toolbar_texteditor');
	const urltfbox=t.closest('.urltfbox');
	// prevent deselection
	if(toolbar!==null || (urltfbox!==null && e.target.classList.contains('urltf')===false)){
	 	e.preventDefault();
	}
	
	// texteditor fade out and make editable / outside click...
	if(toolbar===null && urltfbox===null){
		TEXTEDITOR.toolbar_hide();
		TEXTEDITOR.urltfbox_hide();
        // contenteditable
        if(TEXTEDITOR.rootel!==null){
            TEXTEDITOR.rootel.setAttribute('contenteditable', 'false');
			TEXTEDITOR.toolbar_hide();
			if(TEXTEDITOR.rootel.hasAttribute("ref-texteditor-toolbar-id")){
				const reftexteditors=document.querySelectorAll('*[texteditor-toolbar-id="'+TEXTEDITOR.rootel.getAttribute("ref-texteditor-toolbar-id")+'"]');
				if(reftexteditors.length>0){
					reftexteditors[0].removeAttribute('is-current-texteditor-toolbar');
				}
			}
        } 
		const pot_rootel=t.closest('*[contenteditable][editor-tags]');
        TEXTEDITOR.rootel=pot_rootel;
        if(TEXTEDITOR.rootel!==null){
            TEXTEDITOR.rootel.setAttribute('contenteditable', 'true');
			TEXTEDITOR.toolbar_show();
			if(TEXTEDITOR.rootel.hasAttribute("ref-texteditor-toolbar-id")){
				const reftexteditors=document.querySelectorAll('*[texteditor-toolbar-id="'+TEXTEDITOR.rootel.getAttribute("ref-texteditor-toolbar-id")+'"]');
				if(reftexteditors.length>0){
					reftexteditors[0].setAttribute('is-current-texteditor-toolbar', '');
				}
			}
        }
	}
	// urltf link bt
	if(t.closest('.iconbt_a')!==null){
		TEXTEDITOR.urltfbox_show();
	}
	// urltf confirm bt
	if(t.closest('.urltfconfirm')!==null){
		TEXTEDITOR.urltfbox_confirm();
	}
	// tag buttons 
	if(t.hasAttribute('format-tag')){ 
        const tag=t.getAttribute('format-tag');
        if(TEXTEDITOR.modulrange!=null){
			formatRange(TEXTEDITOR.modulrange, tag, 'instantly');
        }
    }
}
// KEY DOWN HAND
document.addEventListener('keydown', keyDown_hand);
document.addEventListener('keyup', keyUp_hand); 
let KEYS=[];
function checkKey(keytocheck){
	return KEYS.indexOf(keytocheck)!==-1;
}
function keyDown_hand(e){
    const key=e.key;
    if(KEYS.indexOf(String(key))===-1){
        KEYS.push(String(key));
    }
	// confirm urltf
	if(checkKey('Enter') && TEXTEDITOR.urltfbox.hasAttribute('is-active')){
		e.preventDefault();
		TEXTEDITOR.urltfbox_confirm();
	}
	// strg + z
	if(checkKey('Control') && checkKey('z')){
		TEXTEDITOR.history_goBack(TEXTEDITOR.rootel);
	}
	// strg + y
	if(checkKey('Control') && checkKey('y')){
		TEXTEDITOR.history_goForward(TEXTEDITOR.rootel);
	}
}
function keyUp_hand(e){
    const key=e.key;
    const index=KEYS.indexOf(String(key));
    if(index!==-1){
        KEYS.splice(index, 1);
    }
}
// SELECTION CHANGE HAND
document.addEventListener('selectionchange', selectionChange_hand);
function selectionChange_hand(e){
	if(TEXTEDITOR.SELECTION_CHANGE_ON===true){
		 // hide / show toolbar
		if(TEXTEDITOR.toolbar!=null && document.activeElement.closest('*[editor-tags]')!==null){
			//set range
			TEXTEDITOR.modulrange=getRange();
			/*
			if(TEXTEDITOR.modulrange!=null && !TEXTEDITOR.modulrange.collapsed){
				TEXTEDITOR.toolbar_show();
			}else{
				TEXTEDITOR.toolbar_hide();
			}*/
		}
	}
   
}
// HELPER ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
// helper
function getRange(){
    const sel=document.getSelection();
    let range=null;
    if(sel!=null && sel.rangeCount){
        range=sel.getRangeAt(0);
    }
    return range;
}
function nodeName(node){
    return node.nodeName.toLowerCase();
}
function unWrap(el) {
    const p=el.parentElement;
    while(el.firstChild) {
        p.insertBefore(el.firstChild, el);
    }
    p.removeChild(el);
    return p;
}
function loopChildNodes(node, func) {
    let i=0, child=null;
    for(i=0; i<node.childNodes.length; i++) {
      child=node.childNodes[i];
      loopChildNodes(child, func);
      func(child);
    }
}
function makePlain(node){
    if(nodeName(node)!=="#text"){
        unWrap(node);
    }
}	

// updateSelTextBoxInfos
function updateSelTextBoxInfos(){
    //console.log('updateSelTextBoxInfos', 'TEXTEDITOR.modulrange', TEXTEDITOR.modulrange);
    SEL_TEXTBOX_INFOS={};
    SEL_TEXTBOX_INFOS.parr=[];
    SEL_TEXTBOX_INFOS.selinfo='before';
	SEL_TEXTBOX_INFOS.selinfo_last='before';
	SEL_TEXTBOX_INFOS.selinfolastin=false;
	SEL_TEXTBOX_INFOS.p=null;
    SEL_TEXTBOX_INFOS.lastp=null;
    loopChildNodes(TEXTEDITOR.rootel, collectTextInfo);
	// force closed selinfos
	if(SEL_TEXTBOX_INFOS.selinfo_last==='before' || SEL_TEXTBOX_INFOS.selinfo_last==='in'){
		const lastpar=SEL_TEXTBOX_INFOS.parr[SEL_TEXTBOX_INFOS.parr.length-1];
		const firstpar=SEL_TEXTBOX_INFOS.parr[0];
		if(lastpar.length>=1){
			const lasttextobj=lastpar[lastpar.length-1];
			if(SEL_TEXTBOX_INFOS.selinfo_last==='before'){
				lasttextobj.selinfofirstin=true;
			}
			lasttextobj.selinfolastin=true;
			lasttextobj.selinfo_last='in';
		}
	}
}
function cleanNodeText(_nodetext){
	if(_nodetext!=null){
		return _nodetext.split('&nbsp;').join(' ');
	}
	return '';
}
function collectTextInfo(_node){
    let textobj={}, name=nodeName(_node), i=0, value=_node.nodeValue, lastpar, lasttextobj, formatatts;
	lastpar=null;
    lasttextobj=null;
    if(SEL_TEXTBOX_INFOS.parr.length!==0){
        lastpar=SEL_TEXTBOX_INFOS.parr[SEL_TEXTBOX_INFOS.parr.length-1];
        if(lastpar.length>=1){
            lasttextobj=lastpar[lastpar.length-1];
        }
    }
    if(name==='selstart'){
       SEL_TEXTBOX_INFOS.selinfo='in';     
    }
    if(name==='selend'){
       SEL_TEXTBOX_INFOS.selinfo='after';     
    }
    if(name==='#text' || name==='br' || name==='selstart' || name==='selend'){
		
		textobj={};
		// selin fos
		textobj.selinfofirstin=false;
		textobj.selinfolastin=false;
		if(SEL_TEXTBOX_INFOS.selinfo==='in' && SEL_TEXTBOX_INFOS.selinfo_last==='before'){
			textobj.selinfofirstin=true;
		}
		if(SEL_TEXTBOX_INFOS.selinfo==='after' && SEL_TEXTBOX_INFOS.selinfo_last==='before'){
			textobj.selinfofirstin=true;
			textobj.selinfolastin=true;
		}
		if(SEL_TEXTBOX_INFOS.selinfo==='after' && SEL_TEXTBOX_INFOS.selinfo_last==='in'){
			if(lasttextobj!=null){
				lasttextobj.selinfolastin=true;
			}
		}
		textobj.selinfo=SEL_TEXTBOX_INFOS.selinfo;
	
		// if has no paragraphs yet force p as default paragraph
        textobj.pformats=getParagraphFormats(_node, TEXTEDITOR.rootel);
		if(name==='#text' && textobj.pformats.length===0){
			textobj.pformats.push('p');
		}
		// textobj formats and attributes
		formatatts=getTextFormatsAndAtts(_node, TEXTEDITOR.rootel)
        textobj.formats=formatatts[0];
		textobj.atts=formatatts[1];
		// textobj textvalue
        textobj.text=cleanNodeText(value);
		// textobj name
		textobj.name=name;
		// group same paragraphs
		if(textobj.pformats.length>0){
			SEL_TEXTBOX_INFOS.p=_node.parentElement.closest(textobj.pformats[0]);
			if(lastpar!=null && SEL_TEXTBOX_INFOS.p===SEL_TEXTBOX_INFOS.lastp){
			    lastpar.push(textobj);
			}else{
				SEL_TEXTBOX_INFOS.parr.push([textobj]);
			}
		}else{
			SEL_TEXTBOX_INFOS.parr.push([textobj]);
		}
		// last updates
        SEL_TEXTBOX_INFOS.lastp=SEL_TEXTBOX_INFOS.p;
		SEL_TEXTBOX_INFOS.selinfo_last=SEL_TEXTBOX_INFOS.selinfo;
    }
}
function getParagraphFormats(_textnode, _rootel){
    let formats=[], name='';
    let node=_textnode.parentElement;
    while(node!=null && node!==_rootel){
        name=nodeName(node);
		// force divs to p
		if(name==='div'){
			name='p';
		}
        if(PARAGRAPHFORMATS.indexOf(name)!==-1 && formats.indexOf(name)===-1){
            formats.push(name);
        }
        node=node.parentElement;
    }
    return formats;
}
function getTextFormatsAndAtts(_textnode, _rootel){
    let formats=[], atts=[], name='', n, index;
    let node=_textnode.parentElement, color_is_already_set=false;
    while(node!=null && node!==_rootel){
        name=nodeName(node);
        if(TEXTFORMATS.indexOf(name)!==-1 && formats.indexOf(name)===-1){
			// collect only first color...
			if(name.substr(0,5)==='color'){
				if(color_is_already_set===false){
					formats.push(name);
					atts.push(node.attributes);
					color_is_already_set=true;
				}
			}else{
				formats.push(name);
				atts.push(node.attributes);
			}
           
        }
        node=node.parentElement;
    }
    return [formats, atts];
}
})();