
let COMPONENTS=[];

// sett Attributes
function setAttributes(el, attributes) {
 	for(var key in attributes){
	  el.setAttribute(key, attributes[key]);
 	}
}
// GRID
function getGridColumnCount(el){
	return window.getComputedStyle(el).getPropertyValue('grid-template-columns').split(' ').length;
}
// WINDOW CALLBACKS
function callWindowCallback(str, e){
	let parts=str.split('.');
    if(parts.length===1){
        window[parts[0]](e);
    }
    if(parts.length===2){
        window[parts[0]][parts[1]](e);
    }
    if(parts.length===3){
        window[parts[0]][parts[1]][parts[2]](e);
    }
	if(parts.length===4){
        window[parts[0]][parts[1]][parts[2]][parts[3]](e);
    }
	if(parts.length===5){
        window[parts[0]][parts[1]][parts[2]][parts[3]][parts[4]](e);
    }
}
// MEDIA
function rMedia(mediaid){
	let src='';
	if(mediaid.substr(0, 5)==='https'){
		src=mediaid;
	}else{
		src=HTMLRELPATH+'data/media/'+mediaid;
	}
	const media='<img src="'+src+'" alt=""/>';
	return '<div class="media" view-mode="contain">'+media+'</div>';	
};

// SET HOVER ATTRIBUTE
function setIsHoveredAttribute(el){
	removeAllIsHoveredAttributes();
	if(!el.hasAttribute('is-hovered')){
		el.setAttribute('is-hovered', '');
		el.addEventListener('mouseout', removeAllIsHoveredAttributes);
	}
}
function removeAllIsHoveredAttributes(){
	const hoverels=document.querySelectorAll('*[is-hovered]');
	for(let hoverel of hoverels){
		hoverel.removeAttribute('is-hovered');
	}
} 

// MOUSE
const MOUSE={isoutside:false, overtraget:null, x:0, y:0, istouch:false};
document.addEventListener('mouseout', mOut_hand);
document.addEventListener('mouseover', mOver_hand);
window.addEventListener('mousemove', mMove_hand);
function mMove_hand(e){
	if(e.movementX!==0 || e.movementY!==0){
		MOUSE.istouch=false;
		MOUSE.x=e.clientX;
		MOUSE.y=e.clientY;
	}else{
		MOUSE.istouch=true;
	}
}
function mOut_hand(e){
	MOUSE.isoutside=true;
	MOUSE.overtarget=null;
}
function mOver_hand(e){
	MOUSE.isoutside=false;
	MOUSE.overtarget=e.target;
}

// CONTROLS
const CONTROLS={mouseobj:null, mouseobj_last:null, mousedownobj:null, mousemovecount:0, touchobjs:[], touchobjs_last:[], touchdownobjs:[], dragobj:null, dragobj_last:null, pinchobj:null, orientation:null, wheelobj:null, lastinteraction: '', IN_TOUCH_MODE:true};
const DRAG_FUNCS=[];
const WHEEL_FUNCS=[];
const DRAG_END_FUNCS=[];
const cssroot= document.querySelector(':root');
function setTouchMode(bol){
	CONTROLS.IN_TOUCH_MODE=bol;
}

let tsn=0; 
let tss, ts, ts2, tmpdragobj, tmpdragobj_last;
window.addEventListener('mousedown', mouseDown_hand, {passive: false});
window.addEventListener('mousemove', mouseMove_hand, {passive: false});
window.addEventListener('mouseup', mouseUp_hand, {passive: false});
window.addEventListener('wheel', mouseWheel_hand, {passive: false});
window.addEventListener('touchstart', touchStart_hand, {passive: false});
window.addEventListener('touchmove', touchMove_hand, {passive: false});
window.addEventListener('touchend', touchEnd_hand, {passive: false});
window.addEventListener('deviceorientation', deviceOrientation_hand);

if(/Mac|iPad|iPhone|iPod/.test(navigator.userAgent)){
    document.addEventListener('touchmove', function(event){
        if(event.scale!==1){
          //event.preventDefault();
          //document.body.style.transform='scale(1)';
        }
    }, {passive:false});
}

function mouseDown_hand(e){
	CONTROLS.lastinteraction='mousedown';
    CONTROLS.mousemovecount=0;
    CONTROLS.mouseobj={target:e.target, clientX:e.clientX, clientY:e.clientY, timestamp: performance.now() };
    CONTROLS.mouseobj_last={target:e.target, clientX:e.clientX, clientY:e.clientY, timestamp:CONTROLS.mouseobj.timestamp };
    CONTROLS.mousedownobj={target:e.target, clientX:e.clientX, clientY:e.clientY };
}
function mouseMove_hand(e){
	if((e.movementX!==0 || e.movementY!==0) && !e.hasOwnProperty('touches') && CONTROLS.lastinteraction!=='touchend'){
		setTouchMode(false);
		CONTROLS.lastinteraction='mousemove';
		CONTROLS.mousemovecount++;
		CONTROLS.mouseobj={target:e.target, clientX:e.clientX, clientY:e.clientY, timestamp:performance.now() };
		if(CONTROLS.mousedownobj!==null){
			DRAG(e);
		}
		CONTROLS.mouseobj_last={target:e.target, clientX:e.clientX, clientY:e.clientY, timestamp:CONTROLS.mouseobj.timestamp };
	}
}
function mouseUp_hand(e){
	CONTROLS.lastinteraction='mouseup';
    CONTROLS.mouseobj={target:e.target, clientX:e.clientX, clientY:e.clientY, timestamp:performance.now() };
    CONTROLS.mousedownobj=null;
    //if(CONTROLS.mousemovecount>=1){
        DRAG_END();
        CONTROLS.mousemovecount=0;
    //}
    CONTROLS.mouseobj_last={target:e.target, clientX:e.clientX, clientY:e.clientY,timestamp:CONTROLS.mouseobj.timestamp };
}
function touchStart_hand(e){
	setTouchMode(true);
	CONTROLS.lastinteraction='touchstart';
    CONTROLS.touchobjs.length=0;
    CONTROLS.touchobjs_last.length=0;
    CONTROLS.touchdownobjs.length=0;
    tss=e.touches;
    for(tsn=0; tsn<tss.length; tsn++){
        ts=tss[tsn];
        CONTROLS.touchdownobjs.push({target:ts.target, clientX:ts.clientX, clientY:ts.clientY, timestamp:performance.now()});
        CONTROLS.touchobjs.push({target:ts.target, clientX:ts.clientX, clientY:ts.clientY, timestamp:CONTROLS.touchdownobjs[tsn].timestamp});
        CONTROLS.touchobjs_last.push({target:ts.target, clientX:ts.clientX, clientY:ts.clientY, timestamp:CONTROLS.touchdownobjs[tsn].timestamp});
    }
}                          
function touchMove_hand(e){
	setTouchMode(true);
	CONTROLS.lastinteraction='touchmove';
	CONTROLS.touchobjs.length=0;
    tss=e.touches;
    for(tsn=0; tsn<tss.length; tsn++){
        ts=tss[tsn];
        CONTROLS.touchobjs.push({target:ts.target, clientX:ts.clientX, clientY:ts.clientY, timestamp:performance.now()});
    }
    DRAG(e);
    CONTROLS.touchobjs_last.length=0;
    tss=e.touches;
    for(tsn=0; tsn<tss.length; tsn++){
        ts=tss[tsn];
        CONTROLS.touchobjs_last.push({target:ts.target, clientX:ts.clientX, clientY:ts.clientY, timestamp:CONTROLS.touchobjs[tsn].timestamp});
    }

}  
function touchEnd_hand(e){
	setTouchMode(true);
	CONTROLS.lastinteraction='touchend';
	CONTROLS.touchobjs.length=0;
    tss=e.touches;
    for(tsn=0; tsn<tss.length; tsn++){
        ts=tss[tsn];
        CONTROLS.touchobjs.push({target:ts.target, clientX:ts.clientX, clientY:ts.clientY, timestamp:performance.now()});
    }
    if(DRAG_END()==='preventDefault'){
		e.preventDefault();
	}
	CONTROLS.touchobjs_last.length=0;
    tss=e.touches;
    for(tsn=0; tsn<tss.length; tsn++){
        ts=tss[tsn];
        CONTROLS.touchobjs_last.push({target:ts.target, clientX:ts.clientX, clientY:ts.clientY, timestamp:CONTROLS.touchobjs[tsn].timestamp});
    }
} 

function deviceOrientation_hand(e){
   	CONTROLS.orientation={alpha:e.alpha, beta:e.beta, gamma:e.gamma};
}
function mouseWheel_hand(e){
	CONTROLS.lastinteraction='mousewheel';
	let n=WHEEL_FUNCS.length;
	CONTROLS.wheelobj={deltaY:e.deltaY, deltaX:e.deltaX, target:e.target};
    while(n--){
        WHEEL_FUNCS[n]();
    }
	CONTROLS.wheelobj=null;
}
function DRAG(e){
    let n=DRAG_FUNCS.length;
	let pinchdelta=0;
	let pinchdist=0;
	let pinchdist_last=0;
	let pinchdistdelta=0;
	let pinchdistfactor=1;
	let pinchmx=0;
	let pinchmy=0;
	let pinchmx_last=0;
	let pinchmy_last=0;
	let pinchrot=0;
	let pinchrot_last=0;
	let dragfuncreturn;
	let currenttime=performance.now();
	CONTROLS.pinchobj=null;
    // single mouse drag
    if(CONTROLS.mousedownobj!==null){
        ts=CONTROLS.mouseobj;
        CONTROLS.dragobj={
			target:ts.target, 
			clientX:ts.clientX, 
			clientY:ts.clientY, 
			dragdowns:1, 
			downtarget:CONTROLS.mousedownobj.target, 
			deltax:CONTROLS.mouseobj.clientX-CONTROLS.mouseobj_last.clientX, 
			deltay:CONTROLS.mouseobj.clientY-CONTROLS.mouseobj_last.clientY,
			deltatime:CONTROLS.mouseobj.timestamp-CONTROLS.mouseobj_last.timestamp
		};
        ts=CONTROLS.mouseobj_last;
        CONTROLS.dragobj_last={
			target:ts.target, 
			clientX:ts.clientX, 
			clientY:ts.clientY,
			dragdowns:1
		};
    // single finger drag
    }else if(CONTROLS.touchobjs.length===1 && CONTROLS.touchobjs_last.length===1){
        ts=CONTROLS.touchobjs[0];
        CONTROLS.dragobj={
			target:ts.target, 
			clientX:ts.clientX, 
			clientY:ts.clientY, 
			dragdowns:1, 
			downtarget:CONTROLS.touchdownobjs[0].target, 
			deltax:CONTROLS.touchobjs[0].clientX-CONTROLS.touchobjs_last[0].clientX, 
			deltay:CONTROLS.touchobjs[0].clientY-CONTROLS.touchobjs_last[0].clientY,
			deltatime:CONTROLS.touchobjs[0].timestamp-CONTROLS.touchobjs_last[0].timestamp
			
		};
        ts=CONTROLS.touchobjs_last[0];
        CONTROLS.dragobj_last={
			target:ts.target, 
			clientX:ts.clientX, 
			clientY:ts.clientY, 
			dragdowns:1
		};
	// two finger drag
    }else if(CONTROLS.touchobjs.length===2 && CONTROLS.touchobjs_last.length===2){
        ts=CONTROLS.touchobjs[0];
        ts2=CONTROLS.touchobjs[1];
        CONTROLS.dragobj={
			target:ts.target, 
			clientX:ts.clientX, 
			clientY:ts.clientY, 
			dragdowns:2, 
			target2:ts2.target, 
			clientX2:ts2.clientX, 
			clientY2:ts2.clientY, 
			clientXM:ts.clientX+(ts.clientX-ts2.clientX)/2, 
			clientYM:ts.clientY+(ts.clientY-ts2.clientY)/2, 
			downtarget:CONTROLS.touchdownobjs[0].target, 
			downtarget2:ts2.target, 
			deltax:CONTROLS.touchobjs[0].clientX-CONTROLS.touchobjs_last[0].clientX, 
			deltay:CONTROLS.touchobjs[0].clientY-CONTROLS.touchobjs_last[0].clientY, 
			deltax2:CONTROLS.touchobjs[1].clientX-CONTROLS.touchobjs_last[1].clientX, 
			deltay2:CONTROLS.touchobjs[1].clientY-CONTROLS.touchobjs_last[1].clientY,
			deltatime:CONTROLS.touchobjs[0].timestamp-CONTROLS.touchobjs_last[0].timestamp
		};
        ts=CONTROLS.touchobjs_last[0];
        ts2=CONTROLS.touchobjs_last[1];
        CONTROLS.dragobj_last={
			target:ts.target, 
			clientX:ts.clientX, 
			clientY:ts.clientY, 
			dragdowns:2, 
			target2:ts2.target, 
			clientX2:ts2.clientX, 
			clientY2:ts2.clientY, 
			clientXM:ts.clientX+(ts.clientX-ts2.clientX)/2,
			clientYM:ts.clientY+(ts.clientY-ts2.clientY)/2
		};
		pinchdistX=CONTROLS.dragobj.clientX-CONTROLS.dragobj.clientX2;
		pinchdistY=CONTROLS.dragobj.clientY-CONTROLS.dragobj.clientY2;
		pinchdistX_last=CONTROLS.dragobj_last.clientX-CONTROLS.dragobj_last.clientX2;
		pinchdistY_last=CONTROLS.dragobj_last.clientY-CONTROLS.dragobj_last.clientY2;
		pinchdist=Math.sqrt(Math.pow(pinchdistX, 2)+Math.pow(pinchdistY, 2));
		pinchdist_last=Math.sqrt(Math.pow(pinchdistX_last, 2)+Math.pow(pinchdistY_last, 2));
		pinchdistdelta=pinchdist-pinchdist_last;
		pinchdistfactor=pinchdist/pinchdist_last;
		pinchmx=CONTROLS.dragobj.clientX2+pinchdistX/2;
		pinchmy=CONTROLS.dragobj.clientY2+pinchdistY/2;
		pinchmx_last=CONTROLS.dragobj_last.clientX2+pinchdistX_last/2;
		pinchmy_last=CONTROLS.dragobj_last.clientY2+pinchdistY_last/2;
		pinchrot=Math.atan2(pinchdistY, pinchdistX)*(180/Math.PI);
		pinchrot_last=Math.atan2(pinchdistY_last, pinchdistX_last)*(180/Math.PI);
		CONTROLS.pinchobj={
			dist:pinchdist, 
			distx_last:pinchdistX_last, 
			distxdelta:pinchdistX-pinchdistX_last, 
			distfactorx:pinchdistX/pinchdistX_last,
			disty_last:pinchdistY_last, 
			distydelta:pinchdistY-pinchdistY_last, 
			distfactory:pinchdistY/pinchdistY_last,
			dist_last:pinchdist_last, 
			distdelta:pinchdistdelta, 
			distfactor:pinchdistfactor, 
			mx:pinchmx, 
			my:pinchmy, 
			mx_last:pinchmx_last, 
			my_last:pinchmy_last, 
			mdeltax:pinchmx-pinchmx_last, 
			mdeltay:pinchmy-pinchmy_last, 
			rot:pinchrot, 
			rot_last:pinchrot_last, 
			rotdelta:pinchrot-pinchrot_last
		};
    // no drag
    }else{
        CONTROLS.dragobj=null;
        CONTROLS.dragobj_last=null;
		CONTROLS.pinchobj=null;
    }
    if(CONTROLS.dragobj!==null){
        while(n--){
			dragfuncreturn=DRAG_FUNCS[n]();
            if(dragfuncreturn==='prevent'){
                  e.preventDefault();
                  e.stopPropagation();
                  break;
            }else if(dragfuncreturn==='break'){
                break;
           }
         }
    }
}
function DRAG_END(){
    let n=DRAG_END_FUNCS.length;
    while(n--){
		const returncmd=DRAG_END_FUNCS[n]();
        if(returncmd==='break'){
            break;
        }
		if(returncmd==='prevent'){
			return 'prevent';
		}
    }
}
// WHEEL-ABLE
document.addEventListener("DOMContentLoaded", makeAllWheelAble);
function makeAllWheelAble(){
	const wheelableels=document.querySelectorAll('*[wheel-able]:not([wheel-able-state])');
	for(const el of wheelableels){
		makeWheelAble(el);
	}
}
function makeWheelAble(wheelableel){
	if(!wheelableel.hasAttribute('wheel-able-state')){
		wheelableel.setAttribute('wheel-able-state', 'initialized');
		makeTransEl(wheelableel);
	}
}
WHEEL_FUNCS.push(wheelable_onWheel);
function wheelable_onWheel(){
	let delta=CONTROLS.wheelobj.deltaY;
	
}
// TOUCH-ABLE
const TOUCHABLES={
	touchable_ui: null,
	rotate_grabber: null,
	rotate_button: null,
	scale_grabber: null,
	delete_button: null,
	border_rectangle: null,
	mousetransmode: '',
	target: null,
	mousovertarget: null,
	momentumtargets: [],
	lastticktime:0,
	prevent_mousedown:false,
	updateUI: function(){
		if(TOUCHABLES.target!==null){
			const options=TOUCHABLES.target.getAttribute('touch-able').split(' ');
			const trans=getTransObj(TOUCHABLES.target);
			const uipoints=getGlobals(TOUCHABLES.target, {
				s: {x:TOUCHABLES.target.offsetWidth, y:TOUCHABLES.target.offsetHeight, z:0},
				r: {x:TOUCHABLES.target.offsetWidth/2, y:0, z:0},
				d: {x:TOUCHABLES.target.offsetWidth/2, y:TOUCHABLES.target.offsetHeight, z:0},
				e: {x:0, y:0, z:0},
				f: {x:TOUCHABLES.target.offsetWidth, y:0, z:0}
			});
			
			
			
			TOUCHABLES.border_rectangle.style.transform='translate3d('+trans.gx+'px,'+trans.gy+'px, 0px) rotate('+trans.grot+'deg)';
			TOUCHABLES.border_rectangle.style.width=TOUCHABLES.target.offsetWidth*trans.gscx+'px';
			TOUCHABLES.border_rectangle.style.height=TOUCHABLES.target.offsetHeight*trans.gscy+'px';
			if(options.includes('rotategrabber')){
				TOUCHABLES.rotate_grabber.style.display='block';
				TOUCHABLES.rotate_grabber.style.transform='translate3d('+(uipoints.r.x)+'px,'+(uipoints.r.y)+'px, 0px) rotate('+trans.grot+'deg)';
			}else{
				TOUCHABLES.rotate_grabber.style.display='none';
			}
			if(options.includes('rotatebutton')){
				TOUCHABLES.rotate_button.style.display='block';
				TOUCHABLES.rotate_button.style.transform='translate3d('+(uipoints.r.x)+'px,'+(uipoints.r.y)+'px, 0px) rotate('+trans.grot+'deg)';
			}else{
				TOUCHABLES.rotate_button.style.display='none';
			}
			if(options.includes('indexbuttondown')){
				TOUCHABLES.index_button_down.style.display='block';
				TOUCHABLES.index_button_down.style.setProperty('--scope-transform-rotate', trans.grot+'deg');
				TOUCHABLES.index_button_down.style.transform='translate3d('+(uipoints.e.x)+'px,'+(uipoints.e.y)+'px, 0px) rotate('+trans.grot+'deg)';
			}else{
				TOUCHABLES.index_button_down.style.display='none';
			}
			if(options.includes('indexbuttonup')){
				TOUCHABLES.index_button_up.style.display='block';
				TOUCHABLES.index_button_up.style.setProperty('--scope-transform-rotate', trans.grot+'deg');
				TOUCHABLES.index_button_up.style.transform='translate3d('+(uipoints.f.x)+'px,'+(uipoints.f.y)+'px, 0px) rotate('+trans.grot+'deg)';
			}else{
				TOUCHABLES.index_button_up.style.display='none';
			}
			if(options.includes('deletebutton')){
				TOUCHABLES.delete_button.style.display='block';
				TOUCHABLES.delete_button.style.setProperty('--scope-transform-rotate', trans.grot+'deg');
				TOUCHABLES.delete_button.style.transform='translate3d('+(uipoints.d.x)+'px,'+(uipoints.d.y)+'px, 0px) rotate('+trans.grot+'deg)';
			}else{
				TOUCHABLES.delete_button.style.display='none';
			}
			if(options.includes('scalegrabber')){
				TOUCHABLES.scale_grabber.style.display='block';
				TOUCHABLES.scale_grabber.style.transform='translate3d('+(uipoints.s.x)+'px,'+(uipoints.s.y)+'px, 0px) rotate('+trans.grot+'deg)';
			}else{
				TOUCHABLES.scale_grabber.style.display='none';
			}
			if(TOUCHABLES.touchable_ui.style.display!=='block'){
				TOUCHABLES.touchable_ui.style.display='block';
			}
			// show hide
			
		}else{
			if(TOUCHABLES.touchable_ui.style.display==='block'){
				TOUCHABLES.touchable_ui.style.display='none';
			}
		}
	}
}
document.addEventListener('DOMContentLoaded', makeAllTouchAble);
document.addEventListener('touchstart', touchables_mouseDown_touchStart_hand);
document.addEventListener('mousedown', touchables_mouseDown_touchStart_hand);
document.addEventListener('scroll', touchables_Scroll_hand);
document.addEventListener('mousemove', touchables_mouseMove);
window.addEventListener('resize', touchables_Resize_hand);
DRAG_FUNCS.push(touchable_onDRAG);
DRAG_END_FUNCS.push(touchable_onDRAG_END);
WHEEL_FUNCS.push(touchable_onMousewheel);

function makeAllTouchAble(){
	// intitalize touchable ui
	if(TOUCHABLES.touchable_ui===null){
		// mouse over target
		TOUCHABLES.mouseovertarget=null;
		// touchable ui
		TOUCHABLES.touchable_ui=document.createElement('DIV');
		TOUCHABLES.touchable_ui.classList.add('touchable_ui');
		TOUCHABLES.touchable_ui.setAttribute('aria-hidden', 'true');
		TOUCHABLES.touchable_ui.style='position:fixed; top:0px; left:0px; width:100%; height:100%; pointer-events:none; z-index:99999; display:none;';
		document.body.appendChild(TOUCHABLES.touchable_ui);
		// rotate grabber
		TOUCHABLES.rotate_grabber=document.createElement('DIV');
		TOUCHABLES.rotate_grabber.classList.add('rotate_grabber');
		TOUCHABLES.rotate_grabber_icon=document.createElement('DIV');
		TOUCHABLES.rotate_grabber_icon.classList.add('rotate_grabber_icon');
		TOUCHABLES.rotate_grabber.appendChild(TOUCHABLES.rotate_grabber_icon);
		TOUCHABLES.touchable_ui.appendChild(TOUCHABLES.rotate_grabber);
		// rotate button
		TOUCHABLES.rotate_button=document.createElement('DIV');
		TOUCHABLES.rotate_button.classList.add('rotate_button');
		TOUCHABLES.rotate_button_icon=document.createElement('DIV');
		TOUCHABLES.rotate_button_icon.classList.add('rotate_button_icon');
		TOUCHABLES.rotate_button.appendChild(TOUCHABLES.rotate_button_icon);
		TOUCHABLES.touchable_ui.appendChild(TOUCHABLES.rotate_button);
		// index button down
		TOUCHABLES.index_button_down=document.createElement('DIV');
		TOUCHABLES.index_button_down.classList.add('index_button_down');
		TOUCHABLES.index_button_down_icon=document.createElement('DIV');
		TOUCHABLES.index_button_down_icon.classList.add('index_button_down_icon');
		TOUCHABLES.index_button_down.appendChild(TOUCHABLES.index_button_down_icon);
		TOUCHABLES.touchable_ui.appendChild(TOUCHABLES.index_button_down);
		// index button up
		TOUCHABLES.index_button_up=document.createElement('DIV');
		TOUCHABLES.index_button_up.classList.add('index_button_up');
		TOUCHABLES.index_button_up_icon=document.createElement('DIV');
		TOUCHABLES.index_button_up_icon.classList.add('index_button_up_icon');
		TOUCHABLES.index_button_up.appendChild(TOUCHABLES.index_button_up_icon);
		TOUCHABLES.touchable_ui.appendChild(TOUCHABLES.index_button_up);
		// scale grabber
		TOUCHABLES.scale_grabber=document.createElement('DIV');
		TOUCHABLES.scale_grabber.classList.add('scale_grabber');
		TOUCHABLES.scale_grabber_icon=document.createElement('DIV');
		TOUCHABLES.scale_grabber_icon.classList.add('scale_grabber_icon');
		TOUCHABLES.scale_grabber.appendChild(TOUCHABLES.scale_grabber_icon);
		TOUCHABLES.touchable_ui.appendChild(TOUCHABLES.scale_grabber); 
		// border rectangle
		TOUCHABLES.border_rectangle=document.createElement('DIV');
		TOUCHABLES.border_rectangle.classList.add('border_rectangle');
		TOUCHABLES.border_rectangle.style='position:absolute; top:0px; left:0px; width:0px; height:0px; pointer-events:none; mix-blend-mode: difference; transform-origin: 0 0;';
		TOUCHABLES.border_rectangle_outline=document.createElement('DIV');
		TOUCHABLES.border_rectangle_outline.classList.add('scale_grabber_outline');
		TOUCHABLES.border_rectangle_outline.style='position:absolute; top:0px; left:0px; width:100%; height:100%; pointer-events:none; outline:dashed white 1px;';
		TOUCHABLES.border_rectangle.appendChild(TOUCHABLES.border_rectangle_outline);
		TOUCHABLES.touchable_ui.appendChild(TOUCHABLES.border_rectangle);
		// delete button
		TOUCHABLES.delete_button=document.createElement('DIV');
		TOUCHABLES.delete_button.classList.add('delete_button');
		TOUCHABLES.delete_button_icon=document.createElement('DIV');
		TOUCHABLES.delete_button_icon.classList.add('delete_button_icon');
		TOUCHABLES.delete_button.appendChild(TOUCHABLES.delete_button_icon);
		TOUCHABLES.touchable_ui.appendChild(TOUCHABLES.delete_button);
		
		touchables_tick();
	}
	// make all touchable
	const touchableels=document.querySelectorAll('*[touch-able]:not([touch-able-state])');
	for(const el of touchableels){
		makeTouchAble(el);
	}
}
function touchables_mouseMove(e){
	TOUCHABLES.mouseovertarget=e.target.closest(['*[touch-able~="mouseoverwheelscale"]']);
}
function touchables_Scroll_hand(e){
	TOUCHABLES.updateUI();
}
function touchables_Resize_hand(e){
	TOUCHABLES.updateUI();
}
function touchables_tick(){
	const currenttime=performance.now();
	// momentum
	const friction=0.9;
	const deltatime=(currenttime-TOUCHABLES.lastticktime);
	const frameduration_factor=deltatime/(1000/60);
	let n=TOUCHABLES.momentumtargets.length, target, transform;
	while(n--){
		target=TOUCHABLES.momentumtargets[n];
		// calcualte speed while dragging
		if(target.ff_isdragging){
			if(target.ff_speed_scale_distfactor===1){
			   // calc speed
				const len=target.ff_transobj_arr.length;
				if(len!==0){
					if(len>2){
						const delta_time=target.ff_transobj_time_arr[len-1]-target.ff_transobj_time_arr[0];
						const last_transobj=target.ff_transobj_arr[len-1];
						const first_transobj=target.ff_transobj_arr[0];
						const ptransobj=getTransObj(target.parentElement)
						target.ff_speed_x=(((last_transobj.gx-first_transobj.gx)/delta_time)/ptransobj.gscx)*(1000/60);
						target.ff_speed_y=(((last_transobj.gy-first_transobj.gy)/delta_time)/ptransobj.gscy)*(1000/60);
					}else{
						target.ff_transobj_arr=[];
						target.ff_transobj_time_arr=[];
						target.ff_speed_x=0;
						target.ff_speed_y=0;
					}
				}
				// track
				trackTransform(target);
			}
		// use speed as momentuum after dragging
		}else{
			// scale
			if(target.ff_speed_scale_distfactor!==1){
				scaleTransformToGXY(target, target.ff_speed_scale_distfactor, target.ff_speed_scale_mx, target.ff_speed_scale_my);
				target.ff_speed_scale_distfactor-=1;
				target.ff_speed_scale_distfactor*=0.85;
				target.ff_speed_scale_distfactor+=1;
				if(Math.abs(target.ff_speed_scale_distfactor-1)<0.002){
					target.ff_speed_scale_distfactor=1;
				}
				target.ff_transobj_arr=[];
				target.ff_transobj_time_arr=[];
				target.ff_speed_x=0;
				target.ff_speed_y=0;
			// move
			}else if(  (target.ff_speed_x!==0 || target.ff_speed_y!==0)){
				// bounderies
				addTransformXY(target, target.ff_speed_x, target.ff_speed_y)
				// friction
				target.ff_speed_x*=Math.pow(friction, frameduration_factor);
				target.ff_speed_y*=Math.pow(friction, frameduration_factor);
				if(Math.abs(target.ff_speed_x)<0.02){
					target.ff_speed_x=0;
				}
				if(Math.abs(target.ff_speed_y)<0.02){
					target.ff_speed_y=0;
				}
			}
		}
	}
	TOUCHABLES.updateUI();
	//
	TOUCHABLES.lastticktime=currenttime;
	setTimeout(touchables_tick, 1000/60);
}
function addTransformXY(transel, x, y){
    transform=getTransform(transel);
	transform.pos.x+=x;
	transform.pos.y+=y;
    setTransform(transel, {x:transform.pos.x, y:transform.pos.y, scx:transform.scale.x, scy:transform.scale.y, rot:transform.rot.z});
}
function getGlobalCenter(transel){
	const gpoints=getGlobals(transel, {c:{x:transel.offsetWidth/2, y:transel.offsetHeight/2, z:0}});
	return {x:gpoints.c.x, y:gpoints.c.y};
}
function addTransformRotation(transel, rotdelta){
	const gcenter=getGlobalCenter(transel);
	const gcenterx=gcenter.x;
	const gcentery=gcenter.y;
	const trans=getTransObj(transel);
	const distfactor=1;
    const trans_parent=getTransObj(transel.parentElement);
    let new_sc, new_x, new_y, new_rot, ox, oy, ox_offset, oy_offset, scalebounce;
    new_sc=trans.scx*distfactor;
    new_x=trans.x;
    new_y=trans.y;
    new_rot=trans.rot+rotdelta;
    // add rot and scale offset
    ox=gcenterx-trans.gx;
    oy=gcentery-trans.gy;
    point=getRotPoint(0, 0, ox*distfactor, oy*distfactor, -rotdelta);
    ox_offset=point.x-ox;
    oy_offset=point.y-oy;
    point=getRotPoint(0, 0, ox_offset, oy_offset, trans_parent.grot);
    ox_offset=point.x/trans_parent.gscx;
    oy_offset=point.y/trans_parent.gscy;
    new_x-=ox_offset;
    new_y-=oy_offset;
    setTransform(transel, {x:new_x, y:new_y, scx:new_sc, scy:new_sc, rot:new_rot});
}
function setTransformScale(transel, scale, parentcenter=false){
	const transform=getTransform(transel);
	let parobj={x:transform.pos.x, y:transform.pos.y, scx:scale, scy:scale, rot:transform.rot.z};
	if(parentcenter){
		parobj.x=(transel.parentElement.offsetWidth-transel.offsetWidth*parobj.scx)/2;
		parobj.y=(transel.parentElement.offsetHeight-transel.offsetHeight*parobj.scy)/2;
	}
	setTransform(transel, parobj);
}
function scaleTransformToGXY(transel, distfactor, gcenterx, gcentery){
	const trans=getTransObj(transel);
    const trans_parent=getTransObj(transel.parentElement);
    let new_sc, new_x, new_y, new_rot, ox, oy, ox_offset, oy_offset, scalebounce;
    new_sc=trans.scx*distfactor;
    new_x=trans.x;
    new_y=trans.y;
    new_rot=trans.rot;
    // add rot and scale offset
    ox=gcenterx-trans.gx;
    oy=gcentery-trans.gy;
    point=getRotPoint(0, 0, ox*distfactor, oy*distfactor, 0);
    ox_offset=point.x-ox;
    oy_offset=point.y-oy;
    point=getRotPoint(0, 0, ox_offset, oy_offset, trans_parent.grot);
    ox_offset=point.x/trans_parent.gscx;
    oy_offset=point.y/trans_parent.gscy;
    new_x-=ox_offset;
    new_y-=oy_offset;
    setTransform(transel, {x:new_x, y:new_y, scx:new_sc, scy:new_sc, rot:new_rot});
}
function touchables_mouseDown_touchStart_hand(e){
	// prevent-parent-touchable
	if(e.target.closest('*[prevent-parent-touchable]')!==null){
		TOUCHABLES.target=null;
		return false;
	}
	//
	if(e.type==='mousedown' && TOUCHABLES.prevent_mousedown===true){
		TOUCHABLES.prevent_mousedown=false;
		return false;
	}
	//console.log(e);
	const touchable=e.target.closest('*[touch-able]'); 
	const rotate_grabber=e.target.closest('.rotate_grabber');
	const rotate_button=e.target.closest('.rotate_button');
	const index_button_down=e.target.closest('.index_button_down');
	const index_button_up=e.target.closest('.index_button_up');
	const delete_button=e.target.closest('.delete_button');
    const scale_grabber=e.target.closest('.scale_grabber');
	const isongrabber=rotate_grabber!==null || scale_grabber!==null || rotate_button!==null || delete_button!==null || index_button_down!==null || index_button_up!==null;
	// set current touchable element
	if(touchable!==null){
		TOUCHABLES.target=touchable;
		// reset touch arr
		touchable.ff_transobj_arr=[];
		touchable.ff_transobj_time_arr=[];
		touchable.ff_isdragging=true;
	}else if(!isongrabber){
		TOUCHABLES.target=null;
	}
    // reset deletebutton
	if(delete_button!==TOUCHABLES.delete_button){
		TOUCHABLES.delete_button.removeAttribute('ready-to-delete');
	}
    // mouse on grabber or button
    if(rotate_grabber===TOUCHABLES.rotate_grabber){
        TOUCHABLES.mousetransmode='rotate';
	}else if(rotate_button===TOUCHABLES.rotate_button){
        TOUCHABLES.mousetransmode='';
		if(TOUCHABLES.target!==null){
			e.preventDefault();
			addTransformRotation(TOUCHABLES.target, 90);
		}
	}else if(index_button_down===TOUCHABLES.index_button_down){
        TOUCHABLES.mousetransmode='';
		if(TOUCHABLES.target!==null){
			e.preventDefault();
			moveIndexDown(TOUCHABLES.target);
		}
	}else if(index_button_up===TOUCHABLES.index_button_up){
        TOUCHABLES.mousetransmode='';
		if(TOUCHABLES.target!==null){
			e.preventDefault();
			moveIndexUp(TOUCHABLES.target);
		}
	}else if(delete_button===TOUCHABLES.delete_button){
        TOUCHABLES.mousetransmode='';
		if(TOUCHABLES.target!==null){
			e.preventDefault();
			if(delete_button.hasAttribute('ready-to-delete')){
				REMOVE(TOUCHABLES.target);
				TOUCHABLES.target=null;
			}else{
				delete_button.setAttribute('ready-to-delete', '');
			}
		}
    
    }else if(scale_grabber===TOUCHABLES.scale_grabber){
        TOUCHABLES.mousetransmode='scale';
    // mouse not on grabber
    }else if(TOUCHABLES.target!==null){
        TOUCHABLES.mousetransmode='';
        if(TOUCHABLES.target!==null){
            TOUCHABLES.mousetransmode='move';
        }
    }
    // reset momentum
    if(TOUCHABLES.target!==null){
		const options=TOUCHABLES.target.getAttribute('touch-able').split(' ');
		if(options.includes('momentum')){
			TOUCHABLES.target.ff_speed_x=0;
			TOUCHABLES.target.ff_speed_y=0;
			TOUCHABLES.target.ff_speed_scale_distfactor=1;
			TOUCHABLES.target.ff_speed_scale_mx=0;
			TOUCHABLES.target.ff_speed_scale_my=0;
		}
    }
    TOUCHABLES.updateUI();
	if(e.type!=='mousedown'){
		TOUCHABLES.prevent_mousedown=true;
	}
	return false;
}
function makeTouchAble(touchableel){
	if(!touchableel.hasAttribute('touch-able-state')){
		touchableel.setAttribute('touch-able-state', 'initialized');
		const options=touchableel.getAttribute('touch-able').split(' ');
		if(options.includes('momentum')){
			touchableel.ff_has_momentum=true;
			touchableel.ff_speed_x=0;
			touchableel.ff_speed_y=0;
			touchableel.ff_speed_scale_distfactor=1;
			touchableel.ff_speed_scale_mx=0;
			touchableel.ff_speed_scale_my=0;
			TOUCHABLES.momentumtargets.push(touchableel);
		}
		makeTransEl(touchableel);
	}
	TOUCHABLES.updateUI();
}

function touchable_onMousewheel(){
	let touchableel=TOUCHABLES.mouseovertarget;
	if(touchableel!==null){
		const options=touchableel.getAttribute('touch-able').split(' ');
		if(options.includes('mouseoverwheelscale')){
			const distfactor=1-(CONTROLS.wheelobj.deltaY/999)*0.5;
			touchableel.ff_speed_scale_distfactor=distfactor;
			touchableel.ff_speed_scale_mx=MOUSE.x;
			touchableel.ff_speed_scale_my=MOUSE.y;
			// call func
			if(touchableel.hasAttribute('touch-ondrag-func')){
				let parts=touchableel.getAttribute('touch-ondrag-func').split('.');
				if(parts.length===1){
					COMPONENTS[parts[0]]();
				}
				if(parts.length===2){
					COMPONENTS[parts[0]][parts[1]]();
				}
				if(parts.length===3){
					COMPONENTS[parts[0]][parts[1]][parts[2]]();
				}
			}
			// update ui
			TOUCHABLES.updateUI();
		}
	}
}
function touchable_onDRAG_END(){
	const touchableel=TOUCHABLES.target;
	if(touchableel!==null){
		const options=touchableel.getAttribute('touch-able').split(' ');
		touchableel.ff_isdragging=false;
		// reset momentum to prevent momentum gonig from 2 fingers to one finger...
		if(options.includes('momentum') && CONTROLS.touchobjs_last.length!==CONTROLS.touchobjs.length && CONTROLS.touchobjs.length>0){
			TOUCHABLES.target.ff_speed_x=0;
			TOUCHABLES.target.ff_speed_y=0;
			TOUCHABLES.target.ff_speed_scale_distfactor=1;
			TOUCHABLES.target.ff_speed_scale_mx=0;
			TOUCHABLES.target.ff_speed_scale_my=0;
		}
	}
}
function touchable_onDRAG(){
    let touchableel,  trans,  new_x, new_y, new_scx, new_scy, new_rot, ox, oy, mx, my, ox_offset, oy_offset, point, point2, corners, corners2, mode, rotdelta, distfactor, distfactorx, distfactory, scalebounce;
    touchableel=TOUCHABLES.target;
    if(touchableel!==null){
		// get attributes
		const options=touchableel.getAttribute('touch-able').split(' ');
        // get coordinates
		trans=getTransObj(touchableel);
		trans_parent=getTransObj(touchableel.parentElement);
		corners=getGlobals(touchableel);
		// get scale mode
        scalemode='';
		if(TOUCHABLES.mousetransmode==='scale'){
			if(TOUCHABLES.mousetransmode==='scalexy'){
				scalemode='scalexy';
			}else if(options.includes('scale')){
				scalemode='scale';
			}else if(options.includes('scalexy')){
				scalemode='scalexy';
			}
		}
        // mouse mode
        if(CONTROLS.pinchobj===null && CONTROLS.dragobj!==null){
			mx=corners.a.x+(corners.d.x-corners.a.x)/2;
            my=corners.a.y+(corners.d.y-corners.a.y)/2;
			
			// move
			if(TOUCHABLES.mousetransmode==='move' && options.includes('move')){
				point=getRotPoint(0, 0, CONTROLS.dragobj.deltax, CONTROLS.dragobj.deltay, trans_parent.grot);
				new_x=trans.x+point.x/trans_parent.gscx;
				new_y=trans.y+point.y/trans_parent.gscy;
			// don't move
			}else{
				new_x=trans.x;
				new_y=trans.y;
			}
			// scale
			distfactor=1;
			distfactorx=1;
			distfactory=1;
			// scale propotional
			if(scalemode==='scale'){
			
				
				distfactor=calcDist(mx, my, CONTROLS.dragobj.clientX-(CONTROLS.dragobj_last.clientX-corners.d.x), CONTROLS.dragobj.clientY-(CONTROLS.dragobj_last.clientY-corners.d.y))/calcDist(mx, my, CONTROLS.dragobj_last.clientX-(CONTROLS.dragobj_last.clientX-corners.d.x), CONTROLS.dragobj_last.clientY-(CONTROLS.dragobj_last.clientY-corners.d.y));
				
				distfactorx=distfactor;
				distfactory=distfactor;
				new_scx=trans.scx*distfactorx;
				new_scy=trans.scy*distfactory;
				
			// scale x and y seperatly
			}else if(scalemode==='scalexy'){
				point=getRotPoint(0, 0, Math.abs(CONTROLS.dragobj.clientX-mx), Math.abs(CONTROLS.dragobj.clientY-my), -trans.grot);
				point2=getRotPoint(0, 0, Math.abs(CONTROLS.dragobj_last.clientX-mx), Math.abs(CONTROLS.dragobj_last.clientY-my), -trans.grot);
				distfactorx=point.x/point2.x;
				distfactory=point.y/point2.y;
				
				
				new_scx=trans.scx*distfactorx;
				new_scy=trans.scy*distfactory;	
				/*
				distfactorx=Math.abs(CONTROLS.dragobj.clientX-mx)/Math.abs(CONTROLS.dragobj_last.clientX-mx);
				distfactory=Math.abs(CONTROLS.dragobj.clientY-my)/Math.abs(CONTROLS.dragobj_last.clientY-my);				
				distfactorx-=1;
				distfactory-=1;
				point=getRotPoint(0, 0, distfactorx, distfactory, -trans.grot-trans_parent.grot);
				console.log('distfactorx', distfactorx);
				console.log('distfactory', distfactory);
				point.x+=1;
				point.y+=1;
				console.log('point', point);
				new_scx=trans.scx*point.x;
				new_scy=trans.scy*point.y;	
				
				distfactorx+=1;
				distfactory+=1;
				*/
			// don't scale
			}else{
				new_scx=trans.scx;
				new_scy=trans.scy;
			} 
			
			// rotate
			if(TOUCHABLES.mousetransmode==='rotate' && options.includes('rotate') && scalemode!=='scale' && scalemode!=='scalexy' ){
				rotdelta=Math.atan2(CONTROLS.dragobj.clientY-my, CONTROLS.dragobj.clientX-mx)-Math.atan2(CONTROLS.dragobj_last.clientY-my, CONTROLS.dragobj_last.clientX-mx);
				rotdelta*=180/Math.PI;
				new_rot=trans.rot+rotdelta;
			// dont'rotate
			}else{
				rotdelta=0;
				new_rot=trans.rot;
			}
			
			
			// add rot and scale offset
			ox=mx-trans.gx;
         	oy=my-trans.gy;
            point=getRotPoint(0, 0, ox*distfactorx, oy*distfactory, -rotdelta);
            ox_offset=point.x-ox;
            oy_offset=point.y-oy;
			
			point=getRotPoint(0, 0, ox_offset, oy_offset, trans_parent.grot);
			ox_offset=point.x;
			oy_offset=point.y;
            
            new_x-=ox_offset/trans_parent.gscx;
            new_y-=oy_offset/trans_parent.gscy;
			
		// touch mode	
        }else{
			// move
			if(options.includes('move')){
				point=getRotPoint(0, 0, CONTROLS.pinchobj.mdeltax, CONTROLS.pinchobj.mdeltay, trans_parent.grot);
				new_x=trans.x+point.x/trans_parent.gscx;
				new_y=trans.y+point.y/trans_parent.gscy;
			}else{
				new_x=trans.x;
				new_y=trans.y;
			}
			
			// scale
			if(options.includes('scale')){
				new_scx=trans.scx*CONTROLS.pinchobj.distfactor;
				new_scy=trans.scy*CONTROLS.pinchobj.distfactor;
				ox=CONTROLS.pinchobj.mx-trans.gx;
				oy=CONTROLS.pinchobj.my-trans.gy;
				
				rotdelta=CONTROLS.pinchobj.rotdelta;
				if(!options.includes('rotate')){
					rotdelta=0;
				}
				point=getRotPoint(0, 0, ox*CONTROLS.pinchobj.distfactor, oy*CONTROLS.pinchobj.distfactor, -rotdelta);
				ox_offset=point.x-ox;
				oy_offset=point.y-oy;
				point=getRotPoint(0, 0, ox_offset, oy_offset, trans_parent.grot);
				ox_offset=point.x/trans_parent.gscx;
				oy_offset=point.y/trans_parent.gscy;
			}else{
				new_scx=trans.scx;
				new_scy=trans.scy;
			}
			
			
			new_rot=trans.rot+rotdelta;
            new_x-=ox_offset;
            new_y-=oy_offset;
        }
		// no transformation chnages occured
		if(trans.x===new_x && trans.y===new_y && trans.scx===new_scx && trans.scy===new_scy && trans.rot===new_rot){
		
		// was transformed 
		}else{
			// set style
			setTransform(touchableel, {x:new_x, y:new_y, scx:new_scx, scy:new_scy, rot:new_rot}, true);
			
			// call func
			if(touchableel.hasAttribute('touch-ondrag-func')){
				callDottedStrFunc(touchableel.getAttribute('touch-ondrag-func'));
			}
			// update ui
			TOUCHABLES.updateUI();
			// prevent scrolling
			
		}
		return 'prevent';
    }
}
function callDottedStrFunc(funcstr){
    const parts=funcstr.split('.');
    if(parts.length===1){
        COMPONENTS[parts[0]]();
    }
    if(parts.length===2){
        COMPONENTS[parts[0]][parts[1]]();
    }
    if(parts.length===3){
        COMPONENTS[parts[0]][parts[1]][parts[2]]();
    }
}
// TRANS ELEMENT
function makeTransEl(transel){
	// set attributes
	if(!transel.hasOwnProperty('ff_transstate')){
		transel.ff_transstate='initialized';
		// create and add helper elements
    	const t=getTransform(transel);
		// set style	
		let x=t.pos.x;
		let y=t.pos.y;
		transel.style.transform='translate3d('+transel.offsetLeft+x+'px, '+transel.offsetTop+y+'px, 0px) scale('+t.scale.x+', '+t.scale.y+') rotate('+t.rot.z+'deg)';
		transel.style.transformOrigin='0 0';
		transel.style.removeProperty('left');
		transel.style.removeProperty('top');
		transel.style.position='absolute';
		transel.ff_transobj_arr=[];
		transel.ff_transobj_time_arr=[];
	}
}
function getTransObj(el){
	const t=getTransform(el);
	const gt=getGlobalTransform(el)
	const transobj={x:t.pos.x, y:t.pos.y, scx:t.scale.x, scy:t.scale.y, rot:t.rot.z*(180/Math.PI), gx:gt.pos.x, gy:gt.pos.y, gscx:gt.scale.x, gscy:gt.scale.y, grot:gt.rot.z*(180/Math.PI)};
	return transobj;
}
function trackTransform(transel){
	transel.ff_transobj_arr.push(getTransObj(transel));
	transel.ff_transobj_time_arr.push(performance.now());
	if(transel.ff_transobj_arr.length>10){
		transel.ff_transobj_arr.shift();
		transel.ff_transobj_time_arr.shift();
	}
}
function setTransform(transel, parobj, track=false){
	if(transel.hasAttribute('touch-able')){
		const options=transel.getAttribute('touch-able').split(' ');
		// SCALE BOUNDERIES
		let scalebounce=false;
		// max min
		if(transel.hasAttribute('max-scale')){
			const max_scale=parseFloat(transel.getAttribute('max-scale'));
			if(parobj.scx>max_scale){
				parobj.scx=max_scale;
				parobj.scy=max_scale;
				scalebounce=true;
			}
		}
		if(transel.hasAttribute('min-scale')){
			const min_scale=parseFloat(transel.getAttribute('min-scale'));
			if(parobj.scx<min_scale){
				parobj.scx=min_scale;
				parobj.scy=min_scale;
				scalebounce=true;
			}
		}
		// keep
		if(options.includes('keepcovered')){
			if(transel.offsetWidth*parobj.scx<transel.parentElement.offsetWidth){
				parobj.scx=transel.parentElement.offsetWidth/transel.offsetWidth;
				parobj.scy=transel.parentElement.offsetWidth/transel.offsetWidth;
				scalebounce=true;
			}
			if(transel.offsetHeight*parobj.scy<transel.parentElement.offsetHeight){
				parobj.scx=transel.parentElement.offsetHeight/transel.offsetHeight;
				parobj.scy=transel.parentElement.offsetHeight/transel.offsetHeight;
				scalebounce=true;
			}
		}
        if(scalebounce){
            const trans=getTransObj(transel);
            const trans_parent=getTransObj(transel.parentElement);
            const corners=getGlobals(transel);
            const mx=corners.a.x+(corners.d.x-corners.a.x)/2;
            const my=corners.a.y+(corners.d.y-corners.a.y)/2;
            const ox=mx-trans.gx;
            const oy=my-trans.gy;
            let distfactor=parobj.scx/trans.scx;
            parobj.x=trans.x;
            parobj.y=trans.y;
            let point=getRotPoint(0, 0, ox*distfactor, oy*distfactor, 0);
            let ox_offset=point.x-ox;
            let oy_offset=point.y-oy;
            point=getRotPoint(0, 0, ox_offset, oy_offset, trans_parent.grot);
            ox_offset=point.x/trans_parent.gscx;
            oy_offset=point.y/trans_parent.gscy;
            parobj.x-=ox_offset;
            parobj.y-=oy_offset;
        }
		// X Y BOUNDREIES
		if(options.includes('keepcovered')){
			if(parobj.x>0){
				parobj.x=0;
			}
			if(parobj.x<transel.parentElement.offsetWidth-transel.offsetWidth*parobj.scx){
				parobj.x=transel.parentElement.offsetWidth-transel.offsetWidth*parobj.scx;
			}
			if(parobj.y>0){
				parobj.y=0;
			}
			if(parobj.y<transel.parentElement.offsetHeight-transel.offsetHeight*parobj.scy){
				parobj.y=transel.parentElement.offsetHeight-transel.offsetHeight*parobj.scy;
			}
		}
		if(options.includes('keepvisible')){
			if(parobj.x>transel.parentElement.offsetWidth/2){
				parobj.x=transel.parentElement.offsetWidth/2;
			}
			if(parobj.x<transel.parentElement.offsetWidth/2-transel.offsetWidth*parobj.scx){
				parobj.x=transel.parentElement.offsetWidth/2-transel.offsetWidth*parobj.scx;
			}
			if(parobj.y>transel.parentElement.offsetHeight/2){
				parobj.y=transel.parentElement.offsetHeight/2;
			}
			if(parobj.y<transel.parentElement.offsetHeight/2-transel.offsetHeight*parobj.scy){
				parobj.y=transel.parentElement.offsetHeight/2-transel.offsetHeight*parobj.scy;
			}
			// is smaller than parent keep centered
			if(transel.offsetWidth*parobj.scx<transel.parentElement.offsetWidth && transel.offsetHeight*parobj.scy<transel.parentElement.offsetHeight){
				parobj.x=(transel.parentElement.offsetWidth-transel.offsetWidth*parobj.scx)/2;
				parobj.y=(transel.parentElement.offsetHeight-transel.offsetHeight*parobj.scy)/2;
			}
		}
		if(options.includes('setstyletransformvars')){
			transel.style.setProperty('--transform-x', parobj.x);
			transel.style.setProperty('--transform-y', parobj.y);
			transel.style.setProperty('--transform-rot', parobj.rot);
			transel.style.setProperty('--transform-scx', parobj.scx);
			transel.style.setProperty('--transform-scy', parobj.scy);
		}
	}
	
	transel.style.transform='translate3d('+parobj.x+'px, '+parobj.y+'px, 0px) rotate('+parobj.rot+'deg) scale('+parobj.scx+','+parobj.scy+')';
	
	
	if(track){
		trackTransform(transel);
	}
}


// MATH
function getRotPoint(cx, cy, x, y, angle) {
    let rad=(Math.PI/180)*angle;
    let cos=Math.cos(rad);
    let sin=Math.sin(rad);
    return {x:(cos*(x-cx))+(sin*(y-cy))+cx, y:(cos*(y-cy))-(sin*(x-cx))+cy};
}

// ANIMATION
function createAnimation(_fps=60){
    const ani={};
    ani.fps=_fps
    ani.frameduration=1000/_fps;
    ani.frameduration_factor=1;
    ani.timestamp=performance.now();
    ani.timestamp_last=performance.now();
    ani.timestamp_delta=ani.timestamp-ani.timestamp_last;
    ani.onenterframefuncs=[];
    ani.oefn=0;
    ani.isplaying=false;
    ani.requestanimation_id=0;
    // 
    ani.reqAniTick=function(){
        ani.timestamp=performance.now();
        ani.timestamp_delta=ani.timestamp_last===0 ? ani.frameduration : ani.timestamp-ani.timestamp_last;
        // call onEnterFrame Functions if timestamp_delta has reached frameduration 
        if(ani.timestamp_delta>=ani.frameduration){
            ani.frameduration_factor=ani.timestamp_delta/ani.frameduration;
            for(ani.oefn=0; ani.oefn<ani.onenterframefuncs.length; ani.oefn++){
                ani.onenterframefuncs[ani.oefn](ani.frameduration_factor);
            }
            ani.timestamp_last=ani.timestamp;
        }
        // request new Frame
        ani.requestanimation_id=requestAnimationFrame(ani.reqAniTick);
    }
    // 
    ani.addOnEnterFrameFunc=function(_onEnterFrameFunc){
        ani.onenterframefuncs.push(_onEnterFrameFunc);
    }
    ani.play=function(){
        if(ani.isplaying===false){
            ani.isplaying=true;
            ani.timestamp_last=0;
            cancelAnimationFrame(ani.requestanimation_id);
            ani.requestanimation_id=requestAnimationFrame(ani.reqAniTick);
        }
    }	
    ani.stop=function(){
        if(ani.isplaying===true){
            ani.isplaying=false;
            cancelAnimationFrame(ani.requestanimation_id);
        }
    }		
    return ani;
}
/*
function createTween(endvalue, duration){
	const tween={endvalue:endvalue, duration:duration};
	return tween;
}*/
// CANVAS
function CANVAS(width=1280, height=1280,  smoothing=true){
	this.canvas=document.createElement("CANVAS");
	this.ctx=this.canvas.getContext("2d");
	this.ctx.imageSmoothingEnabled=smoothing;
	this.drawobjs=[];
	
	this.setW=function(w){
		this.canvas.width=w;
	}
	this.setW=function(h){
		this.canvas.height=h;
	}
	this.setWH=function(w, h){
		this.canvas.width=w;
		this.canvas.height=h;
	}
	this.setWH(width, height);
	this.addDrawElement=function(el){
		this.drawobjs.push(el);
	}
	this.ani=createAnimation();
	let _this=this;
	this.ani.addOnEnterFrameFunc(function(fdf){
		let n, media, parent, t, x, y, w, h, rot;
		for(let n=0; n<_this.drawobjs.length; n++){
			media=_this.drawobjs[n];
			parent=media.closest('*[touch-able]');
			t=getTransform(parent);
			x=t.pos.x;
			y=t.pos.y;
			w=parent.offsetWidth*t.scale.x;
			h=parent.offsetHeight*t.scale.y;
			rot=t.rot.z;
			_this.ctx.setTransform();
			_this.ctx.translate(x, y);
			_this.ctx.rotate(rot);
			_this.ctx.drawImage(media, 0, 0, w, h);
			
		}
	});
	this.ani.play();
	this.downloadAsPNG=function(filename='Studio Digital') {
		let a=document.createElement('a');
		a.download=filename+'.png';
		a.href=_this.canvas.toDataURL()
		a.click();
		a.delete;
	}
}




// get global transform
function getGlobalTransform(el){
    let t, gt, tp, p;
	gt=createIdentityTransform();
    while(el){
        t=getTransform(el);
		scaleVector(gt.scale, t.scale);
		
        gt.rot.x+=t.rot.x;
		gt.rot.y+=t.rot.y;
		gt.rot.z+=t.rot.z;
		
		scaleVector(gt.pos, t.scale);
		rotateVector(gt.pos, t.rot);
		addVector(gt.pos, t.pos);
		
        if(el.parentElement){
            tp=getTransform(el.parentElement);
            p=getRotPoint(0,0,(el.offsetLeft-el.scrollLeft)*tp.scale.x, (el.offsetTop-el.scrollTop)*tp.scale.y, tp.rot.z); 
			
            addVector(gt.pos, {x:p.x, y:p.y, z:0});
        }else{
            addVector(gt.pos, {x:el.offsetLeft, y:el.offsetTop, z:0});
        }
        el=el.parentElement;
    }
	addVector(gt.pos, {x:-window.pageXOffset, y:-window.pageYOffset, z:0});
	
    return gt;
}

// getGlobals
function getGlobals(el, points=null) {
	let w=el.offsetWidth,
        h=el.offsetHeight,
        t, tp, p, v;
	if(points===null){
		 points={
            a: {x:0, y:0, z:0},
			b: {x:w, y:0, z:0},
			c: {x:0, y:h, z:0},
            d: {x:w, y:h, z:0}
        }
	}
    while(el){
        t=getTransform(el);
		for(const prop in points){
			v=points[prop];
			scaleVector(v, t.scale);
			rotateVector(v, t.rot);
			addVector(v, t.pos);
			if(el.parentElement){
				tp=getTransform(el.parentElement);
				p=getRotPoint(0,0,(el.offsetLeft-el.scrollLeft)*tp.scale.x, (el.offsetTop-el.scrollTop)*tp.scale.y, tp.rot.z);
				addVector(v, {x:p.x, y:p.y, z:0});
			}else{
				addVector(v, {x:el.offsetLeft, y:el.offsetTop, z:0});
			}
		}
        el=el.parentElement;
    }
	for(const prop in points){
		v=points[prop];
		addVector(v, {x:-window.pageXOffset, y:-window.pageYOffset, z:0});
	}
    return points;
}
// compute Matrix
function rComputedMatrix(el) {
	const c=window.getComputedStyle(el, null).getPropertyValue('transform').split(/\s*[(),]\s*/).slice(1,-1);
    let matrix;
	// transform
    if(c.length === 6){
        matrix={
            m11: parseFloat(c[0]), m21: parseFloat(c[2]), m31: 0, m41: parseFloat(c[4]),
            m12: parseFloat(c[1]), m22: parseFloat(c[3]), m32: 0, m42: parseFloat(c[5]),
            m13: 0,     m23: 0,     m33: 1, m43: 0,
            m14: 0,     m24: 0,     m34: 0, m44: 1
        };
    }else if (c.length === 16){
    // transform3d
        matrix={
            m11: parseFloat(c[0]), m21: parseFloat(c[4]), m31: parseFloat(c[8]), m41: parseFloat(c[12]),
            m12: parseFloat(c[1]), m22: parseFloat(c[5]), m32: parseFloat(c[9]), m42: parseFloat(c[13]),
            m13: parseFloat(c[2]), m23: parseFloat(c[6]), m33: parseFloat(c[10]), m43: parseFloat(c[14]),
            m14: parseFloat(c[3]), m24: parseFloat(c[7]), m34: parseFloat(c[11]), m44: parseFloat(c[15])
        };
	// none 
    }else{
        matrix={
            m11: 1, m21: 0, m31: 0, m41: 0,
            m12: 0, m22: 1, m32: 0, m42: 0,
            m13: 0, m23: 0, m33: 1, m43: 0,
            m14: 0, m24: 0, m34: 0, m44: 1
        };
    }
	return matrix;
}

// get Transform
function getTransform(el) {
	let matrix=rComputedMatrix(el),
        rotateY=Math.asin(-matrix.m13),
        rotateX, 
        rotateZ;
    if(Math.cos(rotateY) !== 0) {
        rotateX = Math.atan2(matrix.m23, matrix.m33);
        rotateZ = Math.atan2(matrix.m12, matrix.m11);
    }else{
        rotateX = Math.atan2(-matrix.m31, matrix.m22);
        rotateZ = 0;
    }
   

    return {
        matrix: matrix,
		scale: {
			x: Math.sqrt(matrix.m11*matrix.m11+matrix.m12*matrix.m12+matrix.m13*matrix.m13),
			y: Math.sqrt(matrix.m21*matrix.m21+matrix.m22*matrix.m22+matrix.m23*matrix.m23),
			z: Math.sqrt(matrix.m31*matrix.m31+matrix.m32*matrix.m32+matrix.m33*matrix.m33)
		},
        rot: {
            x: rotateX,
            y: rotateY,
            z: rotateZ
        },
        pos: {
            x: matrix.m41,
            y: matrix.m42,
            z: matrix.m43
        }
    };
}
function createIdentityTransform(){
	return {
        matrix: {
            m11: 1, m21: 0, m31: 0, m41: 0,
            m12: 0, m22: 1, m32: 0, m42: 0,
            m13: 0, m23: 0, m33: 1, m43: 0,
            m14: 0, m24: 0, m34: 0, m44: 1
        },
		scale: {
			x: 1,
			y: 1,
			z: 1
		},
        rot: {
            x: 0,
            y: 0,
            z: 0
        },
        pos: {
            x: 0,
            y: 0,
            z: 0
        }
    };
}
// add vector
function addVector(v1, v2) {
    v1.x+=v2.x;
    v1.y+=v2.y;
    v1.z+=v2.z;
}
// scale vector
function scaleVector(v1, v2) {
    v1.x*=v2.x;
    v1.y*=v2.y;
    v1.z*=v2.z;
}

// rotate Vector
function rotateVector(v1, v2) {
    let v1x=v1.x,
        v1y=v1.y,
        v1z=v1.z,
		angleX=v2.x/2,
        angleY=v2.y/2,
        angleZ=v2.z/2,
        cr=Math.cos(angleX),
        cp=Math.cos(angleY),
        cy=Math.cos(angleZ),
        sr=Math.sin(angleX),
        sp=Math.sin(angleY),
        sy=Math.sin(angleZ),

        w=cr*cp*cy+sr*sp*sy,
        x=sr*cp*cy-cr*sp*sy,
        y=cr*sp*cy+sr*cp*sy,
        z=cr*cp*sy-sr*sp*cy,

        m0=1-2*(y*y+z*z),
        m1=2*(x*y+z*w),
        m2=2*(x*z-y*w),
		
        m4=2*(x*y-z*w),
        m5=1-2*(x*x+z*z),
        m6=2*(z*y+x*w),
		
        m8=2*(x*z+y*w),
        m9=2*(y*z-x*w),
        m10=1-2*(x*x+y*y);

    v1.x=v1x*m0+v1.y*m4+v1z*m8;
    v1.y=v1x*m1+v1.y*m5+v1z*m9;
    v1.z=v1x*m2+v1.y*m6+v1z*m10;
}
// placeholder text generator
function getLorumIpsum(min=10, max=800, endsign='.'){
	const words=shuffleArray(['Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. ', 'At vero eos et accusamus et iusto odio dignissimos ducimus qui blanditiis praesentium voluptatum deleniti atque corrupti quos dolores et quas molestias excepturi sint occaecati cupiditate non provident, similique sunt in culpa qui officia deserunt mollitia animi, id est laborum et dolorum fuga.','Et harum quidem rerum facilis est et expedita distinctio. Nam libero tempore, cum soluta nobis est eligendi optio cumque nihil impedit quo minus id quod maxime placeat facere possimus, omnis voluptas assumenda est, omnis dolor repellendus. Temporibus autem quibusdam et aut officiis debitis aut rerum necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Itaque earum rerum hic tenetur a sapiente delectus, ut aut reiciendis voluptatibus maiores alias consequatur aut perferendis doloribus asperiores repellat.','Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.','Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.','Ut autem a facillimis ordiamur, prima veniat in medium Epicuri ratio, quae plerisque notissima est. quam a nobis sic intelleges eitam, ut ab ipsis, qui eam disciplinam probant, non soleat accuratius explicari; verum enim invenire volumus, non tamquam adversarium aliquem convincere. accurate autem quondam a L. Torquato, homine omni doctrina erudito, defensa est Epicuri sententia de voluptate, a meque ei responsum, cum C. Triarius, in primis gravis et doctus adolescens, ei disputationi interesset.','In quo enim maxime consuevit iactare vestra se oratio, tua praesertim, qui studiose antiqua persequeris, claris et fortibus viris commemorandis eorumque factis non emolumento aliquo, sed ipsius honestatis decore laudandis, id totum evertitur eo delectu rerum, quem modo dixi, constituto, ut aut voluptates omittantur maiorum voluptatum adipiscendarum causa aut dolores suscipiantur maiorum dolorum effugiendorum gratia.','Itaque non placuit Epicuro medium esse quiddam inter dolorem et voluptatem; illud enim ipsum, quod quibusdam medium videretur, cum omni dolore careret, non modo voluptatem esse, verum etiam summam voluptatem. quisquis enim sentit, quem ad modum sit affectus, eum necesse est aut in voluptate esse aut in dolore. omnis autem privatione doloris putat Epicurus terminari summam voluptatem, ut postea variari voluptas distinguique possit, augeri amplificarique non possit.','Quodsi vitam omnem perturbari videmus errore et inscientia, sapientiamque esse solam, quae nos a libidinum impetu et a formidinum terrore vindicet et ipsius fortunae modice ferre doceat iniurias et omnis monstret vias, quae ad quietem et ad tranquillitatem ferant, quid est cur dubitemus dicere et sapientiam propter voluptates expetendam et insipientiam propter molestias esse fugiendam?']).join(' ').split(' ');
	const wordcount=randomInt(min, max);
	const words_length=words.length;
	let string='';
	let i=0;
    while(i<=wordcount){
		string+=words[i%words_length]+' ';
		i++;
    }
	string=string.substr(0, string.length-1)+endsign;
    return string;
}
// MAth
function randomInt(min, max){
	return Math.floor(Math.random()*(max-min+1))+min;
}
function calcDist(x1, y1, x2, y2){
	const a=x1-x2;
	const b=y1-y2;
	return Math.sqrt(a*a+b*b);
}
function interpolateLinear(start, end, n, steps=1){
	return start+((end-start)/steps)*n;
}
// array 
function shuffleArray(arr) {
    for(let a=arr.length-1; a>0; a--) {
        const b=Math.floor(Math.random()*(a+1));
        [arr[a], arr[b]] = [arr[b], arr[a]];
    }
	return arr;
}
// ID
function uniqueID(){
  return Date.now().toString(36)+Math.random().toString(36).substr(2);
};
// as El
function asEl(_string) {
    const div=document.createElement('div');
    div.innerHTML=_string.trim();
    return div.firstChild; 
}
// verlaufsumsetzung
function applyColorList(_colors){
    let o=colorsListToRGBValues(_colors);
    let filterobj=document.body.getElementsByClassName('filterobj')[0];
    changeFeTableValues(filterobj.getElementsByTagName('feFuncR')[0], o.r);
    changeFeTableValues(filterobj.getElementsByTagName('feFuncG')[0], o.g);
    changeFeTableValues(filterobj.getElementsByTagName('feFuncB')[0], o.b);
}
function colorsListToRGBValues(_colors){
    let len=_colors.length, n=0, o={r:[], g:[], b:[]};
    for(n=0; n<len; n++){
        o.r.push(degColor(n, 1, _colors));
        o.g.push(degColor(n, 3, _colors));
        o.b.push(degColor(n, 5, _colors));
    }
    return o;
}
function changeFeTableValues(_fetel, _valuearr){
    let vstr='', len=_valuearr.length, n=0, r, g, b;
    for(n=0; n<len; n++){
        vstr+=(n!==0?' ':'')+_valuearr[n];
    }
    _fetel.setAttribute('tableValues', vstr);
}
function degColor(_colorindex, _channelindex, _colors, _deg=0){
        let len=_colors.length;
        let npos=(_colorindex/len+_deg)%1;
        let n=parseInt(npos*len)%len;
        let nn=(npos-n/len)*len;
        let nextn=n+1;
        if(nextn>=_colors.length){
            nextn=0;
        }
        let color=Math.round(parseInt(_colors[n].substr(_channelindex,2), 16)/255*100)/100;
        let color2=Math.round(parseInt(_colors[nextn].substr(_channelindex,2), 16)/255*100)/100;
        color=interpolateLinear(color, color2, nn);
        return color;
    }
// ENGINE FUNCTIONS */
function interpolateLinear(_start, _end, _steps, _n){
    var d=_end-_start;
    return _start+(d/_steps)*_n;

}
function REMOVE(_el){
    var _p=_el.parentElement;
    if(_p!=null){
        _p.removeChild(_el);
    }else{
        console.log('no parent - cant remove')
    }
    return _p;
}
function getIndex(_el){
    var index=0;
    while((_el=_el.previousElementSibling)){
        index++;
    }
    return index;
} 
function moveIndexUp(_el){
    if(_el.nextElementSibling!==null){
        insertAfter(_el, _el.nextElementSibling);
    }
} 
function moveIndexDown(_el){
    if(_el.previousElementSibling!==null){
        insertBefore(_el, _el.previousElementSibling);
    }
}
function insertAfter(_el, _rel) {
    _rel.parentElement.insertBefore(_el, _rel.nextSibling);
}
function insertBefore(_el, _rel) {
    _rel.parentElement.insertBefore(_el, _rel);
}
function REPLACE(_targetel, _el){
    _targetel.parentElement.insertBefore(_el, _targetel);
    REMOVE(_targetel);
}
function REMOVES(_els){
    for(var _n=0; _n<_els.length; _n++){
        REMOVE(_els[_n]);
    }
}
// window
function openWindowWithPost(url, data) {
    const form=document.createElement("form");
    form.target='_blank';
    form.method='POST';
    form.action=url;
    form.style.display='none';
    for(const key in data) {
        const input=document.createElement("input");
        input.type='hidden';
        input.name=key;
        input.value=data[key];
        form.appendChild(input);
    }
    document.body.appendChild(form);
    form.submit();
    document.body.removeChild(form);
}
// IS IN VIEWPORT ///////////////////////////////////////////////////
function isInViewport(_obj) {
    const rect=_obj.getBoundingClientRect();
    return !(
        rect.bottom < 0 ||
        rect.right < 0 ||
        rect.top > (window.innerHeight || html.clientHeight) ||
        rect.left > (window.innerWidth || html.clientWidth)
    );
}

// KEY HANDLER ///////////////////////////////////////////////////////
document.addEventListener('keydown', keyDown_hand);
document.addEventListener('keyup', keyUp_hand);
let KEY_DOWN_HANDS=[];
let KEY_UP_HANDS=[];
let KEYS=[];
function keyDown_hand(e){
    const key=e.key || e.keyCode;
    if(KEYS.indexOf(String(key).toLowerCase())===-1){
        KEYS.push(String(key).toLowerCase());
    }
    let n=KEY_DOWN_HANDS.length;
    while(n--){
        if(KEY_DOWN_HANDS[n](e)==='prevent'){
			e.preventDefault();
		}
    } 
}
function keyUp_hand(e){
    const key=e.key || e.keyCode;
    const index=KEYS.indexOf(String(key).toLowerCase());
    if(index!==-1){
        KEYS.splice(index, 1);
    }
    let n=KEY_UP_HANDS.length;
    while(n--){
		if(KEY_UP_HANDS[n](e)==='prevent'){
			e.preventDefault();
		}
    } 
}
function iskey_UP(){
    return (KEYS.indexOf('arrowup')!==-1 || KEYS.indexOf('38')!==-1);
}
function iskey_DOWN(){
    return (KEYS.indexOf('arrowdown')!==-1 || KEYS.indexOf('40')!==-1);
}
function iskey_LEFT(){
    return (KEYS.indexOf('arrowleft')!==-1 || KEYS.indexOf('37')!==-1);
}
function iskey_RIGHT(){
    return (KEYS.indexOf('arrowright')!==-1 || KEYS.indexOf('39')!==-1);
}
function iskey_PLUS(){
    return (KEYS.indexOf('+')!==-1 || KEYS.indexOf('107')!==-1);
}
function iskey_MINUS(){
    return (KEYS.indexOf('-')!==-1 || KEYS.indexOf('109')!==-1);
}
function iskey_CONTROL(){
    return (KEYS.indexOf('control')!==-1 || KEYS.indexOf('17')!==-1);
}
function iskey_ENTER(){
    return (KEYS.indexOf('enter')!==-1 || KEYS.indexOf('13')!==-1);
}
function iskey_Z(){
    return (KEYS.indexOf('z')!==-1 || KEYS.indexOf('90')!==-1);
}
function iskey_Y(){
    return (KEYS.indexOf('y')!==-1 || KEYS.indexOf('89')!==-1);
}
