// JavaScript Document
window.LAYOUT={};
(function(){
	document.addEventListener("DOMContentLoaded", INIT);
	document.addEventListener("mousedown", MOUSE_DOWN);
	document.addEventListener("mouseup", MOUSE_UP);
	document.addEventListener('scroll', ON_SCROLL);
	document.addEventListener('focusout', FOCUS_OUT);
	document.addEventListener('focusin', FOCUS_IN);
	LAYOUT.RESIZE_FUNCS=[];
	// ON SCROLL
	function ON_SCROLL(){
		cssroot.style.setProperty('--scroll-left', (window.pageXOffset || document.documentElement.scrollLeft)+'px');
		cssroot.style.setProperty('--scroll-top', (window.pageYOffset || document.documentElement.scrollTop)+'px');
	}
	// INITIALIZE
	function INIT(){
		// resize
		let helper_vh_vw=document.createElement('div');
		helper_vh_vw.style='position:fixed; top:0; left:0; width:100vw; height:100vh; pointer-events:none; z-index:-1;'
		document.body.appendChild(helper_vh_vw);
		window.ff_helper_vh_vw=helper_vh_vw;
		LAYOUT.RESIZE=function(){
			console.log('RESIZE');
			cssroot.style.setProperty('--window-inner-height', window.innerHeight+'px');
			cssroot.style.setProperty('--window-inner-width', window.innerWidth+'px');
			cssroot.style.setProperty('--docel-client-width', document.documentElement.clientWidth+'px');
			cssroot.style.setProperty('--docel-client-height', document.documentElement.clientHeight+'px');
			cssroot.style.setProperty('--docel-client-whmin', Math.min(document.documentElement.clientWidth, document.documentElement.clientHeight)+'px');
			cssroot.style.setProperty('--docel-client-whmax', Math.max(document.documentElement.clientWidth, document.documentElement.clientHeight)+'px');
			cssroot.style.setProperty('--body-client-width', document.body.clientWidth+'px');
			cssroot.style.setProperty('--body-client-height', document.body.clientHeight+'px');
			cssroot.style.setProperty('--body-client-whmin', Math.min(document.body.clientWidth, document.body.clientHeight)+'px');
			cssroot.style.setProperty('--body-client-whmax', Math.max(document.body.clientWidth, document.body.clientHeight)+'px');
			cssroot.style.setProperty('--currentview-height', Math.max(window.innerHeight, document.documentElement.clientHeight)+'px');
			for(const func of LAYOUT.RESIZE_FUNCS){
				func();
			}
		}
		LAYOUT.RESIZE();
		resizeTick();
		
		// delay href (e.g. for ccs fade animation via "show-content" attribute selector)
		LAYOUT.hrefDelay=function(href){
			document.body.removeAttribute('show-content', '');
			setTimeout(function(){window.location.href=href}, 300);
		}
		// replace all hrefs
		const as=document.querySelectorAll('a');
		let href='';
		for(const a of as){
			if(a.hasAttribute('href')){
				href=a.getAttribute('href');
				console.log(href);
				if(href.substr(0,4)!=='http' && a.getAttribute('target')==='_self'){
					const hrefcall=href;
					a.onclick=function(){LAYOUT.hrefDelay(hrefcall);};
					a.removeAttribute('href');
					a.setAttribute('original-href', href);
				}
			}
		}
		setTimeout(function(){document.body.setAttribute('show-content', '');}, 1);
	}
	// RESIZE
	function resizeTick(){
		if(LAYOUT.window_inner_height!==window.innerHeight || LAYOUT.window_inner_width!==window.innerWidth || LAYOUT.body_client_width!==document.body.clientWidth || LAYOUT.body_client_height!==document.body.clientHeight || LAYOUT.docel_client_width!==document.documentElement.clientWidth || LAYOUT.docel_client_height!==document.documentElement.clientHeight){
			LAYOUT.window_inner_width=window.innerWidth;
			LAYOUT.window_inner_height=window.innerHeight;
			LAYOUT.body_client_width=document.body.clientWidth;
			LAYOUT.body_client_height=document.body.clientHeight;
			LAYOUT.docel_client_width=document.documentElement.clientWidth;
			LAYOUT.docel_client_height=document.documentElement.clientHeight;
			LAYOUT.RESIZE();
		}
		setTimeout(resizeTick, 1000/10);
	}
	
	// MOUSE DOWN
	function MOUSE_DOWN(){
		document.body.setAttribute('mouse-down', '');
	}
	function MOUSE_UP(){
		document.body.removeAttribute('mouse-down');
	}
	
	// VIRTUAL KEYBOARD HACKS 
	// purpose: restores scrolls triggert by virtualekeyboard on touchdevices
	function isTextInputEl(el){
	 	const tagname=el.tagName.toLocaleLowerCase()
		return (tagname==='input' || tagname==='textarea' || (el.hasAttribute('contenteditable') && el.getAttribute('contenteditable')!=='false'));
	}
	function FOCUS_OUT(e){
		if(isTextInputEl(e.target) && e.target.tagName.toLocaleLowerCase()!=='a'){
			console.log('FOCUS_OUT', e.target);
        	resetLayout();
        	setTimeout(resetLayout, 1);
		}
	}
	function FOCUS_IN(e){
		if(isTextInputEl(e.target)){
        	scrollels=document.querySelectorAll('body, body > *');
          	for(const scrollel of scrollels){
              	scrollel.ff_onfocusin_scrollTop=scrollel.scrollTop;
              	scrollel.ff_onfocusin_scrollLeft=scrollel.scrollLeft;
          	}
          	document.documentElement.ff_onfocusin_scrollTop=document.documentElement.scrollTop;
          	document.documentElement.ff_onfocusin_scrollLeft=document.documentElement.scrollLeft;
			console.log('focusIn_hand', e.target);
		}
	}
	function resetLayout(){
        for(const scrollel of scrollels){
            scrollel.scrollTop=scrollel.ff_onfocusin_scrollTop;
            scrollel.scrollLeft=scrollel.ff_onfocusin_scrollLeft;
        }
        document.documentElement.scrollTop=document.documentElement.ff_onfocusin_scrollTop;
        document.documentElement.scrollLeft=document.documentElement.ff_onfocusin_scrollLeft
        LAYOUT.RESIZE();
	}
	
	
})();

