// JavaScript Document
window.BUBBLEMAKER={};
(function(){
	document.addEventListener("DOMContentLoaded", INIT);
	function INIT(){
		
		const canvas=document.createElement('CANVAS');
		let stageToCanvas_firsttime=true;
		const context=canvas.getContext('2d');
		const bubblemaker=document.getElementsByClassName('bubblemaker')[0];
		const stage=bubblemaker.getElementsByClassName('stage')[0];
		const blurlayer0=document.getElementsByClassName('blurlayer0')[0];
		const stagebgimg=document.getElementById('stagebgimg');
		const halloffameformbox=bubblemaker.getElementsByClassName('halloffameformbox')[0];
		const addbubblebutton_bear=document.querySelectorAll('.addbubblebutton.button2[figure-name="bear"]')[0];
		const addbubblebutton_police=document.querySelectorAll('.addbubblebutton.button2[figure-name="police"]')[0];
		let scrollels;
		let resize_timer=0;
		BUBBLEMAKER.INIT=function(){
			halloffameformbox.getElementsByClassName('canvaspreview')[0].appendChild(canvas);
			// contain stage
			const fitel=stage;
			const padding=32;
			const parent_rect=fitel.parentElement.getBoundingClientRect();
			const scalef1=(parent_rect.width-padding*2)/stage.offsetWidth;
			const scalef2=(parent_rect.height-padding*2)/stage.offsetHeight
			const scale=Math.min(scalef1, scalef2);
			setTransform(fitel, {x:padding, y:padding, scx:scale, scy:scale, rot:0});
			//
			BUBBLEMAKER.initStage();
			BUBBLEMAKER.addBubble('police');
			BUBBLEMAKER.addBubble('bear');
			TEXTEDITOR.addGlobalToolBarElement(asEl('<div class="bubbletypebutton" onclick="BUBBLEMAKER.bubbletypebutton_onclick(event);" current-bubble="roundedcorner"></div>'));
			TEXTEDITOR.addGlobalToolBarElement(asEl('<div class="deletebubblebutton" onclick="BUBBLEMAKER.deletebubblebutton_onclick(event);"></div>'));
			//setTimeout(BUBBLEMAKER.reSizeMulti, 100);
			
		}
		
		BUBBLEMAKER.bubbletypebutton_onclick=function(e){
			if(TEXTEDITOR.rootel!==null){
				const svg=TEXTEDITOR.rootel.closest('svg.svg_bubbles');
				const bubblename=TEXTEDITOR.rootel.getAttribute('ref-bubble');	
				const bubble=svg.querySelectorAll('g[bubble-name="'+bubblename+'"]')[0];
				const bubblegroup=bubble.querySelectorAll('g[bubble-type]')[0];
				const nosegroup=bubble.querySelectorAll('g[nose-type]')[0];
				let bubbletype=bubblegroup.getAttribute('bubble-type');
				let nosetype=nosegroup.getAttribute('nose-type');
				// change bubbletype
				if(bubbletype==='roundedcorner'){
					bubbletype='thinking'
				}else if(bubbletype==='thinking'){
					bubbletype='angry';
				}else{
					bubbletype='roundedcorner';
				}
				// update editor toolbar
				e.currentTarget.setAttribute('current-bubble', bubbletype);
				// change bubble
				BUBBLEMAKER.changeBubble(bubble, bubbletype);
			}
		}
		BUBBLEMAKER.deletebubblebutton_onclick=function(e){
			if(TEXTEDITOR.rootel!==null){
				const svg=TEXTEDITOR.rootel.closest('svg.svg_bubbles');
				const bubblename=TEXTEDITOR.rootel.getAttribute('ref-bubble');	
				const bubble=svg.querySelectorAll('g[bubble-name="'+bubblename+'"]')[0];
				const foreignobj=TEXTEDITOR.rootel.closest('foreignObject');
				foreignobj.remove();
				bubble.remove();
				BUBBLEMAKER.reSizeMulti();
				TEXTEDITOR.toolbar_hide();
				
			}
		}
		BUBBLEMAKER.globaleditortoolbar_onshow=function(toolbar){
			const svg=TEXTEDITOR.rootel.closest('svg.svg_bubbles');
			const bubblename=TEXTEDITOR.rootel.getAttribute('ref-bubble');	
			const bubble=svg.querySelectorAll('g[bubble-name="'+bubblename+'"]')[0];
			const bubblegroup=bubble.querySelectorAll('g[bubble-type]')[0];
			const bubbletype=bubblegroup.getAttribute('bubble-type');
			const bubbletypebutton=toolbar.getElementsByClassName('bubbletypebutton')[0];
			bubbletypebutton.setAttribute('current-bubble', bubbletype);
		}
		
		
		BUBBLEMAKER.texbox_oninput=function(e){
			BUBBLEMAKER.resizeDelayed();
		}
		BUBBLEMAKER.addbubblebutton_onclick=function(e){
			const figurename=e.currentTarget.getAttribute('figure-name');
			BUBBLEMAKER.addBubble(figurename);
		}
		BUBBLEMAKER.onformatrange=function(){
			BUBBLEMAKER.resizeDelayed();
		}
		BUBBLEMAKER.reSizeMulti=function(){
			BUBBLEMAKER.reSize();
			BUBBLEMAKER.reSize();
			BUBBLEMAKER.reSize();
			BUBBLEMAKER.reSize();
			BUBBLEMAKER.reSize();
			BUBBLEMAKER.reSize();
		}
		BUBBLEMAKER.resizeDelayed=function(){
			clearTimeout(resize_timer);
			resize_timer=setTimeout(function(){
				BUBBLEMAKER.reSizeMulti();
				
			}, 1000/20);
			
		}
		
		// RESIZE
		BUBBLEMAKER.reSize=function(e){
			let current_bear_y=150;
			let current_police_y=200;
			const textels=stage.querySelectorAll('*[editor-tags]');
			for(const textel of textels){
				const svg=textel.closest('svg.svg_bubbles');
				const bubblename=textel.getAttribute('ref-bubble');			
				const figurename4=bubblename.substr(0, 4);
				const bubble=svg.querySelectorAll('g[bubble-name="'+bubblename+'"]')[0];
				const bubblegroup=bubble.querySelectorAll('g[bubble-type]')[0];
				const nosegroup=bubble.querySelectorAll('g[nose-type]')[0];
				const bubbletype=bubblegroup.getAttribute('bubble-type');
				const nosetype=nosegroup.getAttribute('nose-type');
				
				const lineoffset=5;
				const bearhx=2880/2;
				const bearhy=2880/2;
				const policehx=2880/2;
				const policehy=2880/2;
				
				// width and height
				const w=textel.offsetWidth+100;
				const h=textel.offsetHeight+100;
				//y
				if(figurename4==='bear'){
					y=current_bear_y;
					current_bear_y+=h+200;
					if(nosetype==='angry'){
						y+=100;
						current_bear_y+=150;
					}
				}else{
					y=current_police_y;
					if(nosetype==='angry'){
						y+=100;
						current_police_y+=150;
					}
					current_police_y+=h+200;
				}
				//x
				let cx=0, x=0, maxw=1000
				const bottom=y+h;
				if(figurename4==='bear'){
					cx=1440;
					if(bottom>632){
						cx=1200;
					}
					if(bottom>1069){
						cx=1047;
					}
					if(bottom>1379){
						cx=947;
					}
					if(bottom>1669){
						cx=883;
					}
					cx-=50;
					x=cx-w;
					maxw=cx-200;
				}else{
					cx=1766;
					if(bottom>1080){
						cx=2038;
					}
					cx+=75;
					x=cx;
					maxw=2880-cx-200;
				}
				// set textel position
				textel.style.top=(y+50)+'px';
				textel.style.left=(x+50)+'px';
				textel.style.maxWidth=maxw+'px';
				// set bubble position
				bubble.setAttribute('transform', 'translate('+x+' '+y+')');
				
				
				
				// set nosegroup 
				if(nosetype==='triangle'){
					const polyline=nosegroup.querySelectorAll('polyline')[0];
					let nw, nh, nx, ny, tx, ty, point, rot, mx, my, points;
					if(figurename4==='poli'){
						if(y+h/2<1000){
							nw=w/5;
							nw=nw>100?100:nw;
							nh=100;
							nx=w/5;
							ny=h-lineoffset;
							mx=nx;
							my=ny+nh/2;
							rot=Math.atan2(policehy-(y+my), policehx-(x+mx))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -100, rot+90);
							tx=mx-point.x;
							ty=my+point.y;
							polyline.setAttribute('points', nx+' '+ny+' '+tx+' '+ty+' '+(nx+nw)+' '+ny);
						}else{
							nw=100;
							nh=h/5;
							nh=nh>100?100:nh;
							nx=lineoffset;
							ny=h/2-nh/2;
							mx=nx;
							my=ny+nh/2;
							rot=Math.atan2(policehy-(y+my), policehx-(x+mx))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -100, rot+90);
							tx=mx-point.x;
							ty=my+point.y;
							polyline.setAttribute('points', nx+' '+(ny+nh)+' '+tx+' '+ty+' '+nx+' '+ny);
						}
					}else{
						if(y+h/2<890){
							nw=w/5;
							nw=nw>100?100:nw;
							nh=100;
							nx=w-w/5;
							ny=h-lineoffset;
							mx=nx;
							my=ny+nh/2;
							rot=Math.atan2(policehy-(y+my), policehx-(x+mx))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -100, rot+90);
							tx=mx-point.x;
							ty=my+point.y;
							polyline.setAttribute('points', nx+' '+ny+' '+tx+' '+ty+' '+(nx-nw)+' '+ny);
						}else{
							nw=100;
							nh=h/5;
							nh=nh>100?100:nh;
							nx=w-lineoffset;
							ny=h/2-nh/2;
							mx=nx;
							my=ny+nh/2;
							rot=Math.atan2(policehy-(y+my), policehx-(x+mx))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -100, rot+90);
							tx=mx-point.x;
							ty=my+point.y;
							if(y<1190){
								nh=-h/5;
								ny=h/2-nh/2;
							}
							polyline.setAttribute('points', nx+' '+(ny+nh)+' '+tx+' '+ty+' '+nx+' '+ny);
						}
					}
					
				}
				if(nosetype==='circle'){
					const c1r=30;
					const c2r=20;
					let c1x, c1y, c2x, c2y, rot, point, px, py, d;
					if(figurename4==='poli'){
						
						if(y+h/2<1000){
							c1x=w/5-c1r;
							c1y=h+c1r*1.75;
							rot=Math.atan2(policehy-(y+c1y), policehx-(x+c1x))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, (c1r+c2r+10), -rot+90);
							c2x=c1x+point.x;
							c2y=c1y+point.y;
						}else{
							c1x=-c1r*3.5;
							c1y=h/2-c1r;
							rot=Math.atan2(policehy-(y+c1y), policehx-(x+c1x))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -(c1r+c2r+10), -rot-90);
							c2x=c1x+point.x;
							c2y=c1y+point.y;
							c1y+=point.y/2;
							c1x-=point.y/4;
							c2y+=point.y/2;
						}
						
					}else{
						if(bottom<bearhy){
							c1x=w-(w/5-c1r);
							c1y=h+c1r*1.75;
							rot=Math.atan2(bearhy-(y+c1y), bearhx-(x+c1x))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, (c1r+c2r+10), -rot+90);
							c2x=c1x+point.x;
							c2y=c1y+point.y;
						}else{
							c1x=w-(-c1r*3.5);
							c1y=h/2-c1r;
							rot=Math.atan2(bearhy-(y+c1y), bearhx-(x+c1x))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -(c1r+c2r+10), rot+90);
							c2x=c1x-point.x;
							c2y=c1y+point.y;
							c1y+=point.y/2;
							c1x+=point.y/4;
							c2y+=point.y/2;
						}
					}
                   	const circles=nosegroup.querySelectorAll('circle');
					setAttributes(circles[0], {'cx':c1x , 'cy':c1y ,'r':c1r-5});
					setAttributes(circles[1], {'cx':c2x , 'cy':c2y ,'r':c2r-5});
					
				}
				if(nosetype==='angry'){
					const polyline=nosegroup.querySelectorAll('polyline')[0];
					let nw, nh, nx, ny, tx, ty, point, rot, mx, my, points, steps, step, rand1, rand2;
					const zzwh=105;
					const zzwh2=60;
					if(figurename4==='poli'){
						if(y+h/2<1000){
							nw=w/5;
							nw=nw>100?100:nw;
							nh=100;
							nx=w/5;
							ny=h-lineoffset;
							mx=nx;
							my=ny+nh/2;
							rot=Math.atan2(policehy-(y+my), policehx-(x+mx))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -150, rot+90);
							tx=mx-point.x;
							ty=my+point.y;
							px=nx+nw;
							py=ny;
							points=nx+' '+ny+' '+tx+' '+ty+' '+px+' '+py;
							// bottom line to right
							d=w-px;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								px+=step;
								py-=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								px+=rand1;
								py+=rand2;
								points+=' '+px+' '+py;
							}
							// bottomright to top
							d=h
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								py-=step;
								px-=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								py+=rand1;
								px+=rand2;
								points+=' '+px+' '+py;
							}
							// topright to left
							d=w;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								px-=step;
								py+=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								px+=rand1;
								py+=rand2;
								points+=' '+px+' '+py;
							}
							// topleft to bottom
							d=h;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								py+=step;
								px+=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								py+=rand1;
								px+=rand2;
								points+=' '+px+' '+py;
							}
							// close				
							points+=' '+nx+' '+ny;
							polyline.setAttribute('points', points);
						}else{
							nw=100;
							nh=h/5;
							nh=nh>100?100:nh;
							nx=lineoffset;
							ny=h/2-nh/2;
							mx=nx;
							my=ny+nh/2;
							rot=Math.atan2(policehy-(y+my), policehx-(x+mx))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -150, rot+90);
							tx=mx-point.x;
							ty=my+point.y;
							px=nx;
							py=ny;
							points=nx+' '+(ny+nh)+' '+tx+' '+ty+' '+px+' '+py;
							//  to top
                            rand1=Math.random()*zzwh*1-0.5;
                            rand2=Math.random()*zzwh*0.5-0.25;
                            py=rand1;
                            px=rand2;
                            points+=' '+px+' '+py;
                            py=0;
                            px=0;
							//  topleft to right
							d=w;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								px+=step;
								py+=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								px+=rand1;
								py+=rand2;
								points+=' '+px+' '+py;
							}
							// topright to bottom
							d=h;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								py+=step;
								px-=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								py+=rand1;
								px+=rand2;
								points+=' '+px+' '+py;
							}
							// bottomright to left
							d=w;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								px-=step;
								py-=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								px+=rand1;
								py+=rand2;
								points+=' '+px+' '+py;
							}
							//close
							points+=' '+nx+' '+(ny+nh);
							polyline.setAttribute('points', points);
						}
					// bear angry
					}else{
						if(y+h/2<1000){
							nw=w/5;
							nw=nw>100?100:nw;
							nh=100;
							nx=w-w/5;
							ny=h-lineoffset;
							mx=nx;
							my=ny+nh/2;
							rot=Math.atan2(policehy-(y+my), policehx-(x+mx))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -150, rot+90);
							tx=mx-point.x;
							ty=my+point.y;
							px=nx-nw;
							py=ny;
							points=nx+' '+ny+' '+tx+' '+ty+' '+px+' '+py;
							
							// bottom line to left
							d=px;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								px-=step;
								py-=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								px+=rand1;
								py+=rand2;
								points+=' '+px+' '+py;
							}
							// bottomleft to top
							d=h
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								py-=step;
								px+=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								py+=rand1;
								px+=rand2;
								points+=' '+px+' '+py;
							}
							
							// topleft to right
							d=w;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								px+=step;
								py+=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								px+=rand1;
								py+=rand2;
								points+=' '+px+' '+py;
							}
							// toprightto bottom
							d=h;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								py+=step;
								px-=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								py+=rand1;
								px+=rand2;
								points+=' '+px+' '+py;
							}
							
							// close				
							points+=' '+nx+' '+ny;
							polyline.setAttribute('points', points);
						}else{
							nw=100;
							nh=h/5;
							nh=nh>100?100:nh;
							nx=w-lineoffset;
							ny=h/2-nh/2;
							mx=nx;
							my=ny+nh/2;
							rot=Math.atan2(policehy-(y+my), policehx-(x+mx))*(180/Math.PI);
							point=getRotPoint(0, 0, 0, -150, rot+90);
							tx=mx-point.x;
							ty=my+point.y;
							px=nx;
							py=ny;
							points=nx+' '+(ny+nh)+' '+tx+' '+ty+' '+px+' '+py;
							//  to top
                            rand1=Math.random()*zzwh*1-0.5;
                            rand2=w+Math.random()*zzwh*0.5-0.25;
                            py=rand1;
                            px=rand2;
                            points+=' '+px+' '+py;
                            py=0;
                            px=w;
							//  topright to left
							d=w;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								px-=step;
								py+=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								px+=rand1;
								py+=rand2;
								points+=' '+px+' '+py;
							}
							// topright to bottom
							d=h;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								py+=step;
								px+=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								py+=rand1;
								px+=rand2;
								points+=' '+px+' '+py;
							}
							// bottomleft to right
							d=w;
							steps=parseInt(d/zzwh2);
							steps+=steps%2===0?0:1;
							step=d/steps;
							for(let n=0; n<steps; n++){
								px+=step;
								py-=(n%2===0?-1:1)*zzwh;
								rand1=n%2===0?Math.random()*step*1-0.5:-rand1;
								rand2=n%2===0?Math.random()*zzwh*0.5-0.25:-rand2;
								px+=rand1;
								py+=rand2;
								points+=' '+px+' '+py;
							}
							//close
							points+=' '+nx+' '+(ny+nh);
							polyline.setAttribute('points', points);
						}
					}
					
				}
				// set bubble w h
				if(bubbletype==='roundedcorner'){
					const rect=bubblegroup.querySelectorAll('rect')[0];
					rect.setAttribute('width', w);
					rect.setAttribute('height', h);
				}else if(bubbletype==='thinking'){
					const path=bubblegroup.querySelectorAll('path')[0];
					const d=BUBBLEMAKER.rThinkingBubbleD(0,0, w, h);
					path.setAttribute('d', d);
				}
				
				
			}
			// buttons
			addbubblebutton_bear.style.top=current_bear_y+'px';
			addbubblebutton_police.style.top=current_police_y+'px';
		}
		
		BUBBLEMAKER.openHallOfFameForm=function(){
			BUBBLEMAKER.stageToCanvas(
				function(){
					bubblemaker.setAttribute('halloffameform-is-open', '');
				}
			);
			
		}
		BUBBLEMAKER.closeHallOfFameForm=function(){
			BLUEPRINTS['resetInputGroup'](document.querySelectorAll('*[inputgroup-name="halloffameform"]')[0]);
			bubblemaker.removeAttribute('halloffameform-is-open');
			bubblemaker.removeAttribute('is-sending-data');
		}
		function pc_C(x1, y1, x2, y2, x, y){
			return 'C '+x1+' '+y1+' '+x2+' '+y2+' '+x+' '+y+' ';
		}
		function pc_S(x1, y1, x, y){
			return 'S '+x1+' '+y1+' '+x+' '+y+' ';
		}
		BUBBLEMAKER.rThinkingBubbleD=function(x, y, w, h){
			const randf1=Math.random()*0.2+0.8;
			const randf2=Math.random()*0.2+0.8;
			const randf3=Math.random()*0.2+0.8;
			const randf4=Math.random()*0.2+0.8;
			const randf5=Math.random()*0.2+0.8;
			const randf6=Math.random()*0.2+0.8;
			const randf7=Math.random()*0.2+0.8;
			const randf8=Math.random()*0.2+0.8;
		
			const hw=w/5;
			const hh=h/5;
			const r=x+w-w/20;
			const b=y+h-h/20;
			x+=w/20;
			y+=h/20;
			let d='';
			d+='M '+x+' '+y+' ';
			d+=pc_C(x+hw*randf1, y-hh, r-hw*randf2, y-hh, r, y); 
			d+=pc_C(r+hw*randf3, y+hh, r+hw*randf4, b-hh, r, b);
			d+=pc_C(r-hw*randf5, b+hh, x+hw*randf6, b+hh, x, b);
			d+=pc_C(x-hw*randf7, b-hh, x-hw*randf8, y+hh, x, y);
			d+='Z';
			return d;
		}
	
		BUBBLEMAKER.changeBubble=function(bubble , bubbletype){
			if(bubbletype==='roundedcorner'){
				bubble.innerHTML=`<g bubble-type="roundedcorner">
										<rect x="0" y="0" width="790" height="537" rx="124" fill="#fff" stroke="#000" stroke-miterlimit="10" stroke-width="9"/>
								</g>
								<g nose-type="triangle">
									<polyline points="2 1.582 2 251.582 325.333 1.582" fill="#fff" stroke="#000" stroke-miterlimit="10" stroke-width="9"/>
								</g>`;
			}else if(bubbletype==='thinking'){
				bubble.innerHTML=`<g bubble-type="thinking">
									<path d="`+BUBBLEMAKER.rThinkingBubbleD(0,0,200, 100)+`" fill="#fff" stroke="#000" stroke-miterlimit="10" stroke-width="9"></path>
								</g>
								<g nose-type="circle">
										<circle cx="39.5" cy="39.5" r="39.5" fill="#fff" stroke="#000" stroke-miterlimit="10" stroke-width="9"/>
										<circle cx="39.5" cy="39.5" r="39.5" fill="#fff" stroke="#000" stroke-miterlimit="10" stroke-width="9"/>
								</g>`;	 
			}
			else if(bubbletype==='angry'){
				bubble.innerHTML=`<g bubble-type="angry"></g>
								  <g nose-type="angry">
									<polyline points="2 1.582 2 251.582 325.333 1.582" fill="#fff" stroke="#000" stroke-miterlimit="10" stroke-width="9"/>
								</g>`;	 
			}
			BUBBLEMAKER.reSizeMulti();
						
		}
		
		BUBBLEMAKER.addBubble=function(figurename){
			const bubblewrapper=stage.querySelectorAll('svg.svg_bubbles .bubblewrapper')[0];
			const bubblename=figurename+uniqueID();	  
			let dom=`<g x="0" y="0" bubble-name="`+bubblename+`" transform="translate(700)">
						<g bubble-type="roundedcorner">
							<rect x="0" y="0" width="790" height="537" rx="124" fill="#fff" stroke="#000" stroke-miterlimit="10" stroke-width="9"/>
						</g>
						<g nose-type="triangle">
							<polyline points="2 1.582 2 251.582 325.333 1.582" fill="#fff" stroke="#000" stroke-miterlimit="10" stroke-width="9"/>
						</g>
					</g>
					<foreignObject x="0" y="0" width="100%" height="100%" class="textcontainer" style="position:absolute; top:0; left:0; width: 100%; height: 100%;"> 
						<div ref-bubble="`+bubblename+`" contenteditable="true" editor-tags="strong" oninput="TEXTEDITOR.richtextinput_oninput(event);BUBBLEMAKER.texbox_oninput(event);" style="max-width: 897px; position: absolute; top: 480px; left: 100px; min-height: 1em; hyphens: none; min-width: 360px; outline: 0px; -ms-hyphens: none; -moz-hyphens: none; -webkit-hyphens: none; hyphens: none; overflow-wrap: break-word;  word-wrap: break-word;" prevent-parent-touchable is-empty onformatrange-callback="BUBBLEMAKER.onformatrange" ontoolbarshow-callback="BUBBLEMAKER.globaleditortoolbar_onshow"></div>
					</foreignObject>`;
			bubblewrapper.insertAdjacentHTML('beforeEnd', dom);
			BUBBLEMAKER.reSizeMulti();
		}
		BUBBLEMAKER.initStage=function(){
			let svgstr=`<svg class="svg_bubbles" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 2880 2880" width="2880" height="2880">
							<def>
								<style>
									`+window.EMBED_FONTFACE_CAVEAT+`
									svg.svg_bubbles p{
										margin: 0 !important;
										padding: 0 !important;
									}
									svg.svg_bubbles div{
										font-family: 'Caveat', cursive !important;
										font-weight: 500 !important;
										font-size: 120px !important; 
										line-height: 120px !important;
										text-align: center;
									}
									svg.svg_bubbles strong{
										font-family: 'Caveat', cursive !important;
										font-weight: 700 !important;
										font-size: 180px !important; 
										line-height: 180px !important;
									}
								</style>
							</def>
							<g class="bubblewrapper">

							</g>
							<g class="panelframe">
								<rect x="0" y="0" width="2880" height="2880"  fill="none" stroke="#000" stroke-miterlimit="10" stroke-width="18"/>
							</g>
						</svg>`;
			const svgel=asEl(svgstr);
			stage.appendChild(svgel);
		}
	
		
		
		BUBBLEMAKER.savebt_onclick=function(event){
			BUBBLEMAKER.stageToCanvas(
				function(){
					const filename='bubble-maker-dialog';
					if(window.navigator.msSaveBlob){
						window.navigator.msSaveBlob(canvas.msToBlob, filename+'.png');
					}else{
						const a=document.createElement('A');
						document.body.appendChild(a);
						a.href=canvas.toDataURL('image/jpeg');
						a.download=filename+'.jpg';
						a.click();
						a.parentElement.removeChild(a);
					}
				}
			);
			
		}
		
		

		BUBBLEMAKER.plublishtohalloffamebt_onclick=function(e){
			let groupel=e.currentTarget.closest('*[inputgroup-name="halloffameform"]');
			if(groupel!==null){
				const groupobj=BLUEPRINTS['inputGroupToObj'](groupel);
				const inputs=groupobj['inputs'];
				console.log(groupobj);
				let callobj={};
				let parobj={};
				bubblemaker.setAttribute('is-sending-data', '');
				parobj['imgdataurl']=canvas.toDataURL('image/jpeg');
				parobj['infoobj']={};
				parobj['infoobj']['toolslug']='bubblemaker';
				parobj['infoobj']['username']=inputs['username']['value'];
				parobj['infoobj']['artworktitle']=inputs['artworktitle']['value'];
				parobj['infoobj']['city']=inputs['city']['value'];
				parobj['infoobj']['einwilligung']=inputs['einwilligung']['value'];
				callobj['api-func-component']='BUBBLEMAKER';
				callobj['api-func-name']='saveToHallOfFame';
				callobj['api-target-id']='body';
				callobj['api-insert-cmd']='beforeend';
				callobj['api-func-parobj']=parobj;
				API_CALL([callobj]);
			}
			
			
		}
		BUBBLEMAKER.getStageSVGStr=function(){
			const compstyle=window.getComputedStyle(stage, null);
			const w=parseFloat(compstyle.getPropertyValue('width'));
			const h=parseFloat(compstyle.getPropertyValue('height'));
			let svgstr='<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="'+w+'" height="'+h+'" viewBox="0 0 '+w+' '+h+'">'
			const imgs=stage.querySelectorAll('*[touch-able]');
			for(const img of imgs){
				svgstr+='<image transform="'+window.getComputedStyle(img, null).getPropertyValue('transform')+'" href="'+img.getAttribute('src')+'" width="'+img.getAttribute('width')+'" height="'+img.getAttribute('height')+'" />';
			}
			svgstr+='</svg>';
			return svgstr;
		}
		BUBBLEMAKER.stageToCanvas=function(oncompleted_func){
			console.log('BUBBLEMAKER.stageToCanvas');
			const compstyle=window.getComputedStyle(stage, null);
			const w=parseFloat(compstyle.getPropertyValue('width'));
			const h=parseFloat(compstyle.getPropertyValue('height'));
			
			canvas.width=w;
			canvas.height=h; 
			context.clearRect(0, 0, canvas.width, canvas.height);
			/*
			context.fillStyle='#ffffff';
			context.fillRect(0, 0, canvas.width, canvas.height);
			*/
			context.drawImage(stagebgimg, 0, 0, canvas.width, canvas.height);
			const svgs=stage.querySelectorAll('svg.svg_bubbles');
			const svgcount=svgs.length;
			let svgcounter=0;
			console.log('svgcounter', svgcounter, 'svgcount', svgcount);
			for(const svg of svgs){
				//var m=window.getComputedStyle(img, null).getPropertyValue('transform').match(/([-+]?[\d\.]+)/g);
				const m=rComputedMatrix(svg);
				console.log(m);
				const img=new Image();
				
				
				
				const cleansvg=asEl(svg.outerHTML);
				img.onload=function() {
					context.setTransform(m.m11, m.m12, m.m21, m.m22, m.m41, m.m42);
					context.drawImage(img, 0, 0);
					svgcounter++;
					console.log('img.onload()', 'svgcounter', svgcounter, 'svgcount', svgcount);
					if(svgcounter>=svgcount){
						if(stageToCanvas_firsttime===true){
							setTimeout(BUBBLEMAKER.stageToCanvas, 1000/10, oncompleted_func);
							stageToCanvas_firsttime=false;
						}else{
							oncompleted_func();
						}
					}
					//URL.revokeObjectURL(img.src);
				}
				let xmlstr='';
				try {
					xmlstr=new XMLSerializer().serializeToString(cleansvg);
				}catch(e){
					console.log(e);
				}
				img.src='data:image/svg+xml;base64,'+btoa(unescape(encodeURIComponent(xmlstr)));
		
				
			}
			
		}
		BUBBLEMAKER.INIT();
	}





})();


