// JavaScript Document
let COLLAGETOOL={};
(function(){
	document.addEventListener("DOMContentLoaded", INIT);
	function INIT(){
		const canvas=document.createElement('CANVAS');
		const context=canvas.getContext('2d');
		const collagetool=document.getElementsByClassName('collagetool')[0];
		const stage=collagetool.getElementsByClassName('stage')[0];
		const halloffameformbox=collagetool.getElementsByClassName('halloffameformbox')[0];
		
		COLLAGETOOL.INIT=function(){
			COLLAGETOOL.openLibrary();
			halloffameformbox.getElementsByClassName('canvaspreview')[0].appendChild(canvas);
			setTransformScale(stage, 0.8, true);
		}
		COLLAGETOOL.openHallOfFameForm=function(){
			COLLAGETOOL.stageToCanvas();
			collagetool.setAttribute('halloffameform-is-open', '');
		}
		COLLAGETOOL.closeHallOfFameForm=function(){
			BLUEPRINTS['resetInputGroup'](document.querySelectorAll('*[inputgroup-name="halloffameform"]')[0]);
			collagetool.removeAttribute('halloffameform-is-open');
			collagetool.removeAttribute('is-sending-data');
		}
		COLLAGETOOL.openLibrary=function(){
			collagetool.setAttribute('library-is-open', '');
		}
		COLLAGETOOL.closeLibrary=function(){
			collagetool.removeAttribute('library-is-open');
		}
		COLLAGETOOL.addDevice=function(imgel){
			const w=imgel.getAttribute('width');
			const h=imgel.getAttribute('height');
			const src=imgel.getAttribute('src');
			const img=asEl('<img cursor-drag cursor-dragging touch-able="move rotate scale scalegrabber rotategrabber deletebutton indexbuttondown indexbuttonup" width="'+w+'" height="'+h+'" src="'+src+'" draggable="false"  ondragstart="return false;" />');
			stage.appendChild(img);
			makeAllTouchAble();
			const stagetransobj=getTransObj(stage);
			const imgrect=img.getBoundingClientRect();
			const stageparentrect=stage.parentElement.getBoundingClientRect();
			const insertx=(-stagetransobj.gx+stageparentrect.width/2)/stagetransobj.gscx-imgrect.width/2;
			const inserty=(-stagetransobj.gy+stageparentrect.height/2)/stagetransobj.gscy-imgrect.height/2;
			setTransform(img, {x:insertx, y:inserty, scx:1, scy:1, rot:0});
			
			touchables_mouseDown_touchStart_hand({target:img});
			DRAG_END();
		}
		COLLAGETOOL.libraryitem_onclick=function(event){
			const imgel=event.currentTarget.querySelectorAll('.media img')[0];
			COLLAGETOOL.addDevice(imgel);
			COLLAGETOOL.closeLibrary();
		}
		COLLAGETOOL.savebt_onclick=function(event){
			COLLAGETOOL.stageToCanvas();
			const filename='collage';
			if(window.navigator.msSaveBlob){
				window.navigator.msSaveBlob(canvas.msToBlob, filename+'.png');
			}else{
				const a=document.createElement('A');
				document.body.appendChild(a);
				a.href=canvas.toDataURL('image/jpeg');
				a.download=filename+'.jpg';
				a.click();
				a.parentElement.removeChild(a);
			}
		}
		
		

		COLLAGETOOL.plublishtohalloffamebt_onclick=function(e){
			let groupel=e.currentTarget.closest('*[inputgroup-name="halloffameform"]');
			if(groupel!==null){
				const groupobj=BLUEPRINTS['inputGroupToObj'](groupel);
				const inputs=groupobj['inputs'];
				console.log(groupobj);
				let callobj={};
				let parobj={};
				collagetool.setAttribute('is-sending-data', '');
				parobj['imgdataurl']=canvas.toDataURL('image/jpeg');
				parobj['infoobj']={};
				parobj['infoobj']['toolslug']='collagetool';
				parobj['infoobj']['username']=inputs['username']['value'];
				parobj['infoobj']['artworktitle']=inputs['artworktitle']['value'];
				parobj['infoobj']['city']=inputs['city']['value'];
				parobj['infoobj']['einwilligung']=inputs['einwilligung']['value'];
				callobj['api-func-component']='COLLAGETOOL';
				callobj['api-func-name']='saveToHallOfFame';
				callobj['api-target-id']='body';
				callobj['api-insert-cmd']='beforeend';
				callobj['api-func-parobj']=parobj;
				API_CALL([callobj]);
			}
			
			
		}
		COLLAGETOOL.getStageSVGStr=function(){
			const compstyle=window.getComputedStyle(stage, null);
			const w=parseFloat(compstyle.getPropertyValue('width'));
			const h=parseFloat(compstyle.getPropertyValue('height'));
			let svgstr='<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="'+w+'" height="'+h+'" viewBox="0 0 '+w+' '+h+'">'
			const imgs=stage.querySelectorAll('*[touch-able]');
			for(const img of imgs){
				svgstr+='<image transform="'+window.getComputedStyle(img, null).getPropertyValue('transform')+'" href="'+img.getAttribute('src')+'" width="'+img.getAttribute('width')+'" height="'+img.getAttribute('height')+'" />';
			}
			svgstr+='</svg>';
			return svgstr;
		}
		COLLAGETOOL.stageToCanvas=function(){
			const compstyle=window.getComputedStyle(stage, null);
			const w=parseFloat(compstyle.getPropertyValue('width'));
			const h=parseFloat(compstyle.getPropertyValue('height'));
			canvas.width=w;
			canvas.height=h; 
			context.clearRect(0, 0, canvas.width, canvas.height);
			
			context.fillStyle='#ffffff';
			context.fillRect(0, 0, canvas.width, canvas.height);
			
			const imgs=stage.querySelectorAll('*[touch-able]');
			for(const img of imgs){
				//var m=window.getComputedStyle(img, null).getPropertyValue('transform').match(/([-+]?[\d\.]+)/g);
				console.log(m);
				var m=rComputedMatrix(img);
				
				//context.setTransform(m[0], m[1], m[2], m[3], m[4], m[5]);
				context.setTransform(m.m11, m.m12, m.m21, m.m22, m.m41, m.m42);
				context.drawImage(img, 0, 0);
			}
		}
		
		COLLAGETOOL.INIT();
	};
	
	
})();
