<?php
$DOMSTR_TITLE='Collage Tool';
$DOMSTR_BODY_ATTRIBUTES.=' is-tool';
$COMPONENTS['COLLAGETOOL']=[];

$menubar=$BLUEPRINTS['rCreativeToolMenuBar'](['title'=>'Collage Tool', 'icon'=>'icon-collage-tool', 'default-closeurl'=>'artist-page']);

$libraryitems_dom='';
$imgurls=glob('data/media/collage-tool/*.png');

foreach($imgurls as $src){
	$filename=basename($src, ".png");
	$firstchar=substr($filename, 0, 1);
	if($firstchar!=='_'){ // exclude _
		$wh=getimagesize($src);
		$w=$wh[0];
		$h=$wh[1];
		$libraryitems_dom.='<div class="libraryitem" onclick="COLLAGETOOL.libraryitem_onclick(event);">
							   <div class="media" view-mode="cover">
									<img src="'.HTMLRELPATH.$src.'" width="'.$w.'" height="'.$h.'" alt="" onload="BLUEPRINTS[\'media_isloaded\'](event);" style="width:'.$w.'px; height:'.$h.'px;"/>
								</div>
								<div class="text">
									'.$filename.'
								</div>
							</div>';		
	}
	
}

// SAVE TO HALL OF FAME
$COMPONENTS['COLLAGETOOL']['saveToHallOfFame']=function($parobj){
	global $BLUEPRINTS;
	if(strval($parobj['infoobj']['einwilligung'])!=='true'){
		return '<script>
					document.getElementById("halloffameformresponsebox").innerHTML="Du musst die Einwilligung für die Veröffentlichung bestätigen.";
					document.getElementsByClassName("collagetool")[0].removeAttribute("is-sending-data");
				</script>';
	}
	$id=rID();
	$path='data/halloffame/'.$id;
	$imgfilepath=$path.'stage.jpg';
	$infoobj=json2obj(obj2json($parobj['infoobj']));
	$infoobj['id']=$id;
	$infoobj['time']=time();
	saveJSON($path.'/info.json', obj2json($infoobj));
	$data=str_replace(' ','+',$parobj['imgdataurl']);
	$data=substr($data,strpos($data, ',')+1);
	$data=base64_decode($data);
	$file=fopen($imgfilepath, 'w');
	fwrite($file, $data);
	fclose($file);
	
    $script='<script>COLLAGETOOL.closeHallOfFameForm();</script>';
    $contentdom='<h1>Sehr schön!</h1>
                            <p>
                                Deine Collage <i>'.$infoobj['artworktitle'].'</i> wurde erfolgreich zur Veröffentlichung in der <a href="hall-of-fame" target="_self">Hall of Fame</a> eingereicht. Es kann bis zu 3 Werkstage dauern bis dein Werk überprüft und veröffentlicht wird. Tipp: Mit "Speichern" kannst du dein Werk jetzt schon downloaden und mit deinen Freunden teilen.<br>
                            </p>
                            <div class="button2" onclick="REMOVE(this.closest(\'.overlay\'));">
                                <span>Alles klar</span>
                            </div> ';

    return $BLUEPRINTS['rOverlayBubbleBox']($contentdom).$script;
	
};

$halloffameform_dom=$BLUEPRINTS['HALLOFFAMEFORM']['rHallOfFameForm']('COLLAGETOOL', 'meine Collage');
					 
?>
<?php echo $menubar; ?>

<div class="collagetool">
	<div class="blurlayer0">
		<div class="toolbartop">
			<div class="openlibrarybt button2" onclick="COLLAGETOOL.openLibrary();">
				<span>+ Element hinzufügen</span>
			</div>
		</div>
		<div class="toolbarbottom">
			<div class="savebt button2" onclick="COLLAGETOOL.savebt_onclick(event);">
				<span>Speichern</span>
			</div>
			
			<div class="openhalloffameformbt button2" onclick="COLLAGETOOL.openHallOfFameForm();">
				<span>Veröffentlichen</span>
			</div>
		</div>
		<div class="stagewrapper">
			<div class="stage" touch-able="move scale mouseoverwheelscale momentum keepvisible" min-scale="0.1" max-scale="1">

			</div>
		</div>
	</div>
	
	<div class="library">
		<div class="librarytopbar">
			<div class="desctext">
				Wähle ein Collage-Element
			</div>
			<div class="closebt" onclick="COLLAGETOOL.closeLibrary();">
				<?php echo $BLUEPRINTS['rSVGIcon']('icon_close'); ?>
			</div>
		</div>
		<div class="libraryscrollwrapper" custom-scrollbar>
			<div class="librarycontent">
				<?php echo $libraryitems_dom; ?>
			</div>
		</div>
		
	</div>
	<div class="overlay halloffameformoverlay">
		<?php echo $halloffameform_dom; ?>
	</div>
</div>