<?php 
$COMPONENTS['GRIDMAKER']=[];
$DOMSTR_TITLE.='Grid Maker';
$DOMSTR_BODY_ATTRIBUTES.=' is-tool';
$BP=$BLUEPRINTS;
$menubar=$BLUEPRINTS['rCreativeToolMenuBar'](['title'=>'Gridmaker', 'icon'=>'icon-gridmaker', 'default-closeurl'=>'artist-name']);


// LOAD GRID LIBARY
$libraryitems_dom='';
$svgurls=glob('data/media/gridmaker/*.svg');
foreach($svgurls as $url){
	$filename=basename($url, ".svg");
	$firstchar=substr($filename, 0, 1);
	if($firstchar!=='_'){ // exclude _
		$libraryitems_dom.='<div class="libraryitem" onclick="GRIDMAKER.libraryitem_onclick(event);">
							   <div class="media" view-mode="cover">
									'.file_get_contents($url).'
								</div>
							</div>';		
	}
}

// SAVE TO HALL OF FAME
$COMPONENTS['GRIDMAKER']['saveToHallOfFame']=function($parobj){
	global $BLUEPRINTS;
	if(strval($parobj['infoobj']['einwilligung'])!=='true'){
		return '<script>
					document.getElementById("halloffameformresponsebox").innerHTML="Du musst die Einwilligung für die Veröffentlichung bestätigen.";
					document.getElementsByClassName("gridmaker")[0].removeAttribute("is-sending-data");
				</script>';
	}
	$id=rID();
	$path='data/halloffame/'.$id;
	$imgfilepath=$path.'stage.jpg';
	$infoobj=json2obj(obj2json($parobj['infoobj']));
	$infoobj['id']=$id;
	$infoobj['time']=time();
	saveJSON($path.'/info.json', obj2json($infoobj));
	$data=str_replace(' ','+',$parobj['imgdataurl']);
	$data=substr($data,strpos($data, ',')+1);
	$data=base64_decode($data);
	$file=fopen($imgfilepath, 'w');
	fwrite($file, $data);
	fclose($file);
	$script='<script>GRIDMAKER.closeHallOfFameForm();</script>';
	$contentdom='<h1>Sehr schön!</h1>
							<p>
								Dein Rasterwerk <i>'.$infoobj['artworktitle'].'</i> wurde erfolgreich zur Veröffentlichung in der <a href="hall-of-fame" target="_self">Hall of Fame</a> eingereicht. Es kann bis zu 3 Werkstage dauern bis dein Werk überprüft und veröffentlicht wird. Tipp: Mit "Speichern" kannst du dein Werk jetzt schon downloaden und mit deinen Freunden teilen.<br>
							</p>
							<div class="button2" onclick="REMOVE(this.closest(\'.overlay\'));">
								<span>Alles klar</span>
							</div> ';
	
	return $BLUEPRINTS['rOverlayBubbleBox']($contentdom).$script;
};

$halloffameform_dom=$BLUEPRINTS['HALLOFFAMEFORM']['rHallOfFameForm']('GRIDMAKER', 'mein Rasterwerk');

// stage bgimg
$bgimgsrc='data/media/bubblemaker/bubblemaker_stage.jpg';
$wh=getimagesize($bgimgsrc);

?>
<?php echo $menubar;  ?>
<div class="gridmaker">
	<div class="blurlayer0">
		<div class="toolbartop">
			<div class="toolmodeinfo" show-on-mode="placegrids" onclick="this.style.display='none'">
				<span>Schritt 1/3: Linienraster hinzufügen, positionieren (verschieben, vergößern und drehen) und kombinieren.</span>
			</div>
			<div class="addgridelbutton button2" onclick="GRIDMAKER.openLibrary();" >
				<span>+ Linienraster hinzufügen</span>
			</div>
			<div class="freezegridelbutton button2" onclick="GRIDMAKER.freezegridelbutton_onclick(event);">
				<span>nächster Schritt: Linien löschen</span>
			</div>
			<div class="toolmodeinfo" show-on-mode="delete" onclick="this.style.display='none'">
				<span>Schritt 2/3: Klicke auf eine Linie um sie zu löschen.</span>
			</div>
			
			<div class="beginfillbutton button2" onclick="GRIDMAKER.beginfillbutton_onclick(event);" title="Wenn du keine Linien mehr löschen möchtest, kannst du mit dem Farbfüllen beginnen.">
				<span>nächster Schritt: Mit Farben füllen</span>
			</div>
			<div class="toolmodeinfo" show-on-mode="fill" onclick="this.style.display='none'">
				<span>Schritt 3/3: Wähle eine Farbe und klicke auf eine Rasterfläche um sie zu füllen.</span>
			</div>
			<div class="colorpalette">
				<input id="palettecolor1" type="color" value="#e83f14" oninput="GRIDMAKER.palettecolor_oninput(event);" onclick="GRIDMAKER.palettecolor_onclick(event);" is-active>
				<input id="palettecolor2" type="color" value="#27afc9" oninput="GRIDMAKER.palettecolor_oninput(event);" onclick="GRIDMAKER.palettecolor_onclick(event);">
				<input id="palettecolor3" type="color" value="#f69c0a" oninput="GRIDMAKER.palettecolor_oninput(event);" onclick="GRIDMAKER.palettecolor_onclick(event);">
			</div>
		</div>
		<div class="toolbarbottom">
			<div class="savebt button2" onclick="GRIDMAKER.savebt_onclick(event);">
				<span>Speichern</span>
			</div>
			
			<div class="openhalloffameformbt button2" onclick="GRIDMAKER.openHallOfFameForm();">
				<span>Veröffentlichen</span>
			</div>
		</div>
		<div class="stagewrapper">
			<div class="stage" touch-able="move scale mouseoverwheelscale momentum keepvisible setstyletransformvars" min-scale="0.05" max-scale="12" style="--palettecolor1:#ff0000;">
				<div class="grids_layer"></div>
				<div class="broken_layer" onclick="GRIDMAKER.broken_layer_onclick(event);">
					<svg class="brokengrid" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 2880 2880" width="2880" height="2880"></svg>
				</div>
				<div class="fills_layer" onclick="GRIDMAKER.fills_layer_onclick(event);">
					<svg class="fills" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 2880 2880" width="2880" height="2880">
						<style>
                           .fills_polygongroup polygon {
                                stroke: white;
                                stroke-width: 32px;
                                stroke-linejoin: miter;
                                stroke-miterlimit: 2;
                            }
						</style>
						<g class="fills_polygongroup"></g>
					</svg>
				</div>
				<div class="ui_layer"></div>
			</div>
		</div>
	</div>
	<div class="library">
		<div class="librarytopbar">
			<div class="desctext">
				Wähle ein Raster
			</div>
			<div class="closebt" onclick="GRIDMAKER.closeLibrary();">
				<?php echo $BLUEPRINTS['rSVGIcon']('icon_close'); ?>
			</div>
		</div>
		<div class="libraryscrollwrapper" custom-scrollbar>
			<div class="librarycontent">
				<?php echo $libraryitems_dom; ?>
			</div>
		</div>
		
	</div>
	<div class="overlay halloffameformoverlay">
		<?php echo $halloffameform_dom; ?>
	</div>
</div>