// JavaScript Document
let HAIKUWRITER={};
(function(){
	document.addEventListener("DOMContentLoaded", INIT);
	function INIT(){
		const canvas=document.createElement('CANVAS');
		const context=canvas.getContext('2d');
		const haikuwriter=document.getElementsByClassName('haikuwriter')[0];
		const halloffameformbox=document.getElementsByClassName('halloffameformbox')[0];
		const haikubox=document.getElementsByClassName('haikubox')[0];
		const heikuwrapper=document.getElementsByClassName('heikuwrapper')[0];
		const heikutransformer=document.getElementsByClassName('heikutransformer')[0];
		const haikuimg=document.getElementsByClassName('haikuimg')[0];
		let stageToCanvas_firsttime=true;
		let svg_haiku=null;
		const haikuimgtitle='';
		let heikusubline;
		
		HAIKUWRITER.INIT=function(){
			halloffameformbox.getElementsByClassName('canvaspreview')[0].appendChild(canvas);
			HAIKUWRITER.initHaiku();
			RESIZE();
			LAYOUT.RESIZE_FUNCS.push(RESIZE);
		}
		function RESIZE(){
			if(svg_haiku!==null){
				const rect=heikuwrapper.getBoundingClientRect();
				const scx=rect.width/2880;
				console.log(rect, 'scx', scx);
				heikutransformer.style.transform='scale('+scx+','+scx+')';
			}
		}
		HAIKUWRITER.initHaiku=function(){
			let svgstr=`<svg class="svg_haiku" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 2880 2880" width="2880" height="2880">
							<def>
								<style>
									`+window.EMBED_FONTFACE_EBGARAMOND+`
									svg.svg_haiku p{
										margin: 0 !important;
										padding: 0 !important;
									}
									svg.svg_haiku .haikuinputdiv,
									svg.svg_haiku .heikusubline{
										font-family: 'EB Garamond', cursive !important;
										font-weight: 400;
										font-size: 160px;
										line-height: 310px;
										height: 310px;
										text-align: center;
										border: 0;
										outline: 0;
										background: none;
										position: absolute;
									}
									svg.svg_haiku .haikuinputdiv{
                                        position: absolute;
                                        width: 2624px;
                                        left: 128px;
                                        white-space: nowrap;
									}
									svg.svg_haiku .haikuinputdiv br{
                                      	display: none;
									}
									svg.svg_haiku .haikuinputdiv *{
                                      	display: inline;
									}
									svg.svg_haiku .heikusubline{
										top: 1900px;
										font-size: 90px;
										line-height: 100px;
										height: 100px;
										text-align: center;
										width: 1880px;
										left: 500px;
										right: 500px;
									}
									svg.svg_haiku g{
										position: absolute;
										top:0;
										left:0;
										width:2880px;
										height:2880px;
									}
									svg.svg_haiku .haikuinputdiv1 {
										top: 640px;
									}
									svg.svg_haiku .haikuinputdiv2 {
										top: 970px;
									}
									svg.svg_haiku .haikuinputdiv3 {
										top: 1300px;
									}
								</style>
							</def>
							<g>
								<foreignObject x="0" y="0" width="100%" height="100%" class="textcontainer" style="position:absolute; top:0; left:0; width: 100%; height: 100%;"> 
									<div class="heikuinputs">
										<div contenteditable="true" class="haikuinputdiv haikuinputdiv1" placeholder="Start' mit fünf Sil-ben" /></div>
										<div contenteditable="true" class="haikuinputdiv haikuinputdiv2" placeholder="Wei-ter mit sie-ben Sil-ben" /></div>
										<div contenteditable="true" class="haikuinputdiv haikuinputdiv3" placeholder="En-de fünf sil-big" /></div>
									</div>
									<div class="heikusubline"></div>
								</foreignObject>
							</g>
							<g class="panelframe">
								<rect x="0" y="0" width="2880" height="2880"  fill="none" stroke="#000" stroke-miterlimit="10" stroke-width="18"/>
							</g>
						</svg>`;
			svg_haiku=asEl(svgstr);
			heikutransformer.appendChild(svg_haiku);
			heikusubline=heikuwrapper.getElementsByClassName('heikusubline')[0];
		}
		HAIKUWRITER.choosethumb_click=function(e){
			haikuwriter.setAttribute('main-mode', 'write');
			heikusubline.innerHTML='Haiku für '+e.currentTarget.querySelectorAll('.thumbtext')[0].innerHTML.split('<i>').join('').split('</i>').join('');
			haikuimg.src=e.currentTarget.querySelectorAll('.thumbimg img')[0].src;
		}
		
		HAIKUWRITER.openHallOfFameForm=function(){
			HAIKUWRITER.stageToCanvas(
				function(){
					haikuwriter.setAttribute('halloffameform-is-open', '');
				}
			);
		}
		HAIKUWRITER.closeHallOfFameForm=function(){
			BLUEPRINTS['resetInputGroup'](document.querySelectorAll('*[inputgroup-name="halloffameform"]')[0]);
			haikuwriter.removeAttribute('halloffameform-is-open');
			haikuwriter.removeAttribute('is-sending-data');
		}
		
		HAIKUWRITER.savebt_onclick=function(event){
			HAIKUWRITER.stageToCanvas(function(){
				const filename='haiku-studio-digital';
				if(window.navigator.msSaveBlob){
					window.navigator.msSaveBlob(canvas.msToBlob, filename+'.png');
				}else{
					const a=document.createElement('A');
					document.body.appendChild(a);
					a.href=canvas.toDataURL('image/jpeg');
					a.download=filename+'.jpg';
					a.click();
					a.parentElement.removeChild(a);
				}
			});
		}
		HAIKUWRITER.plublishtohalloffamebt_onclick=function(e){
			let groupel=e.currentTarget.closest('*[inputgroup-name="halloffameform"]');
			if(groupel!==null){
				const groupobj=BLUEPRINTS['inputGroupToObj'](groupel);
				const inputs=groupobj['inputs'];
				console.log(groupobj);
				let callobj={};
				let parobj={};
				haikuwriter.setAttribute('is-sending-data', '');
				parobj['imgdataurl']=canvas.toDataURL('image/jpeg');
				parobj['infoobj']={};
				parobj['infoobj']['toolslug']='haikuwriter';
				parobj['infoobj']['username']=inputs['username']['value'];
				parobj['infoobj']['artworktitle']='Haiku';
				parobj['infoobj']['city']=inputs['city']['value'];
				parobj['infoobj']['einwilligung']=inputs['einwilligung']['value'];
				callobj['api-func-component']='HAIKUWRITER';
				callobj['api-func-name']='saveToHallOfFame';
				callobj['api-target-id']='body';
				callobj['api-insert-cmd']='beforeend';
				callobj['api-func-parobj']=parobj;
				API_CALL([callobj]);
			}
			
			
		}
		
		HAIKUWRITER.stageToCanvas=function(oncompleted_func){
			console.log('BUBBLEMAKER.stageToCanvas');
			const w=2880;
			const h=2880;
			
			canvas.width=w;
			canvas.height=h; 
			context.clearRect(0, 0, canvas.width, canvas.height);
			context.fillStyle='#ffffff';
			context.fillRect(0, 0, canvas.width, canvas.height);
			const svg=document.querySelectorAll('svg.svg_haiku')[0];
            const img=new Image();
            const cleansvg=asEl(svg.outerHTML);
            img.onload=function() {
				context.drawImage(img, 0, 0);
                if(stageToCanvas_firsttime===true){
					setTimeout(HAIKUWRITER.stageToCanvas, 1000/10, oncompleted_func);
					stageToCanvas_firsttime=false;
				}else{
					oncompleted_func();
				}
                //URL.revokeObjectURL(img.src);
            }
            let xmlstr='';
            try {
                xmlstr=new XMLSerializer().serializeToString(cleansvg);
            }catch(e){
                console.log(e);
            }
            img.src='data:image/svg+xml;base64,'+btoa(unescape(encodeURIComponent(xmlstr)));


        }
		
		HAIKUWRITER.INIT();
	};
	
	
})();
