// WEBCAM
function WEBCAM(facingmode='user', width=720, height=720, onChangeSuccess=null){
	const _this=this;
	this.stream=null;
	this.video=document.createElement('video');
	this.video.setAttribute('autoplay', 'true');
	this.video.setAttribute('playsinline', 'true');
	this.video.setAttribute('muted', 'true');
	this.onGetWebcamSize=null;
	this.img=new Image();
	this.canvas=document.createElement("CANVAS");
	this.ctx=this.canvas.getContext("2d");
	this.isready=true;
	document.body.appendChild(this.video);
	this.video.style.opacity=0;
	this.video.style.pointerEvents='none';
	this.updateIMG=function(){
		_this.canvas.width=_this.width;
		_this.canvas.height=_this.height;
		_this.ctx.drawImage(_this.video, 0, 0, _this.width, _this.height);
		_this.img.src=_this.canvas.toDataURL();
	};
	this.changeSrc=function(facingmode='toggle', width=720, height=720, onChangeSuccess=null){
		console.log('changeSrc', this);
		this.onChangeSuccess=onChangeSuccess;
		this.width=width;
		this.height=height;
		this.isready=false;
		// toggle
		if(facingmode==='toggle'){
			if(this.facingmode==='user'){
				this.facingmode='environment';
			}else{
				this.facingmode='user';
			}
		}
		// set
		let _this=this;
		navigator.mediaDevices.getUserMedia({video:{width:this.width, height:this.height, facingMode:this.facingmode}})
			.then(function(stream){
				_this.stream=stream;
				_this.video.srcObject=_this.stream;
				_this.isready=true;
				if(_this.onChangeSuccess!==null){
					_this.onChangeSuccess(_this);
				}
					_this.video.addEventListener('playing', _this.getVideoSize, false);
					_this.width=_this.video.videoWidth;
					_this.height=_this.video.videHeight;
					console.log('WEBCAM.changedSrc', _this);
					
			})
			.catch(function (error) {
				console.log("Something went wrong!", error, this);
			});
	}
	this.changeSrc(facingmode, width, height, onChangeSuccess);
	this.getVideoSize=function() {
		_this.width=_this.video.videoWidth;
		_this.height=_this.video.videoHeight;
		if(_this.onGetWebcamSize!==null){
			_this.onGetWebcamSize(_this);
		}
		_this.video.removeEventListener('playing', _this.getVideoSize, false);
	};
}