// JavaScript Document
window.STOPMOTIONTOOL={};
(function(){
	document.addEventListener("DOMContentLoaded", INIT);
	function INIT(){
		
		const canvas=document.createElement('CANVAS');
		const context=canvas.getContext('2d');
		const stopmotiontool=document.getElementsByClassName('stopmotiontool')[0];
		const viewport=document.getElementsByClassName('viewport')[0];
		const viewport_canvas=document.getElementsByClassName('viewport_canvas')[0];
		const viewport_canvas_prev=document.getElementsByClassName('viewport_canvas_prev')[0];
		const viewport_webcamcanvas=document.getElementsByClassName('viewport_webcamcanvas')[0];
		const viewport_webcamcontext=viewport_webcamcanvas.getContext('2d');
		const stage=stopmotiontool.getElementsByClassName('stage')[0];
		const blurlayer0=document.getElementsByClassName('blurlayer0')[0];
		const halloffameformbox=stopmotiontool.getElementsByClassName('halloffameformbox')[0];
		const framethumbnails=document.getElementsByClassName('framethumbnails')[0];
		const framethumbs=document.getElementsByClassName('framethumb');
		const framethumb_canvases=document.getElementsByClassName('framethumb_canvas');
		const gifsperre=document.getElementsByClassName('gifsperre')[0];
		const previewgif=document.createElement('img');
		const webcam=new WEBCAM();
		let current_frameindex=0;
		let current_framethumb=null;
		let current_framethumb_canvas=null;
		let gif;
		let isplaying=false;
		let publish_gif_blob;
		let publish_gif_objecturl;
		
		// INIT 
		STOPMOTIONTOOL.INIT=function(){
			setCurrentFrame(0);
			webcam_tick();
			playpauseTick();
			previewgif.classList.add('previewgif');
			document.getElementsByClassName('canvaspreview')[0].appendChild(previewgif);
		}
		// TICKER
		function webcam_tick(){
			if(webcam.isready && stopmotiontool.getAttribute('webcam-mode')==='live'){
				let minwh=Math.min(webcam.width, webcam.height);
				viewport_webcamcontext.drawImage(webcam.video, (viewport_webcamcanvas.width-minwh)/2, (viewport_webcamcanvas.height-minwh)/2, minwh, minwh, 0, 0, viewport_webcamcanvas.width, viewport_webcamcanvas.height);
			}
			setTimeout(webcam_tick, 1000/30)
		}
		function playpauseTick(){
			if(stopmotiontool.hasAttribute('is-playing')){
				stopmotiontool.setAttribute('webcam-mode', '');
				if(current_frameindex<framethumbs.length-1){
					current_frameindex++;
				}else{
					current_frameindex=0;
				}
				setCurrentFrame(current_frameindex);
				while(current_framethumb_canvas.hasAttribute('has-picture')===false && current_frameindex<framethumbs.length-1){
					current_frameindex++;
					setCurrentFrame(current_frameindex);
				}
			}
			setTimeout(playpauseTick, 1000/8);
		}
		
		// INLINE LISTENERS 
		STOPMOTIONTOOL.takePicture=function(){
			stopmotiontool.setAttribute('webcam-mode', '');
			current_framethumb_canvas.getContext('2d').drawImage(viewport_webcamcanvas, 0, 0, current_framethumb_canvas.width, current_framethumb_canvas.height);
			current_framethumb_canvas.setAttribute('has-picture', '');
			if(current_frameindex<framethumbs.length-1){
			   	current_frameindex++;
				setCurrentFrame(current_frameindex);
				stopmotiontool.setAttribute('webcam-mode', 'live');
			}
			
		}
		STOPMOTIONTOOL.removePicture=function(){
			console.log('STOPMOTIONTOOL.removePicture');
			const thumbcanvas=current_framethumb_canvas.getContext('2d')
			thumbcanvas.clearRect(0, 0, current_framethumb_canvas.width, current_framethumb_canvas.height);
			current_framethumb_canvas.removeAttribute('has-picture');
			setCurrentFrame(current_frameindex);
		}
		
		
		STOPMOTIONTOOL.tooglePlayPause=function(){
			if(stopmotiontool.hasAttribute('is-playing')){
				stopmotiontool.removeAttribute('is-playing');
			}else{
				stopmotiontool.setAttribute('is-playing', '');	
			}
		}
		STOPMOTIONTOOL.toggleWebcamSrc=function(){
			webcam.changeSrc();
		}
		STOPMOTIONTOOL.toggleLive=function(){
			if(stopmotiontool.getAttribute('webcam-mode')!=='live'){
			   	stopmotiontool.setAttribute('webcam-mode', 'live');
			}else{
				stopmotiontool.setAttribute('webcam-mode', '');
			}
			setCurrentFrame(current_frameindex);
		}
		STOPMOTIONTOOL.openHallOfFameForm=function(){
			STOPMOTIONTOOL.viewportToGIF(
				function(_blob){
					publish_gif_blob=_blob;
					publish_gif_objecturl=URL.createObjectURL(_blob);
					previewgif.src=URL.createObjectURL(_blob);
					stopmotiontool.setAttribute('halloffameform-is-open', '');
				}
			);
			
		}
		STOPMOTIONTOOL.closeHallOfFameForm=function(){
			BLUEPRINTS['resetInputGroup'](document.querySelectorAll('*[inputgroup-name="halloffameform"]')[0]);
			stopmotiontool.removeAttribute('halloffameform-is-open');
			stopmotiontool.removeAttribute('is-sending-data');
		}
	
		function setCurrentFrame(index){
			console.log('setCurrentFrame: index: ', index)
			current_frameindex=parseInt(index);
			for(const framethumb of framethumbs){
				framethumb.removeAttribute('is-current');
			}
			current_framethumb=document.querySelectorAll('.framethumb[frame-index="'+current_frameindex+'"]')[0];
			current_framethumb_canvas=current_framethumb.querySelectorAll('.framethumb_canvas')[0];
			current_framethumb.setAttribute('is-current', '');
			const thumb_rect=current_framethumb.getBoundingClientRect();
			const parent_rect=framethumbnails.getBoundingClientRect();
			framethumbnails.scrollTo(current_framethumb.offsetLeft-parent_rect.width/2+thumb_rect.width/2, 0);
			
			// update viewport
			if(index>0){
				const prevframethumb_canvas=document.querySelectorAll('.framethumb[frame-index="'+(current_frameindex-1)+'"]')[0].querySelectorAll('.framethumb_canvas')[0]
				viewport_canvas_prev.getContext('2d').drawImage(prevframethumb_canvas, 0, 0, viewport_canvas_prev.width, viewport_canvas_prev.height);
			}else{
				viewport_canvas_prev.getContext('2d').clearRect(0, 0, viewport_canvas_prev.width, viewport_canvas_prev.height);
			}
			viewport_canvas.getContext('2d').drawImage(current_framethumb_canvas, 0, 0, current_framethumb_canvas.width, current_framethumb_canvas.height);
			console.log('viewport_canvas', viewport_canvas);
		}		
		
		STOPMOTIONTOOL.framethumb_onclick=function(e){
			const framethumb=e.currentTarget.closest('.framethumb');
			const framethumb_canvas=framethumb.getElementsByClassName('framethumb_canvas')[0];
			if(framethumb_canvas.hasAttribute('has-picture')){
				stopmotiontool.setAttribute('webcam-mode', '');
			}else{
				stopmotiontool.setAttribute('webcam-mode', 'live');
			}
			stopmotiontool.removeAttribute('is-playing');
			setCurrentFrame(framethumb.getAttribute('frame-index'));
			
		}
		
		STOPMOTIONTOOL.savebt_onclick=function(event){
			STOPMOTIONTOOL.viewportToGIF(
				function(blob){
					const filename='stop-motion';
					const a=document.createElement('A');
					document.body.appendChild(a);
					//a.href=blob.toDataURL('image/gif');
					a.href=URL.createObjectURL(blob);
					a.download=filename+'.gif';
					a.click();
					a.parentElement.removeChild(a);
				}
			);
		}
		
		STOPMOTIONTOOL.plublishtohalloffamebt_onclick=function(e){
			let groupel=e.currentTarget.closest('*[inputgroup-name="halloffameform"]');
			if(groupel!==null){
				// on load
				var filereader=new FileReader();
				filereader.onload=function(e){
					const groupobj=BLUEPRINTS['inputGroupToObj'](groupel);
					const inputs=groupobj['inputs'];
					console.log(groupobj);
					let callobj={};
					let parobj={};
					stopmotiontool.setAttribute('is-sending-data', '');
					parobj['imgdataurl']=e.target.result;
					parobj['infoobj']={};
					parobj['infoobj']['toolslug']='stop-motion-tool';
					parobj['infoobj']['username']=inputs['username']['value'];
					parobj['infoobj']['artworktitle']=inputs['artworktitle']['value'];
					parobj['infoobj']['city']=inputs['city']['value'];
					parobj['infoobj']['einwilligung']=inputs['einwilligung']['value'];
					callobj['api-func-component']='STOPMOTIONTOOL';
					callobj['api-func-name']='saveToHallOfFame';
					callobj['api-target-id']='body';
					callobj['api-insert-cmd']='beforeend';
					callobj['api-func-parobj']=parobj;
					API_CALL([callobj]);
				}
				filereader.readAsDataURL(publish_gif_blob);
			}
		}
		
		STOPMOTIONTOOL.viewportToGIF=function(oncompleted_func){
			console.log('STOPMOTIONTOOL.viewportToGIF');
			gifsperre.style.display='block';
			gif=new GIF({workers:2, quality:10});
			let allempty=true;
			for(const _canvas of framethumb_canvases){
				if(_canvas.hasAttribute('has-picture')){
					gif.addFrame(_canvas, {delay: parseInt(1000/8)});
					allempty=false;
				}
            }
			if(allempty===false){
				 gif.on('finished', function(_blob) {
					oncompleted_func(_blob);
					gifsperre.style.display='none';
				});
				gif.render();
			}else{
				gifsperre.style.display='none';
			}
		}
		STOPMOTIONTOOL.INIT();
	}

})();


