const ci_color=0x009ee0;
const ci_color2=0xff3d93;

(function(){
	COMPONENTS.VRMUSEUM={};
	window.addEventListener('DOMContentLoaded', INIT);
	window.addEventListener('click', click_hand);
	let current_artwork_slug;
	let artworksloaded=0;
	
	// CLICK HANDLER
	function click_hand(e){
		if(e.target.closest('.panviewer')!=null || e.target.closest('.artwork_label')){
			// desktop
			if(CONTROLS.IN_TOUCH_MODE===false){
				openByCURRENT_ARTWORKSLUG();
			// touch device
			}else{
				// label click
				if(e.target.closest('.artwork_label')!=null){
					openByCURRENT_ARTWORKSLUG();
				}else{
					// rayhittest
					const clientraycaster=new THREE.Raycaster();
					const vec=new THREE.Vector2(0, 0);
					vec.x=(e.clientX/COMPONENTS.VRMUSEUM.canvas.width)*2-1;
					vec.y=-(e.clientY/COMPONENTS.VRMUSEUM.canvas.height)*2+1;
					clientraycaster.setFromCamera(vec, COMPONENTS.VRMUSEUM.camera);
					const intersects=clientraycaster.intersectObjects(COMPONENTS.VRMUSEUM.intersection_objs, true);
					if(intersects.length>0){	
						const o=intersects[0].object.parent;
						if(o.hasOwnProperty('ff_infoobj') && o.ff_infoobj!==null && o.ff_infoobj.hasOwnProperty('artworkslug')){
							openByArtworkSlug(o.ff_infoobj.artworkslug);
						}
					}
				}
			}
		}
	}
	
	// OPEN ARTIST PAGE BY SLUG
	function openByArtworkSlug(slug){
		if(slug==='artist1'){
            location.href=HTMLRELPATH+'artist-name';
        }
		if(slug==='artist2'){
            location.href=HTMLRELPATH+'artist-name';
        }
        if(slug==='artist3'){
            location.href=HTMLRELPATH+'artist-name';
        }
		if(slug==='artist4'){
            location.href=HTMLRELPATH+'artist-name';
        }
		if(slug==='artist5'){
            location.href=HTMLRELPATH+'artist-name';
        }
		if(slug==='artist6'){
            location.href=HTMLRELPATH+'artist-name';
        }
		if(slug==='artist7'){
            location.href=HTMLRELPATH+'artist-name';
        }
		if(slug==='artist8'){
            location.href=HTMLRELPATH+'artist-name';
        }
		if(slug==='artist9'){
            location.href=HTMLRELPATH+'artist-name';
        }
		if(slug==='artist10'){
            location.href=HTMLRELPATH+'artist-name';
        }
	}
	function openByCURRENT_ARTWORKSLUG(){
		openByArtworkSlug(COMPONENTS.VRMUSEUM.CURRENT_ARTWORKSLUG);		
	}
	
	// INITIALIZE 3D VRMUSEUM on DOMContentLoaded
	function INIT(){
		panview_origin_x=50;
		panview_origin_y=50;
		panview_origin_x_smoothed=50;
		panview_origin_y_smoothed=50;
		panview_scale=1;
		panview_scale_smoothed=1;
		
		// OBJECT LOADER VARS
		COMPONENTS.VRMUSEUM.objloader_objstoload=0;
		COMPONENTS.VRMUSEUM.objloader_objsloaded=0;
		
		// store and restore scroll possiton
		COMPONENTS.VRMUSEUM.panviewer=document.getElementsByClassName('panviewer')[0];
		
		COMPONENTS.VRMUSEUM.trans_min_line=[[-99999, -7], [-14, -7], [-10, -9.2], [-5, -9.2], [-3, -7], [0.5, -2.8], [19, -2.8], [22, -7], [30, -7], [34, -2], [99999, -2]];
		COMPONENTS.VRMUSEUM.trans_minx=-15;
		COMPONENTS.VRMUSEUM.trans_maxx=39;
		COMPONENTS.VRMUSEUM.trans_miny=1.6;
		COMPONENTS.VRMUSEUM.trans_maxy=1.6;
		COMPONENTS.VRMUSEUM.trans_minz=-6;
		COMPONENTS.VRMUSEUM.trans_maxz=2;
		
		COMPONENTS.VRMUSEUM.trans_x=parseFloat(localStorage.getItem('components-vrmuseum-trans-x'));
		COMPONENTS.VRMUSEUM.trans_y=parseFloat(localStorage.getItem('components-vrmuseum-trans-y'));
		COMPONENTS.VRMUSEUM.trans_z=parseFloat(localStorage.getItem('components-vrmuseum-trans-z'));
		if(isNaN(COMPONENTS.VRMUSEUM.trans_x) || isNaN(COMPONENTS.VRMUSEUM.trans_y) || isNaN(COMPONENTS.VRMUSEUM.trans_z)) {
			COMPONENTS.VRMUSEUM.trans_x=0;
			COMPONENTS.VRMUSEUM.trans_y=0;
			COMPONENTS.VRMUSEUM.trans_z=0;
		}
		COMPONENTS.VRMUSEUM.speed_x=0;
		COMPONENTS.VRMUSEUM.speed_y=0;
		COMPONENTS.VRMUSEUM.speed_z=0;
		
		COMPONENTS.VRMUSEUM.ARTWORKS={};
		COMPONENTS.VRMUSEUM.CURRENT_ARTWORKSLUG='';
		COMPONENTS.VRMUSEUM.ARTWORK_LABELS=document.getElementsByClassName('artwork_label');
		
		COMPONENTS.VRMUSEUM.fdf=1;
		
		COMPONENTS.VRMUSEUM.intersection_objs=[];
		COMPONENTS.VRMUSEUM.wall_intersection_objs=[];
		
		tick();
		checkLOADER();
		
		// INTERCATIONS
        const raycaster=new THREE.Raycaster();
		const mousevec=new THREE.Vector2(0,0);
		let intersects=[];
        let intersects_previous=[];
		let interactives=[];
		
		// SCENE
		const canvas=document.getElementById('vrmuseumwebglcanvas');
        const renderer=new THREE.WebGLRenderer({canvas, alpha: true, antialias: true });
		
        const fov=55;
        const aspect=2;  
        const near=0.1;
        const far=1000;
        const camera=new THREE.PerspectiveCamera(fov, aspect, near, far);
		const camera_interest=new THREE.Vector3(COMPONENTS.VRMUSEUM.trans_x, COMPONENTS.VRMUSEUM.trans_y+1,  -10);
		const camera_interest_delta=new THREE.Vector3(0, 1,  -10);
		const camera_interest_delta_target=new THREE.Vector3(0, 1,  -10);
        camera.position.z=2;
		camera.position.y=-1;
        const scene=new THREE.Scene();
		scene.ff_hoverobj=null;
		const museum=new THREE.Group();
		scene.fog=new THREE.Fog(0x000000, 10, 30);
		COMPONENTS.VRMUSEUM.camera=camera;
		COMPONENTS.VRMUSEUM.canvas=canvas;
		COMPONENTS.VRMUSEUM.scene=scene;
		COMPONENTS.VRMUSEUM.interactives=interactives;
		// measure constants
		const pilar_dist=8.46;
		const pilar_startz=-9.75;
		
		// MATERIALS
		
		// default
		const default_material=new THREE.MeshBasicMaterial({color:0x0000FF, side:THREE.DoubleSide});
		
		// wall
		const wall_texture=new THREE.TextureLoader().load( 'data/media/wall_pattern.png' );
		wall_texture.wrapS=THREE.RepeatWrapping;
		wall_texture.wrapT=THREE.RepeatWrapping;
		wall_texture.repeat.set(50, 10);
		const wall_material=new THREE.MeshBasicMaterial({color:ci_color, side:THREE.DoubleSide});
		const wall_texture_material=new THREE.MeshBasicMaterial({ map: wall_texture, side: THREE.DoubleSide });
		const wall_edges_material=new THREE.LineBasicMaterial({ color: 0x000000, linewidth: 1 });
		
		// invisible
		const invisible_material=new THREE.MeshBasicMaterial({ color:0x000000, side:THREE.DoubleSide, transparent:true, opacity:0 });
		
		// artwork
		const artwork_material=new THREE.MeshBasicMaterial({ color:ci_color2, side:THREE.DoubleSide , depthWrite:true });
		const artwork_wireframe_material=new THREE.LineBasicMaterial({ color: 0x000000, linewidth: 1, depthWrite:true, depthTest:true, side: THREE.DoubleSide });
		
		// black
		const black_material=new THREE.MeshBasicMaterial({ color:0x000000, side:THREE.DoubleSide});
		const black_wireframe_material=new THREE.LineBasicMaterial({ color: 0x000000, linewidth: 1 });
		
		// white
		const white_material=new THREE.MeshBasicMaterial({color:0xffffff, side:THREE.DoubleSide});
		const white_wireframe_material=new THREE.LineBasicMaterial({ color: 0xffffff, linewidth: 1 });
		
		// pilar
		const pilar_material = new THREE.LineBasicMaterial({ color: ci_color, linewidth: 4 } );
		const pilar_edges_material = new THREE.LineBasicMaterial({ color: 0x000000, linewidth: 4 });
		
		// cicolors
		const cicolor_material=new THREE.MeshBasicMaterial({ color:ci_color, side:THREE.DoubleSide });
		
		// HELPER FUNCTION TO ADD 3D MODELS - exported from https://threejs.org/editor/ as json
		function addObj(objjsonurl, material=null, edges_material=null, wireframe_material=null, x=0, y=0, z=0, addtointeractives=false, infoobj=null){
			COMPONENTS.VRMUSEUM.objloader_objstoload++;
			const loader=new THREE.ObjectLoader();
			const group=new THREE.Group();
			const wireframe_group=new THREE.Group();
			const edges_group=new THREE.Group();
			group.position.x=x;
			group.position.y=y;
			group.position.z=z;
            loader.load(objjsonurl,
                // loading complete
                function(object) {
					COMPONENTS.VRMUSEUM.objloader_objsloaded++;
					if(material!==null){
						object.ff_material=material.clone();
					}else{
						object.ff_material=default_material;
					}
					if(edges_material!==null){
						object.ff_edges_material=edges_material.clone();
					}else{
						object.ff_edges_material=null;
					}
					if(wireframe_material!==null){
						object.ff_wireframe_material=wireframe_material.clone();
					}else{
						object.ff_wireframe_material=null;
					}
                    object.traverse(function(child){
                        if(child instanceof THREE.Mesh) {
							// excludeboundingobj
							if(child.name!=='boundingobject'){
								child.material=object.ff_material;
								if(edges_material!==null){
									object.ff_edges=new THREE.LineSegments(new THREE.EdgesGeometry(child.geometry), object.ff_edges_material);
									edges_group.add(object.ff_edges);
								}
								if(wireframe_material!==null){
									object.ff_wireframe=new THREE.LineSegments(new THREE.EdgesGeometry(child.geometry), object.ff_wireframe_material);
									wireframe_group.add(object.ff_wireframe);
								}
							}
						}
                    } );
					if(addtointeractives){
						interactives.push(object);
					}
					object.ff_boundingbox=new THREE.Box3().setFromObject(object);
					// bounding of children objects for hittest without gaps
					object.ff_boundingboxes=[];
					object.ff_boundingmesh=null;
					object.traverse(function(child){
							if(child instanceof THREE.Mesh){
								if(child.name==='boundingobject'){
									child.material=invisible_material;
									object.ff_boundingmesh=child;
								}else{
									object.ff_boundingboxes.push(new THREE.Box3().setFromObject(child));
								}
								
							}
					});
					
					// give extra height to bounding box to get a better hoverexpereience on touch devices (centered raycaster)
					object.ff_boundingbox_touch=object.ff_boundingbox.clone();
					object.ff_boundingbox_touch.min.y-=5;
					object.ff_boundingbox_touch.max.y+=5;
					//
					object.ff_center=object.ff_boundingbox.getCenter(new THREE.Vector3());
					object.ff_group=group;
					object.ff_edges_group=edges_group;
					object.ff_wireframe_group=wireframe_group;
					object.ff_infoobj=infoobj;
					if(infoobj!==null && infoobj.hasOwnProperty('artworkslug')){
						COMPONENTS.VRMUSEUM.ARTWORKS[infoobj.artworkslug]=object;
					}
					if(infoobj!==null && infoobj.hasOwnProperty('wallhitterslug')){
						COMPONENTS.VRMUSEUM.wall_intersection_objs.push(object);
					}
				
					COMPONENTS.VRMUSEUM.intersection_objs.push(object);
					group.add(object);
					group.add(wireframe_group);
					group.add(edges_group);
                    scene.add(group);
				
					// all objs loaded
					if(COMPONENTS.VRMUSEUM.objloader_objsloaded>=COMPONENTS.VRMUSEUM.objloader_objstoload){
					   document.body.setAttribute('all-objs-loaded', '');
					}
                },
                // loading rogress
                function(xhr) {
                    console.log((xhr.loaded/xhr.total * 100)+'% loaded' );
                },
                // loading error
                function(error) {
                    console.log( 'An error happened' );
                }
            );
			
		}
		// HELPER FUNCTION: ADD WALL 
		function addWallObj(objjsonurl, x=0, y=0, z=0, addtointeractives=false, infoobj=null){
			addObj(objjsonurl, wall_material, wall_edges_material, null, x, y, z, addtointeractives, infoobj);
		}
		// HELPER FUNCTION: ARTWORKS
		function addArtworkObj(objjsonurl, x=0, y=0, z=0, slug='', addtointeractives=true){
			return addObj(objjsonurl, artwork_material, artwork_wireframe_material, artwork_wireframe_material, x, y, z, addtointeractives, {artworkslug:slug});
		}
		// HELPER FUNCTION: BLACK
		function addBlackObj(objjsonurl, x=0, y=0, z=0, addtointeractives=false, infoobj=null){
			addObj(objjsonurl, black_material, null, null, x, y, z, addtointeractives, infoobj);
		}
		// HELPER FUNCTION: BLACK WIREFRAME
		function addBlackWireframeObj(objjsonurl, x=0, y=0, z=0){
			addObj(objjsonurl, black_material, null, white_wireframe_material, x, y, z);
		}
		
		// BUILD SCENE /////////////
		
		// ADD WALLS 
		addWallObj('data/models/walls.json', 0, 0, 0, false, {wallhitterslug: 'walls'});
		addWallObj('data/models/stairs.json');
		addWallObj('data/models/curtain.json', 0, 0, 0, false, {wallhitterslug: 'walls'});
		addWallObj('data/models/benchlong.json');
		
		addBlackObj('data/models/blacker.json', 0, 0, 0, false, {wallhitterslug: 'walls'});
		addBlackWireframeObj('data/models/roof.json', 0, -0.6, 0);
		addWallObj('data/models/trailling.json');
		addBlackObj('data/models/cinemaroom.json', 0, 0, 0, false, {wallhitterslug: 'walls'});
		
		// ADD ARTWORKS
		addArtworkObj('data/models/artwork1.json',0,0,0,'artist1');
		addWallObj('data/models/artwork1_pedestal.json',0,0,0);
		
		addArtworkObj('data/models/artwork2.json',0,0,0,'artist2');
		
		addArtworkObj('data/models/artwork3.json',0,0,0,'artist3');
		
		addArtworkObj('data/models/artwork4.json',0,0,0,'artist4');
		
		addArtworkObj('data/models/artwork5.json',0,0,0,'artist5');
		
		addArtworkObj('data/models/artwork6.json',0,0,0,'artist6');
		addWallObj('data/models/artwork6_pedestal.json');
		
		addArtworkObj('data/models/artwork7.json',0,0,0,'artist7');
		
		addArtworkObj('data/models/artwork8.json',0,0,0,'artist8');
		
		addArtworkObj('data/models/artwork9.json',0,0,0,'artist9');
		
		addArtworkObj('data/models/artwork10.json',0,0,0,'artist10');
		
		
		// GROUND
		const ground_texture=new THREE.TextureLoader().load('data/media/parkett_pattern7.png');
		ground_texture.wrapS=THREE.RepeatWrapping;
		ground_texture.wrapT=THREE.RepeatWrapping;
		//ground_texture.minFilter=THREE.LinearFilter;
		const ground_material=new THREE.MeshBasicMaterial({ map:ground_texture, side:THREE.DoubleSide, color:0xffffff, transparent: false});

		
		function addGroundObj(objjsonurl, x=0, y=0, z=0){
			const loader=new THREE.ObjectLoader();
			const ground= new THREE.Group();
			ground.position.x=x;
			ground.position.y=y;
			ground.position.z=z;
            loader.load(objjsonurl,
                // loading complete
                function(object) {
					const box=new THREE.Box3().setFromObject(object);
					const size=box.getSize();
					ground_texture.repeat.set(size.x, size.z);
				
                    object.traverse(function(child) {
                        if(child instanceof THREE.Mesh) {
                            child.material=ground_material;
                        }
                    } );
                  
                    ground.add(object);
                    museum.add(ground);
                    console.log('ground ADDED!');
                },
                // loading rogress
                function(xhr) {
                    console.log((xhr.loaded/xhr.total * 100)+'% loaded' );
                },
                // loading error
                function(error) {
                    console.log( 'An error happened' );
                }
            );
		}
		addBlackObj('data/models/floor.json');
		
		
				
		// GROUND GRID
		const ground_grid=new THREE.GridHelper(100, 100);
		ground_grid.position.y=-0.001;
		scene.add(ground_grid);
		
		const ground_grid2=new THREE.GridHelper(100, 25);
		ground_grid2.position.z=-5.9506-100/2;
		ground_grid2.position.x=4.6325+50;
		ground_grid2.position.y=12;
		scene.add(ground_grid2);
		
		
		// PILARS
		function addPilar(x=0, z=0){
			const pilar=new THREE.Group();
			const pilar_geometry = new THREE.CylinderGeometry( 0.2, 0.2, 50, 16);
			const pilar_edges_geometry=new THREE.EdgesGeometry(pilar_geometry);
			const pilar_edges=new THREE.LineSegments(pilar_edges_geometry, pilar_edges_material);
			const pilar_mesh=new THREE.Mesh( pilar_geometry, pilar_material );
			pilar_mesh.position.y=0;
			pilar_edges.position.y=0;
			pilar.position.x=x;
			pilar.position.z=z;
			pilar.add(pilar_mesh);
			pilar.add(pilar_edges);
			scene.add(pilar);
		}
		addPilar(-20.5, pilar_startz);
		addPilar(-20.5, pilar_startz-pilar_dist);
		addPilar(-20.5+pilar_dist, pilar_startz-pilar_dist);
		addPilar(-20.5+pilar_dist*2, pilar_startz-pilar_dist);
		addPilar(-20.5+pilar_dist*3, pilar_startz-pilar_dist);
		addPilar(40, -4);
		addPilar(45.50,-18.2102);
		
		// LIGHT
        const light_color=0xFFFFFF;
        const light_intensity=1.18;
        const light=new THREE.DirectionalLight(light_color, light_intensity);
        light.position.set(4, 2, 8);
        scene.add(light);
		
		// SCENE
		scene.add(museum);
        renderer.render(scene, camera);
		

        const renderani=createAnimation(60);
        renderani.addOnEnterFrameFunc(render);
        renderani.play();
      
		// RENDER LOOP
        function render(_fdf) { 
			const canvas=renderer.domElement;
			COMPONENTS.VRMUSEUM.fdf=_fdf;
			
			// add speed to position
			COMPONENTS.VRMUSEUM.trans_x+=COMPONENTS.VRMUSEUM.speed_x*_fdf;
			COMPONENTS.VRMUSEUM.trans_y+=COMPONENTS.VRMUSEUM.speed_y*_fdf;
			COMPONENTS.VRMUSEUM.trans_z+=COMPONENTS.VRMUSEUM.speed_z*_fdf;
			
			camera_interest_delta_target.x=0;
			camera_interest_delta_target.y=1;
			camera_interest_delta_target.z=-10;
			
			// bounderies
			let prev_p=null;
			for(const p of COMPONENTS.VRMUSEUM.trans_min_line){
				if(prev_p!==null){
					if(COMPONENTS.VRMUSEUM.trans_x>prev_p[0] && COMPONENTS.VRMUSEUM.trans_x<p[0]){
						const f=1-Math.abs(p[0]-COMPONENTS.VRMUSEUM.trans_x)/Math.abs(p[0]-prev_p[0]);
						const d=p[1]-prev_p[1];
						COMPONENTS.VRMUSEUM.trans_minz=prev_p[1]+(d*f);
					}
				}
				prev_p=p;
			}
		
			let aspectgropx=0;
			let aspectgropy=0;
			if(canvas.clientWidth>canvas.clientHeight){
				aspectgropx=4*-(canvas.clientWidth-canvas.clientHeight)/canvas.clientWidth;
				aspectgropy=0;
			}else {
				aspectgropx=4*(canvas.clientHeight-canvas.clientWidth)/canvas.clientHeight;
				aspectgropy=0;
			}
			
			
			if(COMPONENTS.VRMUSEUM.trans_x<COMPONENTS.VRMUSEUM.trans_minx-aspectgropx){
				COMPONENTS.VRMUSEUM.trans_x=COMPONENTS.VRMUSEUM.trans_minx-aspectgropx;
			}
			if(COMPONENTS.VRMUSEUM.trans_x>COMPONENTS.VRMUSEUM.trans_maxx+aspectgropx){
				COMPONENTS.VRMUSEUM.trans_x=COMPONENTS.VRMUSEUM.trans_maxx+aspectgropx;
			}
			if(COMPONENTS.VRMUSEUM.trans_y<COMPONENTS.VRMUSEUM.trans_miny){
				COMPONENTS.VRMUSEUM.trans_y=COMPONENTS.VRMUSEUM.trans_miny;
			}
			if(COMPONENTS.VRMUSEUM.trans_y>COMPONENTS.VRMUSEUM.trans_maxy){
				COMPONENTS.VRMUSEUM.trans_y=COMPONENTS.VRMUSEUM.trans_maxy;
			}
			if(COMPONENTS.VRMUSEUM.trans_z<COMPONENTS.VRMUSEUM.trans_minz){
				COMPONENTS.VRMUSEUM.trans_z=COMPONENTS.VRMUSEUM.trans_minz;
			}
			if(COMPONENTS.VRMUSEUM.trans_z>COMPONENTS.VRMUSEUM.trans_maxz){
				COMPONENTS.VRMUSEUM.trans_z=COMPONENTS.VRMUSEUM.trans_maxz;
			}
			
			// bounderies interestdelta
			if(camera_interest_delta_target.x>1){
				camera_interest_delta_target.x=1;
			}
			if(camera_interest_delta_target.x<-1){
				camera_interest_delta_target.x=-1;
			}
			if(camera_interest_delta_target.y>1){
				camera_interest_delta_target.y=1;
			}
			if(camera_interest_delta_target.y<-1){
				camera_interest_delta_target.y=-1;
			}
			
			
			// set camera position
			camera.position.x=COMPONENTS.VRMUSEUM.trans_x;
			camera.position.y=COMPONENTS.VRMUSEUM.trans_y;
			camera.position.z=COMPONENTS.VRMUSEUM.trans_z;
			
			camera_interest_delta.x+=(camera_interest_delta_target.x-camera_interest_delta.x)/20;
			camera_interest_delta.y+=(camera_interest_delta_target.y-camera_interest_delta.y)/20;
			camera_interest_delta.z+=(camera_interest_delta_target.z-camera_interest_delta.z)/20;
				
			camera_interest.x=camera.position.x+camera_interest_delta.x;
			camera_interest.y=camera.position.y+camera_interest_delta.y;
			camera_interest.z=camera.position.z+camera_interest_delta.z;
			
			camera.lookAt(camera_interest);
			
			
			// friction
			const friction=0.08;
			COMPONENTS.VRMUSEUM.speed_x=COMPONENTS.VRMUSEUM.speed_x-COMPONENTS.VRMUSEUM.speed_x*friction*_fdf;
			COMPONENTS.VRMUSEUM.speed_y=COMPONENTS.VRMUSEUM.speed_y-COMPONENTS.VRMUSEUM.speed_y*friction*_fdf;
			COMPONENTS.VRMUSEUM.speed_z=COMPONENTS.VRMUSEUM.speed_z-COMPONENTS.VRMUSEUM.speed_z*friction*_fdf;
			
			renderer.render(scene, camera);  
			//  change aspect / resize
            if(resizeRendererToDisplaySize(renderer)){
                camera.aspect=canvas.clientWidth/canvas.clientHeight;
                camera.updateProjectionMatrix();
            }
			
			
            /* INTERACTIONS */
			// setup raycaster
			if(CONTROLS.IN_TOUCH_MODE){
				mousevec.x=0;
				mousevec.y=0;
			}else{
				mousevec.x=(MOUSE.x/canvas.width)*2-1;
            	mousevec.y=-(MOUSE.y/canvas.height)*2+1;
			}
            raycaster.setFromCamera(mousevec, camera);
			
			// nearest
			let nearesthitobj=null;
			let nearesthitdist=99999;
			let dist=nearesthitdist
			
			// check walls hit nearestdist
            const intersects=raycaster.intersectObjects(COMPONENTS.VRMUSEUM.wall_intersection_objs, true);
		    if(intersects.length>0){
				nearesthitdist=intersects[0].distance;
            }
			
			// check hits with interactives
			for(let obj of interactives){
				// touch mode
				if(CONTROLS.IN_TOUCH_MODE){
					const bb=obj.ff_boundingbox_touch;
					if(raycaster.ray.intersectsBox(bb)){
						obj.ff_bbdist2camera=bb.distanceToPoint(camera.position);
						if(obj.ff_bbdist2camera<nearesthitdist){
							nearesthitdist=obj.ff_centerdist2camera;
							nearesthitobj=obj; 
						}
					}
				// desktop
				}else{
					// use boundingmesh
					if(obj.ff_boundingmesh!==null){
						const intersects=raycaster.intersectObject(obj.ff_boundingmesh, true);
						if(intersects.length>0){
							const hitdist=intersects[0].distance;
							if(hitdist<nearesthitdist){
								nearesthitdist=hitdist;
								nearesthitobj=obj; 
							}
						}
					// use boundingboxes
					}else{
						const bbs=obj.ff_boundingboxes;
						for(const bb of bbs){
							const hitpoint=raycaster.ray.intersectBox(bb);
							if(hitpoint!==null){
								const hitdist=hitpoint.distanceTo(camera.position);
								if(hitdist<nearesthitdist){
									nearesthitdist=hitdist;
									nearesthitobj=obj; 
								}
							}
						}
					}
				}
			}
			// hover states
			let hadnearesthit=false;
			for(let obj of interactives){
				if(obj===nearesthitobj){
					// HOVERED
					if(obj.ff_infoobj!==null){
						hadnearesthit=true;
						if(obj.ff_infoobj.hasOwnProperty('artworkslug')){
							COMPONENTS.VRMUSEUM.CURRENT_ARTWORKSLUG=obj.ff_infoobj.artworkslug;
							document.body.setAttribute('current-artwork', obj.ff_infoobj.artworkslug);
							for(let label of COMPONENTS.VRMUSEUM.ARTWORK_LABELS){
								label.removeAttribute('is-current');
							}
							const artworklabel=document.querySelectorAll('.artwork_label[artwork-slug="'+obj.ff_infoobj.artworkslug+'"]')[0];
							if(artworklabel!=null){
								artworklabel.setAttribute('is-current','');
							}
						}
					}
					
				}else{
					// NOT HOVERED
					// ...
				}
			}
			// NO HOVER AT ALL
			if(hadnearesthit===false){
				for(let label of COMPONENTS.VRMUSEUM.ARTWORK_LABELS){
					label.removeAttribute('is-current');
				}
				COMPONENTS.VRMUSEUM.CURRENT_ARTWORKSLUG='';
				document.body.setAttribute('current-artwork', '');
			}
			
			/* ARTWORK KORRDINATES FOR LABELS */
			if(COMPONENTS.VRMUSEUM.CURRENT_ARTWORKSLUG!==''){
				let vec=COMPONENTS.VRMUSEUM.ARTWORKS[COMPONENTS.VRMUSEUM.CURRENT_ARTWORKSLUG].ff_center.clone();
				vec.project(camera);
				vec.x=(vec.x+1)*canvas.width/2;
				vec.y=-(vec.y-1)*canvas.height/2;
				document.body.style.setProperty('--current-artwork-clientx', parseInt(vec.x)+'px');
				document.body.style.setProperty('--current-artwork-clienty', parseInt(vec.y)+'px');

			}
			
			// save Trans
			COMPONENTS.VRMUSEUM.saveTrans();
			
			// update rendertime_last
			COMPONENTS.VRMUSEUM.rendertime_last=COMPONENTS.VRMUSEUM.rendertime;
        }
        function resizeRendererToDisplaySize(renderer) {
            const canvas=renderer.domElement;
            const width=canvas.clientWidth;
            const height=canvas.clientHeight;
            const needresize=canvas.width!==width || canvas.height!==height;
            if(needresize) {
              	renderer.setSize(width, height, false);
            }
            return needresize;
        }
				
	}
	
	// HELPER FUNCTION: LOADER
	function checkLOADER(){
		if(COMPONENTS.VRMUSEUM.artworks!=null && artworksloaded>=COMPONENTS.VRMUSEUM.artworks.length){
			document.body.setAttribute('artworks-loaded', '');
		}
	}
	COMPONENTS.VRMUSEUM.onArtworkLoaded=function(e){
		artworksloaded++;
		checkLOADER();
	}
	COMPONENTS.VRMUSEUM.onMuseumLoaded=function(e){
		document.body.setAttribute('museum-loaded', '');
	}
	
	// SAVE TRANS TO LOCAL STORAGE
	COMPONENTS.VRMUSEUM.saveTrans=function(){
		localStorage.setItem('components-vrmuseum-trans-x', COMPONENTS.VRMUSEUM.trans_x);
		localStorage.setItem('components-vrmuseum-trans-y', COMPONENTS.VRMUSEUM.trans_y);
		localStorage.setItem('components-vrmuseum-trans-z', COMPONENTS.VRMUSEUM.trans_z);
		COMPONENTS.VRMUSEUM.panviewer.style.setProperty('--vrmuseum-trans-x', COMPONENTS.VRMUSEUM.trans_x);
		COMPONENTS.VRMUSEUM.panviewer.style.setProperty('--vrmuseum-trans-y', COMPONENTS.VRMUSEUM.trans_y);
		COMPONENTS.VRMUSEUM.panviewer.style.setProperty('--vrmuseum-trans-z', COMPONENTS.VRMUSEUM.trans_z);
	}
	
	// KEYBOARD
	KEY_DOWN_HANDS.push(keyDown_hand)
	function keyDown_hand(e){
		const panviewercont=COMPONENTS.VRMUSEUM.panviewercont;
		if(iskey_LEFT()){
			COMPONENTS.VRMUSEUM.speed_x=-0.1;
		}
		if(iskey_RIGHT()){
			COMPONENTS.VRMUSEUM.speed_x=0.1;
		}
		if(iskey_UP()){
			COMPONENTS.VRMUSEUM.speed_z=-0.1;
		}
		if(iskey_DOWN()){
			COMPONENTS.VRMUSEUM.speed_z=0.1;
		}
		return 'prevent';
	}
	
	
	// TICK
	function tick(){
		// edge scroll
		if(CONTROLS.lastinteraction==='mousemove' && !MOUSE.isoutside && MOUSE.overtarget!=null && (MOUSE.overtarget.closest('.panviewer')!=null || MOUSE.overtarget.closest('.artwork_label')!=null)){
			const marginx=window.innerWidth/6;
			const marginy=window.innerHeight/6;
			const maxspeedx=0.2;
			const maxspeedy=0.2;
			let speedx=0;
			let new_y=0;
			let trans, new_x;
			// left
            if(MOUSE.x<marginx){
                speedx=-(1-MOUSE.x/marginx);
			// right
			}else if(MOUSE.x>window.innerWidth-marginx){
				speedx=(MOUSE.x-(window.innerWidth-marginx))/marginx;
			// center
            }else{
			    speedx=0;
			}  
			// top
            if(MOUSE.y<marginy){
                speedy=-(1-MOUSE.y/marginy);
			// bottom
			}else if(MOUSE.y>window.innerHeight-marginy){
				speedy=(MOUSE.y-(window.innerHeight-marginy))/marginy;
			// center
            }else{
			   speedy=0;
			}  
			// move
			if(speedx!==0 || speedy!==0){
				// speed x
				speedx*=speedx*(speedx<0?-1:1);
				speedx*=maxspeedx;
				COMPONENTS.VRMUSEUM.speed_x=speedx;
				// speed y
				speedy*=speedy*(speedy<0?-1:1);
				speedy*=maxspeedy
				COMPONENTS.VRMUSEUM.speed_y=-speedy;
			}
		}
		setTimeout(tick, 1000/60);
	}
	
	
	// ON DRAG
	DRAG_FUNCS.push(museum_onDRAG);
	function museum_onDRAG(){
		//touch control
		if(CONTROLS.lastinteraction==='touchmove'){
			COMPONENTS.VRMUSEUM.speed_x=-(CONTROLS.dragobj.deltax/window.innerWidth)*10*(window.innerWidth/window.innerHeight);
			COMPONENTS.VRMUSEUM.speed_y=0;
			if(CONTROLS.pinchobj!==null){
				COMPONENTS.VRMUSEUM.speed_z=-(CONTROLS.pinchobj.distfactor-1)*5;
			}
		}
	}
	// ON MOUSE WHEEL
	WHEEL_FUNCS.push(museum_onMousewheel);
	function museum_onMousewheel(){
		COMPONENTS.VRMUSEUM.speed_z+=CONTROLS.wheelobj.deltaY/2000;
	}
	
	
	
})();
